// johab.cpp

#include <windows.h>
#include <ctype.h>
#include "msc.h"
#include "johab.h"
#include "codepage.h"
#include "mbctbl.h"
#include "unicode.h"



///////////////////////////////////////////////////////////////////////////////////////
//                                  UNICODE -> JOHAB
///////////////////////////////////////////////////////////////////////////////////////



static const unsigned short UnicodeToJohabTable_0080_00FF [] = {
      0x0080,  0x0081,  0x0082,  0x0083,  0,       0,       0,       0,       // 0x008x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x009x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0xD9AE,  0,       0,       0xD9B4,  0,       0,       0xD967,  // 0x00Ax
      0xD937,  0,       0xDCA3,  0,       0,       0xD939,  0xD9E7,  0,       
      0xD956,  0xD94E,  0xDD99,  0xDD9A,  0xD9A5,  0,       0xD9D2,  0xD934,  // 0x00Bx
      0xD9AC,  0xDD98,  0xDCAC,  0,       0xDCF9,  0xDCF6,  0xDCFA,  0xD9AF,  
      0,       0,       0,       0,       0,       0,       0xDCA1,  0,       // 0x00Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xDCA2,  0,       0,       0,       0,       0,       0,       0xD94F,  // 0x00Dx
      0xDCAA,  0,       0,       0,       0,       0,       0xDCAD,  0xDD3C,  
      0,       0,       0,       0,       0,       0,       0xDD31,  0,       // 0x00Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xDD33,  0,       0,       0,       0,       0,       0,       0xD950,  // 0x00Fx
      0xDD3A,  0,       0,       0,       0,       0,       0xDD3D,  0,       
} ;


static const unsigned short UnicodeToJohabTable_1100_11FF [] = {
      0x8841,  0x8C41,  0x9041,  0x9441,  0x9841,  0x9C41,  0xA041,  0xA441,  // 0x110x
      0xA841,  0xAC41,  0xB041,  0xB441,  0xB841,  0xBC41,  0xC041,  0xC441,  
      0xC841,  0xCC41,  0xD041,  0,       0xDAD5,  0xDAD6,  0,       0,       // 0x111x
      0,       0,       0,       0,       0xDADE,  0xDAE1,  0xDAE2,  0,       
      0xDAE3,  0,       0xDAE4,  0xDAE5,  0,       0,       0,       0xDAE6,  // 0x112x
      0xDAE7,  0,       0,       0xDAE8,  0xDAE9,  0xDAEA,  0xDAEB,  0xDAEC,  
      0,       0,       0xDAED,  0,       0,       0,       0xDAEE,  0,       // 0x113x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0xDAEF,  0,       0,       0,       0,       0xDAF2,  0xDAF3,  0xDAF0,  // 0x114x
      0,       0,       0,       0,       0xDAF1,  0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0xDAF4,  // 0x115x
      0xDAF5,  0xDAF6,  0,       0,       0,       0,       0,       0xDAD4,  
      0,       0x8461,  0x8481,  0x84A1,  0x84C1,  0x84E1,  0x8541,  0x8561,  // 0x116x
      0x8581,  0x85A1,  0x85C1,  0x85E1,  0x8641,  0x8661,  0x8681,  0x86A1,  
      0x86C1,  0x86E1,  0x8741,  0x8761,  0x8781,  0x87A1,  0,       0,       // 0x117x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0xDAF7,  0xDAF8,  0,       0,       // 0x118x
      0xDAF9,  0,       0,       0,       0,       0,       0,       0,       
      0,       0xDAFA,  0xDAFB,  0,       0xDAFC,  0,       0,       0,       // 0x119x
      0,       0,       0,       0,       0,       0,       0xDAFD,  0,       
      0,       0xDAFE,  0,       0,       0,       0,       0,       0,       // 0x11Ax
      0x8442,  0x8443,  0x8444,  0x8445,  0x8446,  0x8447,  0x8448,  0x8449,  
      0x844A,  0x844B,  0x844C,  0x844D,  0x844E,  0x844F,  0x8450,  0x8451,  // 0x11Bx
      0x8453,  0x8454,  0x8455,  0x8456,  0x8457,  0x8458,  0x8459,  0x845A,  
      0x845B,  0x845C,  0x845D,  0,       0,       0,       0,       0xDAD7,  // 0x11Cx
      0xDAD8,  0,       0,       0,       0xDAD9,  0,       0xDADA,  0,       
      0,       0,       0,       0xDADB,  0,       0,       0,       0xDADC,  // 0x11Dx
      0,       0xDADD,  0,       0,       0,       0xDADF,  0,       0xDAE0,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x11Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x11Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;


static const unsigned short UnicodeToJohabTable_3130_316F [] = {
      0,       0x8841,  0x8C41,  0x8444,  0x9041,  0x8446,  0x8447,  0x9441,  // 0x313x
      0x9841,  0x9C41,  0x844A,  0x844B,  0x844C,  0x844D,  0x844E,  0x844F,  
      0x8450,  0xA041,  0xA441,  0xA841,  0x8454,  0xAC41,  0xB041,  0xB441,  // 0x314x
      0xB841,  0xBC41,  0xC041,  0xC441,  0xC841,  0xCC41,  0xD041,  0x8461,  
      0x8481,  0x84A1,  0x84C1,  0x84E1,  0x8541,  0x8561,  0x8581,  0x85A1,  // 0x315x
      0x85C1,  0x85E1,  0x8641,  0x8661,  0x8681,  0x86A1,  0x86C1,  0x86E1,  
      0x8741,  0x8761,  0x8781,  0x87A1,  0xDAD4,  0xDAD5,  0xDAD6,  0xDAD7,  // 0x316x
      0xDAD8,  0xDAD9,  0xDADA,  0xDADB,  0xDADC,  0xDADD,  0xDADE,  0xDADF,  
} ;


static const unsigned short UnicodeToJohabTable_FFA0_FFDF [] = {
      0xDAD4,  0x8841,  0x8C41,  0x8444,  0x9041,  0x8446,  0x8447,  0x9441,  // 0xFFAx
      0x9841,  0x9C41,  0x844A,  0x844B,  0x844C,  0x844D,  0x844E,  0x844F,  
      0x8450,  0xA041,  0xA441,  0xA841,  0x8454,  0xAC41,  0xB041,  0xB441,  // 0xFFBx
      0xB841,  0xBC41,  0xC041,  0xC441,  0xC841,  0xCC41,  0xD041,  0,       
      0,       0,       0x8461,  0x8481,  0x84A1,  0x84C1,  0x84E1,  0x8541,  // 0xFFCx
      0,       0,       0x8561,  0x8581,  0x85A1,  0x85C1,  0x85E1,  0x8641,  
      0,       0,       0x8661,  0x8681,  0x86A1,  0x86C1,  0x86E1,  0x8741,  // 0xFFDx
      0,       0,       0x8761,  0x8781,  0x87A1,  0,       0,       0,       
} ;



int UnicodeToJohab ( int cUnicode ) {


   if ( cUnicode >= 0xAC00 && cUnicode <= 0xD7A3 ) {

      int nInitial = ( ( (unsigned) cUnicode - 0xAC00 ) / 0x24C ) + 2 ;
      int nVowel = ( ( ( (unsigned) cUnicode - 0xAC00 ) % 0x24C ) / 0x1C ) + 3 ;
      int nFinal = ( ( ( (unsigned) cUnicode - 0xAC00 ) % 0x24C ) % 0x1C ) + 1 ;

      if      ( nVowel >= 0x14 ) nVowel += 6 ;
      else if ( nVowel >= 0xE ) nVowel += 4 ;
      else if ( nVowel >= 0x8 ) nVowel += 2 ;

      if ( nFinal >= 0x12 ) nFinal ++ ;

      return 0x8000 + ( nInitial << 10 ) + ( nVowel << 5 ) + nFinal ;
   }


   if ( (unsigned) cUnicode <= 0x0FFF ) {
      if ( (unsigned) cUnicode <= 0x0083 ) return cUnicode ;
      if ( (unsigned) cUnicode <= 0x00FF ) return UnicodeToJohabTable_0080_00FF [ cUnicode - 0x80 ] ;
      if ( cUnicode == 0x0110 ) return 0 ;
   }
   else if ( (unsigned) cUnicode <= 0x32FF ) {
      if ( cUnicode >= 0x1100 && cUnicode <= 0x11FF ) return UnicodeToJohabTable_1100_11FF [ cUnicode - 0x1100 ] ;
      if ( cUnicode >= 0x24B6 && cUnicode <= 0x24CF ) return 0 ;
      if ( cUnicode >= 0x3131 && cUnicode <= 0x3163 ) return UnicodeToJohabTable_3130_316F [ cUnicode - 0x3130 ] ;
      if ( cUnicode >= 0x3192 && cUnicode <= 0x31FF ) return 0 ;
      if ( cUnicode >= 0x3220 && cUnicode <= 0x3243 ) return 0 ;
      if ( cUnicode >= 0x3280 && cUnicode <= 0x32B0 ) return 0 ;
   }
   else if ( cUnicode >= 0xF800 ) {
      if ( cUnicode >= 0xFA0C && cUnicode <= 0xFAFF ) return 0 ;
      if ( cUnicode >= 0xFFA0 && cUnicode <= 0xFFDF ) return UnicodeToJohabTable_FFA0_FFDF [ cUnicode - 0xFFA0 ] ;
   }


   if ( IsUnicodePua ( cUnicode ) ) return 0 ;


   int cKs = UnicodeToMultiByte ( cUnicode, CP_KOREAN ) ;
   if ( cKs ) {

      if ( cKs < 0x100 ) return cKs ;

      int cKsHigh = cKs >> 8 ;
      int cKsLow = cKs & 0xFF ;

      if ( cKsHigh < 0xA1 || cKsLow < 0xA1 ) return 0 ;

      int cJohabHigh = 0 ;
      int cJohabLow ;

      if ( cKsHigh <= 0xAC )                         cJohabHigh = (unsigned)( cKsHigh + 0x111 ) / 2 ;
      else if ( cKsHigh == 0xC9 || cKsHigh == 0xFE ) cJohabHigh = 0xD8 ;
      else if ( cKsHigh >= 0xCA && cKsHigh <= 0xFD ) cJohabHigh = (unsigned)( cKsHigh + 0xF6 ) / 2 ;

      if ( ( cKsHigh & 1 ) == ( cKsHigh <= 0xAC ) ) {
         if ( cKsLow <= 0xEE ) cJohabLow = cKsLow - 0x70 ;
         else                  cJohabLow = cKsLow - 0x5E ;
      }
      else {
         cJohabLow = cKsLow ;
      }

      if ( cJohabHigh && cJohabLow ) return ( cJohabHigh << 8 ) + cJohabLow ;
   }


   return 0 ;
}



///////////////////////////////////////////////////////////////////////////////////////
//                                  JOHAB -> UNICODE
///////////////////////////////////////////////////////////////////////////////////////



int JohabToUnicode ( int cJohab ) {


   if ( (unsigned) cJohab < 0x100 ) {
      if ( (unsigned) cJohab <= 0x0083 ) return cJohab ;
      else                               return 0 ;
   }


   if ( cJohab >= 0x8800 && cJohab <= 0xD3FF ) {

      if ( ( cJohab & 0xFF ) == 0x41 ) {
         for ( int cUnicode = 0x1100 ; cUnicode <= 0x1112 ; cUnicode ++ ) {
            if ( UnicodeToJohabTable_1100_11FF [ cUnicode - 0x1100 ] == cJohab ) return cUnicode ;
         }
      }

      int nInitial = ( cJohab >> 10 ) & 0x1F ;
      int nVowel = ( cJohab >> 5 ) & 0x1F ;
      int nFinal = cJohab & 0x1F ;

      if      ( nInitial >= 0x15 ) return 0 ;
      else if ( nInitial <= 0x1 ) return 0 ;

      if      ( nVowel >= 0x1E ) return 0 ;
      else if ( nVowel >= 0x1A ) nVowel -= 6 ;
      else if ( nVowel >= 0x18 ) return 0 ;
      else if ( nVowel >= 0x12 ) nVowel -= 4 ;
      else if ( nVowel >= 0x10 ) return 0 ;
      else if ( nVowel >= 0xA ) nVowel -= 2 ;
      else if ( nVowel >= 0x8 ) return 0 ;
      else if ( nVowel <= 0x2 ) return 0 ;

      if      ( nFinal >= 0x1E ) return 0 ;
      else if ( nFinal >= 0x13 ) nFinal -- ;
      else if ( nFinal >= 0x12 ) return 0 ;
      else if ( nFinal <= 0x0 ) return 0 ;

      return 0xAC00 + ( ( nInitial - 2 ) * 0x24C ) + ( ( nVowel - 3 ) * 0x1C ) + ( nFinal - 1 ) ;
   }


   if ( cJohab >=0x8442 && cJohab <= 0x8451 ) return cJohab - ( 0x8442 - 0x11A8 ) ;
   if ( cJohab >=0x8453 && cJohab <= 0x845D ) return cJohab - ( 0x8453 - 0x11B8 ) ;


   if ( ( cJohab >> 8 ) == 0xDA ) {
      for ( int cUnicode = 0x1100 ; cUnicode <= 0x11FF ; cUnicode ++ ) {
         if ( UnicodeToJohabTable_1100_11FF [ cUnicode - 0x1100 ] == cJohab ) return cUnicode ;
      }
   }
   if ( ( cJohab >> 8 ) >= 0x84 && ( cJohab >> 8 ) <= 0x87 && ( cJohab & 0x1F ) == 1 ) {
      for ( int cUnicode = 0x1161 ; cUnicode <= 0x1175 ; cUnicode ++ ) {
         if ( UnicodeToJohabTable_1100_11FF [ cUnicode - 0x1100 ] == cJohab ) return cUnicode ;
      }
   }
   if ( ( cJohab >> 8 ) == 0xD8 ) return 0 ;
   if ( cJohab >= 0xDAA1 && cJohab <= 0xDAD3 ) return 0 ;


   int cJohabHigh = cJohab >> 8 ;
   int cJohabLow = cJohab & 0xFF ;

   if ( cJohabLow <= 0x30 ) return 0 ;

   int cKsHigh = 0 ;
   int cKsLow = 0 ;

   if ( cJohabHigh == 0xD8 ) {
      if ( cJohabLow >= 0xA1 ) cKsHigh = 0xFE ;
      else                     cKsHigh = 0xC9 ;
   }
   else if ( cJohabHigh >= 0xD9 && cJohabHigh <= 0xDE ) {
      if ( cJohabLow >= 0xA1 ) cKsHigh = ( cJohabHigh * 2 ) - 0x110 ;
      else                     cKsHigh = ( cJohabHigh * 2 ) - 0x111 ;
   }
   else if ( cJohabHigh >= 0xE0 && cJohabHigh <= 0xF9 ) {
      if ( cJohabLow >= 0xA1 ) cKsHigh = ( cJohabHigh * 2 ) - 0xF5 ;
      else                     cKsHigh = ( cJohabHigh * 2 ) - 0xF6 ;
   }

   if      ( cJohabLow >= 0xA1 ) cKsLow = cJohabLow ;
   else if ( cJohabLow >= 0x91 ) cKsLow = cJohabLow + 0x5E ;
   else if ( cJohabLow <= 0x7E ) cKsLow = cJohabLow + 0x70 ;


   if ( cKsHigh && cKsLow ) {
      int cKs = ( cKsHigh << 8 ) + cKsLow ;
      return MultiByteToUnicode ( cKs, CP_KOREAN ) ;
   }


   return 0 ;
}



