// fileconv.cpp

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "msc.h"

#include "access.h"
#include "fileconv.h"
#include "filename.h"
#include "filetime.h"
#include "oemio.h"
#include "stringex.h"



//////////////////////////////
//          ANSI          //
//////////////////////////////



// t@CwRo[^iANSIŁj
// szExtension  . ĂȂĂ悢
// szExtension  NULL w肵Ƃ́AWo͂ɏo͂
// ߂l͎̒ʂ
//        0      :   
//        1 ȏ :   Ro[^̃G[̂܂ܕԂ
//       -1      :   ANZXہiFILECONV_ERROR_ACCESSj
//       -2      :   gqsiFILECONV_ERROR_EXTENSIONj
//       -3      :   [ȂiFILECONV_ERROR_MEMORYj

int FileConvertA ( const char *szSrcFileName, const char *szExtension, int ( WINAPI *pFunction ) ( const char *szSrcFileName, const char *szDstFileName, int nSrcCodePage, int nDstCodePage, void *pFunctionData ), int nSrcCodePage, int nDstCodePage, void *pFunctionData, unsigned long dwMode ) {

   char *szDstFileName = NULL ;

   int IsDisplay = 0 ;                             // 1 : o߂\

   int IsSrcDstReversed = 0 ;
   int nResult ;

   FILETIME CreationTime, LastAccessTime, LastWriteTime ;

   static const char szConverting [] = "now converting " ;
   static const char szConverted  [] = "converted      " ;


   // o̓t@Cw肵Ȃꍇ
   if ( ! szExtension ) {
      if ( ! fisatty ( stdout ) ) IsDisplay = 1 ;
   }
   // gqw肵ꍇ
   else {

      if ( *szExtension == '.' ) szExtension ++ ;

      szDstFileName = strdup_expand ( szSrcFileName, MAX_PATH, strlen ( szExtension ) + 1 ) ;   // sIht邽
      if ( ! szDstFileName ) { nResult = FILECONV_ERROR_MEMORY ; goto CAUGHT_ERROR ; }

      ChangeExtensionA ( szDstFileName, szExtension ) ;
      if ( strlen ( szDstFileName ) + 1 > MAX_PATH ) { nResult = FILECONV_ERROR_MEMORY ; goto CAUGHT_ERROR ; }
      if ( ! stricmp ( szDstFileName, szSrcFileName ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }

      if ( ( dwMode & FILECONV_SAVE_TIMESTAMP ) && GetFileTimeExA ( szSrcFileName, & CreationTime, & LastAccessTime, & LastWriteTime ) ) dwMode &= ~ FILECONV_SAVE_TIMESTAMP ;

      if ( ! stricmp ( szExtension, "BAK" ) ) {
         IsSrcDstReversed = 1 ;
         if ( ! IsFileAccessibleA ( szSrcFileName, FILE_ACCESS_WRITE | FILE_ACCESS_FILE ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }
         if ( ! IsFileAccessibleA ( szDstFileName, FILE_ACCESS_WRITE | FILE_ACCESS_FILE ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }
         DeleteFileA ( szDstFileName ) ;
         if ( ! MoveFileA ( szSrcFileName, szDstFileName ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }
      }
      else {
         if ( ! IsFileAccessibleA ( szDstFileName, FILE_ACCESS_WRITE | FILE_ACCESS_FILE ) ) {
            if ( IsFileAccessibleA ( szDstFileName, FILE_ACCESS_EXIST ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }
            if ( ! IsFileAccessibleA ( szSrcFileName, FILE_ACCESS_EXIST | FILE_ACCESS_FILE ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }
            nResult = FILECONV_ERROR_EXTENSION ; goto CAUGHT_ERROR ;
         }
      }
      IsDisplay = 1 ;
   }

   if ( dwMode & FILECONV_NO_ECHO ) IsDisplay = 0 ;


   if ( IsDisplay ) {
      fputs_line ( szConverting, stderr ) ;
      fputs_line ( szSrcFileName, stderr ) ;
   }


   if ( IsSrcDstReversed ) nResult = pFunction ( szDstFileName, szSrcFileName, nSrcCodePage, nDstCodePage, pFunctionData ) ;
   else                    nResult = pFunction ( szSrcFileName, szDstFileName, nSrcCodePage, nDstCodePage, pFunctionData ) ;
   if ( nResult ) goto CAUGHT_ERROR ;


   if ( ( dwMode & FILECONV_SAVE_TIMESTAMP ) && szDstFileName ) {
      if ( IsSrcDstReversed ) SetFileTimeExA ( szSrcFileName, & CreationTime, & LastAccessTime, & LastWriteTime ) ;
      else                    SetFileTimeExA ( szDstFileName, & CreationTime, & LastAccessTime, & LastWriteTime ) ;
   }

   if ( dwMode & FILECONV_TO_HIDDEN ) {
      if ( IsSrcDstReversed ) SetFileAttributesA ( szDstFileName, ( GetFileAttributesA ( szSrcFileName ) & FILE_ATTRIBUTES_THROUGH ) | FILE_ATTRIBUTE_HIDDEN ) ;
      else                    SetFileAttributesA ( szSrcFileName, ( GetFileAttributesA ( szDstFileName ) & FILE_ATTRIBUTES_THROUGH ) | FILE_ATTRIBUTE_HIDDEN ) ;
   }


   if ( IsDisplay ) {
      fputs_line ( "\r", stderr ) ;
      fputs ( szConverted, stderr ) ;
      fputs ( szSrcFileName, stderr ) ;
      fputs ( "\n", stderr ) ;
   }


   CAUGHT_ERROR :
   free ( szDstFileName ) ;
   return nResult ;
}



//////////////////////////////
//         UNICODE        //
//////////////////////////////



// t@CwRo[^iUNICODEŁj
// szExtension  . ĂȂĂ悢
// szExtension  NULL w肵Ƃ́AWo͂ɏo͂
// ߂l͎̒ʂ
//        0      :   
//        1 ȏ :   Ro[^̃G[̂܂ܕԂ
//       -1      :   ANZXہiFILECONV_ERROR_ACCESSj
//       -2      :   gqsiFILECONV_ERROR_EXTENSIONj
//       -3      :   [ȂiFILECONV_ERROR_MEMORYj

int FileConvertW ( const wchar_t *szSrcFileName, const wchar_t *szExtension, int ( WINAPI *pFunction ) ( const wchar_t *szSrcFileName, const wchar_t *szDstFileName, int nSrcCodePage, int nDstCodePage, void *pFunctionData ), int nSrcCodePage, int nDstCodePage, void *pFunctionData, unsigned long dwMode ) {

   wchar_t *szDstFileName = NULL ;

   int IsDisplay = 0 ;                             // 1 : o߂\

   int IsSrcDstReversed = 0 ;
   int nResult ;

   FILETIME CreationTime, LastAccessTime, LastWriteTime ;

   static const wchar_t szConverting [] = L"now converting " ;
   static const wchar_t szConverted  [] = L"converted      " ;


   // o̓t@Cw肵Ȃꍇ
   if ( ! szExtension ) {
      if ( ! fisatty ( stdout ) ) IsDisplay = 1 ;
   }
   // gqw肵ꍇ
   else {

      if ( *szExtension == '.' ) szExtension ++ ;

      szDstFileName = wcsdup_expand ( szSrcFileName, MAX_LONG_PATH, wcslen ( szExtension ) + 1 ) ; // sIht邽
      if ( ! szDstFileName ) { nResult = FILECONV_ERROR_MEMORY ; goto CAUGHT_ERROR ; }

      ChangeExtensionW ( szDstFileName, szExtension ) ;
      if ( wcslen ( szDstFileName ) + 1 > MAX_LONG_PATH ) { nResult = FILECONV_ERROR_MEMORY ; goto CAUGHT_ERROR ; }
      if ( ! wcsicmp ( szDstFileName, szSrcFileName ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }

      if ( ( dwMode & FILECONV_SAVE_TIMESTAMP ) && GetFileTimeExW ( szSrcFileName, & CreationTime, & LastAccessTime, & LastWriteTime ) ) dwMode &= ~ FILECONV_SAVE_TIMESTAMP ;

      if ( ! wcsicmp ( szExtension, L"BAK" ) ) {
         IsSrcDstReversed = 1 ;
         if ( ! IsFileAccessibleW ( szSrcFileName, FILE_ACCESS_WRITE | FILE_ACCESS_FILE ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }
         if ( ! IsFileAccessibleW ( szDstFileName, FILE_ACCESS_WRITE | FILE_ACCESS_FILE ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }
         DeleteFileW ( szDstFileName ) ;
         if ( ! MoveFileW ( szSrcFileName, szDstFileName ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }
      }
      else {
         if ( ! IsFileAccessibleW ( szDstFileName, FILE_ACCESS_WRITE | FILE_ACCESS_FILE ) ) {
            if ( IsFileAccessibleW ( szDstFileName, FILE_ACCESS_EXIST ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }
            if ( ! IsFileAccessibleW ( szSrcFileName, FILE_ACCESS_EXIST | FILE_ACCESS_FILE ) ) { nResult = FILECONV_ERROR_ACCESS ; goto CAUGHT_ERROR ; }
            nResult = FILECONV_ERROR_EXTENSION ; goto CAUGHT_ERROR ;
         }
      }
      IsDisplay = 1 ;
   }

   if ( dwMode & FILECONV_NO_ECHO ) IsDisplay = 0 ;


   if ( IsDisplay ) {
      fputws_line ( szConverting, stderr ) ;
      fputws_line ( szSrcFileName, stderr ) ;
   }


   if ( IsSrcDstReversed ) nResult = pFunction ( szDstFileName, szSrcFileName, nSrcCodePage, nDstCodePage, pFunctionData ) ;
   else                    nResult = pFunction ( szSrcFileName, szDstFileName, nSrcCodePage, nDstCodePage, pFunctionData ) ;
   if ( nResult ) goto CAUGHT_ERROR ;


   if ( ( dwMode & FILECONV_SAVE_TIMESTAMP ) && szDstFileName ) {
      if ( IsSrcDstReversed ) SetFileTimeExW ( szSrcFileName, & CreationTime, & LastAccessTime, & LastWriteTime ) ;
      else                    SetFileTimeExW ( szDstFileName, & CreationTime, & LastAccessTime, & LastWriteTime ) ;
   }

   if ( dwMode & FILECONV_TO_HIDDEN ) {
      if ( IsSrcDstReversed ) SetFileAttributesW ( szDstFileName, ( GetFileAttributesW ( szSrcFileName ) & FILE_ATTRIBUTES_THROUGH ) | FILE_ATTRIBUTE_HIDDEN ) ;
      else                    SetFileAttributesW ( szSrcFileName, ( GetFileAttributesW ( szDstFileName ) & FILE_ATTRIBUTES_THROUGH ) | FILE_ATTRIBUTE_HIDDEN ) ;
   }


   if ( IsDisplay ) {
      fputws_line ( L"\r", stderr ) ;
      fputws ( szConverted, stderr ) ;
      fputws ( szSrcFileName, stderr ) ;
      fputws ( L"\n", stderr ) ;
   }


   CAUGHT_ERROR :
   free ( szDstFileName ) ;
   return nResult ;
}



