// rtfconv_com.h

#ifndef RTFCONV_COM_H
#define RTFCONV_COM_H



static const wchar_t szHelpLangList1 [] =
            L"\n"
            L"   -c1200   or  -cU         : Unicode (UTF-16)\n"
            L"   -c1201   or  -cUBIG      : Unicode (UTF-16) Big Endian\n"
            L"   -c65001  or  -cUTF8      : Unicode (UTF-8)\n"
            L"   -c65000  or  -cUTF7      : Unicode (UTF-7)\n"
            L"   -c65005  or  -cUTF32     : Unicode (UTF-32)\n"
            L"   -c65006  or  -cUTF32BIG  : Unicode (UTF-32) Big Endian\n"
            L"\n"
            L"   -c437   : US English (DOS)          -c858   : Western European + Euro (DOS)\n"
            L"   -c737   : Greek    (DOS)            -c860   : Portuguese (DOS)\n"
            L"   -c775   : Baltic   (DOS)            -c861   : Icelandic  (DOS)\n"
            L"   -c850   : Western European (DOS)    -c863   : Canadian French (DOS)\n"
            L"   -c852   : Central European (DOS)    -c865   : Nordic     (DOS)\n"
            L"   -c855   : Cyrillic (DOS)            -c866   : Russian    (DOS)\n"
            L"   -c857   : Turkish  (DOS)            -c869   : Modern Greek (DOS)\n"
;

static const wchar_t szHelpLangList2 [] =
            L"\n"
            L"   -c708   : Arabic (ASMO 708)         -c856   : Hebrew (DOS)\n"
            L"   -c709   : Arabic (ASMO 449+)        -c862   : Hebrew (DOS)\n"
            L"   -c720   : Arabic (DOS)              -c864   : Arabic (DOS)\n"
            L"\n"
            L"   -c28591  or  -cISO-1    : Western European (ISO-8859-1)\n"
            L"   -c28592  or  -cISO-2    : Central European (ISO-8859-2)\n"
            L"   -c28593  or  -cISO-3    : Southern European (ISO-8859-3)\n"
            L"   -c28594  or  -cISO-4    : Baltic    (ISO-8859-4)\n"
            L"   -c28595  or  -cISO-5    : Cyrillic  (ISO-8859-5)\n"
            L"   -c28596  or  -cISO-6    : Arabic    (ISO-8859-6)\n"
            L"   -c28597  or  -cISO-7    : Greek     (ISO-8859-7)\n"
            L"   -c28598  or  -cISO-8-V  : Hebrew    (ISO-8859-8 Visual)\n"
            L"   -c38598  or  -cISO-8-L  : Hebrew    (ISO-8859-8 Logical)\n"
            L"   -c28599  or  -cISO-9    : Turkish   (ISO-8859-9)\n"
            L"   -c28600  or  -cISO-10   : Nordic    (ISO-8859-10)\n"
            L"   -c28601  or  -cISO-11   : Thai      (ISO-8859-11)\n"
            L"   -c28603  or  -cISO-13   : Baltic    (ISO-8859-13)\n"
            L"   -c28604  or  -cISO-14   : Celtic    (ISO-8859-14)\n"
            L"   -c28605  or  -cISO-15   : Western European Ext. (ISO-8859-15)\n"
            L"   -c28606  or  -cISO-16   : Central European Ext. (ISO-8859-16)\n"
;

static const wchar_t szHelpLangList3 [] =
            L"\n"
            L"   -c1250   or  -cCE     : Central European (Windows)\n"
            L"   -c1251   or  -cCY     : Cyrillic (Windows)\n"
            L"   -c1252   or  -cE      : Western European (Windows)\n"
            L"   -c1253   or  -cGR     : Greek    (Windows)\n"
            L"   -c1254   or  -cTU     : Turkish  (Windows)\n"
            L"   -c1257   or  -cBA     : Baltic   (Windows)\n"
            L"\n"
            L"   -c874    or  -cTH     : Thai     (Windows)\n"
            L"   -c1258   or  -cVN     : Vietnamese (Windows)\n"
            L"   -c1256   or  -cAR     : Arabic   (Windows)\n"
            L"   -c1255   or  -cHE     : Hebrew   (Windows)\n"
            L"\n"
            L"   -c932    or  -cJ      : Japanese (Shift-JIS)\n"
            L"   -c50220  or  -cJIS    : Japanese (ISO-2022-JP)\n"
            L"   -c51932  or  -cJEUC   : Japanese (EUC-JP)\n"
            L"   -c949    or  -cK      : Korean (EUC-KR/UHC)\n"
            L"   -c50225  or  -cKISO   : Korean (ISO-2022-KR)\n"
            L"   -c1361   or  -cKJ     : Korean (Johab)\n"
            L"   -c936    or  -cC      : Chinese Simplified (GB2312/GBK)\n"
            L"   -c52936  or  -cHZ     : Chinese Simplified (HZ)\n"
            L"   -c950    or  -cT      : Chinese Traditional (BIG5)\n"
            L"   -c951    or  -cHK     : Chinese Traditional (HKSCS) (*)\n"
            L"   -c58950  or  -cTEUC   : Chinese Traditional (EUC-TW) (*)\n"
;

static const wchar_t szHelpLangList4 [] =
            L"\n"
            L"   -c20127  or  -cASCII    : US ASCII (7-bit)\n"
            L"   -c20866  or  -cKOI8-R   : Cyrillic (KOI8-R)\n"
            L"   -c21866  or  -cKOI8-U   : Cyrillic (KOI8-U)\n"
            L"\n"
            L"   -c10000  : Western European (MAC)   -c10017  : Ukrainian (MAC)\n"
            L"   -c10004  : Arabic    (MAC)          -c10021  : Thai      (MAC)\n"
            L"   -c10005  : Hebrew    (MAC)          -c10029  : Central European (MAC)\n"
            L"   -c10006  : Greek     (MAC)          -c10079  : Icelandic (MAC)\n"
            L"   -c10007  : Cyrillic  (MAC)          -c10081  : Turkish   (MAC)\n"
            L"   -c10010  : Romanian  (MAC)          -c10082  : Croatian  (MAC)\n"
            L"\n"
            L"   -c57002  : Devanagari (ISCII)       -c57007  : Oriya     (ISCII)\n"
            L"   -c57003  : Bengali  (ISCII)         -c57008  : Kannada   (ISCII)\n"
            L"   -c57004  : Tamil    (ISCII)         -c57009  : Malayalam (ISCII)\n"
            L"   -c57005  : Telugu   (ISCII)         -c57010  : Gujarathi (ISCII)\n"
            L"   -c57006  : Assamese (ISCII)         -c57011  : Panjabi   (ISCII)\n"
            L"\n"
            L"   -c895    : Czech (DOS, Kamenicky CS) (*)\n"
            L"\n"
            L"   -c58240  : Nordic (ISO-IR-197) (*)  -c58241  : Nordic (ISO-IR-209) (*)\n"
            L"   -c58242  : Nordic (SAMI-WS2) (*)\n"
;

static const wchar_t szHelpLangList5 [] =
            L"\n"
            L"   -c58000  : Georgian (GEOSTD8) (*)   -c58001  : Armenian (ARMSCII-8) (*)\n"
            L"   -c58003  : Georgian (Academy) (*)   -c58002  : Armenian (ARMSCII-8A) (*)\n"
            L"   -c58004  : Georgian (Parliament-Soros) (*)\n"
            L"\n"
            L"   -c58010  : Cyrillic (KOI8-RU) (*)   -c58014  : Cyrillic (KOI8-Unified) (*)\n"
            L"   -c58011  : Cyrillic (KOI8-T) (*)    -c58015  : Cyrillic (ISO-IR-111) (*)\n"
            L"   -c58012  : Cyrillic (KOI8-C) (*)    -c58017  : Cyrillic (PT154) (*)\n"
            L"   -c58013  : Cyrillic (KOI8-O) (*)    -c58018  : Cyrillic (KZ-1048) (*)\n"
            L"\n"
            L"   -c58200  : Vietnamese (TCVN-1) (*)  -c58201  : Vietnamese (VISCII) (*)\n"
            L"   -c58205  : Vietnamese (TCVN-2) (*)  -c58202  : Vietnamese (VPS-8) (*)\n"
            L"   -c58206  : Vietnamese (TCVN-3) (*)  -c58203  : Vietnamese (VNI) (*)\n"
            L"   -c58204  : Vietnamese (VIQR) (*)\n"
            L"\n"
            L"   -c58100  : Tamil (TSCII) (*)        -c58101  : Tamil (TAM) (*)\n"
            L"   -c58102  : Tamil (TAB) (*)\n"
            L"\n"
            L"   -c58060  : Farsi (ISIRI-3342) (*)\n"
;



#endif

