// wildcard.cpp

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "msc.h"
#include "filename.h"
#include "storestr.h"
#include "wildcard.h"



static int RegisterAbortFlag ( volatile const short **pAbortFlagAddress ) ;
static int UnregisterAbortFlag ( volatile const short *pAbortFlag ) ;


#ifndef _CONSOLE
static int InitPeekMessage ( HWND *phDialog, int *pIsUnicode ) ;
static int PeekMessageProc ( HWND hDialog, int IsUnicode ) ;
#endif



//////////////////////////////
//          ANSI          //
//////////////////////////////



typedef struct {
   WIN32_FIND_DATAA *pFindData ;
   int ( __cdecl *CompareFunction ) ( const char **, const char ** ) ;
   volatile const short *pAbortFlag ;
#ifndef _CONSOLE
   HWND hDialog ;
   int IsMessageUnicode ;
   int nCountAll ;
#endif
} DATAA ;



// ֐
static WILDCARDA *DoSearchWildcardA ( WILDCARDA *Wildcard, const char *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const char *szSearchPath, WIN32_FIND_DATAA *FindData, int nDepth, LPARAM lParam ), LPARAM lParam, int nDepth, DATAA *pData ) ;
static inline int IsAbortedA ( DATAA *pData ) { return *pData->pAbortFlag ; }
static int IsHaveAnyFileA ( const char *szFileName, int IsSearchHidden, int IsExcludeDir ) ;
static int IsValidAnsiLongFileName ( const char *szLongPathName, const char *szShortFileName ) ;



// ChJ[ht@Cobt@Ƀt@Co͂iANSIŁj
// nhɂ CloseWildcard () Ăяo
// t@Coɂ GetFirstFile ()  GetNextFile () Ăяo
// vf̌ GetFileCount () т
// nh܂ł́At@CǉČ邱Ƃł

// Wildcard : ChJ[hnhi NULL ̂Ƃ͐VɊ蓖āj
// szSearchPath : t@CiChJ[hуpX܂މj
// szSearchMode Ɍ[hw肷iڍׂ wildcard.h j
// R[obN֐̖߂l 0 ȂrAlȂ璆~
// ChJ[hnhԂ
// t@CȂƂ́A蓖Ăꂽ Wildcard ̂܂ܕԂ
// obt@̊mۂɎsƂA܂ AbortWildcard ɂ蒆~ꂽƂ́A
//   obt@NA WILDCARD_ERROR Ԃ
WILDCARDA *WINAPI SearchWildcardA ( WILDCARDA *Wildcard, const char *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const char *szSearchPath, WIN32_FIND_DATAA *FindData, int nDepth, LPARAM lParam ), LPARAM lParam ) {

   if ( ! GetFileNameA ( szSearchPath ) ) return Wildcard ;

   DATAA Data = { 0 } ;

   WIN32_FIND_DATAA FindData ;
   Data.pFindData = & FindData ;

#ifndef _CONSOLE
   if ( dwFlags & WILD_PEEKMESSAGE ) {
      if ( InitPeekMessage ( & Data.hDialog, & Data.IsMessageUnicode ) ) dwFlags &= ~ WILD_PEEKMESSAGE ;
   }
#endif

   // t@CfBNg̎w肪Ȃ΃t@Cw
   if ( ! ( dwFlags & WILD_SEARCH_FILE ) && ! ( dwFlags & WILD_SEARCH_FOLDER ) ) dwFlags |= WILD_SEARCH_FILE ;

   if ( ( dwFlags & WILD_NO_EMPTY_DIR ) && ( dwFlags & WILD_ONLY_EMPTY_DIR ) ) dwFlags &= ~ ( WILD_NO_EMPTY_DIR | WILD_ONLY_EMPTY_DIR ) ;

   // \[gp֐I
   if ( dwFlags & WILD_XP_STYLE ) {
      if ( dwFlags & WILD_SORT )         Data.CompareFunction = CompareStoredStringsNumericalA ;
      if ( dwFlags & WILD_SORT_REVERSE ) Data.CompareFunction = CompareStoredStringsNumericalRevA ;
   }
   else {
      if ( dwFlags & WILD_SORT )         Data.CompareFunction = CompareStoredStringsLocaleA ;
      if ( dwFlags & WILD_SORT_REVERSE ) Data.CompareFunction = CompareStoredStringsLocaleRevA ;
   }

   RegisterAbortFlag ( & Data.pAbortFlag ) ;
   WILDCARDA *Result = (WILDCARDA*) WILDCARD_ERROR ;
   __try {
      Result = DoSearchWildcardA ( Wildcard, szSearchPath, dwFlags, Callback, lParam, 0, & Data ) ;
   } __finally {
      UnregisterAbortFlag ( Data.pAbortFlag ) ;
   }

   return Result ;
}



// SearchWildcardA() ̉֐
// ċAĂяo
static WILDCARDA *DoSearchWildcardA ( WILDCARDA *Wildcard, const char *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const char *szSearchPath, WIN32_FIND_DATAA *FindData, int nDepth, LPARAM lParam ), LPARAM lParam, int nDepth, DATAA *pData ) {


   if ( Wildcard == WILDCARD_ERROR ) return (WILDCARDA*) WILDCARD_ERROR ;


   WIN32_FIND_DATAA *const pFindData = pData->pFindData ;
   int IsNoMoreSearchSub = 0 ;


   char *szFileName = strdup_expand ( szSearchPath, MAX_PATH, MAX_PATH + 1 ) ;   // TufBNg \ 邽
   if ( ! szFileName ) {
      CloseWildcardA ( Wildcard ) ;
      return (WILDCARDA*) WILDCARD_ERROR ;
   }


   // ̃fBNg̃t@C
   HANDLE hFindFile = FindFirstFileA ( szSearchPath, pFindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {

      int IsFirst = 1 ;
      int IsErrorInLoop = 0 ;

      do {

#ifndef _CONSOLE
         if ( ! ( ++ pData->nCountAll & 0x7F ) ) {
            if ( dwFlags & WILD_PEEKMESSAGE ) PeekMessageProc ( pData->hDialog, pData->IsMessageUnicode ) ;
         }
#endif
         if ( IsAbortedA ( pData ) ) { IsErrorInLoop = 1 ; break ; }

         if ( ! strcmp ( pFindData->cFileName, "." ) || ! strcmp ( pFindData->cFileName, ".." ) ) {
            if ( ! ( dwFlags & WILD_SEARCH_CURDIR ) ) continue ;
         }
         else {
            if ( pFindData->dwFileAttributes & ( FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM ) ) {
               if ( ! ( dwFlags & WILD_SEARCH_HIDDEN ) ) continue ;
            }
            if ( pFindData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
               if ( ! ( dwFlags & WILD_SEARCH_FOLDER ) ) continue ;
            }
            else {
               if ( ! ( dwFlags & WILD_SEARCH_FILE ) ) continue ;
            }
         }

         // Ot@CƃV[gt@ĈǂD
         char *szPriorName = ( dwFlags & WILD_SHORTNAME ) ? pFindData->cAlternateFileName : pFindData->cFileName ;
         char *szAlternateName = ( dwFlags & WILD_SHORTNAME ) ? pFindData->cFileName : pFindData->cAlternateFileName ;

         // Ot@CƃV[gt@C
         if ( ! *szPriorName && *szAlternateName ) szPriorName = szAlternateName ;

         // WȊO̕R[hgĂȂ
         if ( ! ( dwFlags & WILD_SHORTNAME ) && *szAlternateName ) {
            if ( strchr ( szPriorName, '?' ) ) szPriorName = szAlternateName ;
            else if ( ! IsNT () && strchr ( szPriorName, '_' ) ) {
               ChangeFileNameA ( szFileName, szPriorName ) ;
               if ( ! IsValidAnsiLongFileName ( szFileName, szAlternateName ) ) szPriorName = szAlternateName ;
            }
         }

         // ̃fBNg
         if ( pFindData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
            if ( dwFlags & ( WILD_NO_EMPTY_DIR | WILD_ONLY_EMPTY_DIR ) ) {
               ChangeFileNameA ( szFileName, szPriorName ) ;
               if ( ( dwFlags & WILD_NO_EMPTY_DIR ) && ! IsHaveAnyFileA ( szFileName, dwFlags & WILD_SEARCH_HIDDEN, 1 ) ) continue ;
               if ( ( dwFlags & WILD_ONLY_EMPTY_DIR ) && IsHaveAnyFileA ( szFileName, dwFlags & WILD_SEARCH_HIDDEN, 0 ) ) continue ;
            }
         }

         // R[obN֐Ăяo
         if ( Callback ) {
            int nCallbackRetvalue = Callback ( szSearchPath, pFindData, nDepth, lParam ) ;
            if ( nCallbackRetvalue == 0 ) continue ;
            if ( nCallbackRetvalue < 0 ) { IsNoMoreSearchSub = 1 ; break ; }
         }

         // ChJ[h\̂̃m
         if ( ! Wildcard ) {
            Wildcard = (WILDCARDA*) malloc ( sizeof(WILDCARDA) ) ;
            if ( ! Wildcard ) { IsErrorInLoop = 1 ; break ; }
            memzero ( Wildcard, sizeof(WILDCARDA) ) ;
         }

         // fBNgo
         if ( IsFirst ) {
            IsFirst = 0 ;
            if ( ! ( dwFlags & WILD_NO_PIVOT_DIR ) ) {
               ChangeFileNameA ( szFileName, NULL ) ;
               if ( ! ( dwFlags & WILD_WITHPATH ) ) {
                  if ( ! *szFileName && Wildcard->StoredNames ) Wildcard->StoredNames = StoreStringsA ( Wildcard->StoredNames, ".\\" ) ;
                  else                                          Wildcard->StoredNames = StoreStringsA ( Wildcard->StoredNames, szFileName ) ;
                  if ( Wildcard->StoredNames == STOREDSTRINGS_ERROR ) { IsErrorInLoop = 1 ; break ; }
               }
            }
            MarkSortStartA ( Wildcard->StoredNames ) ;
         }

         // pXo͂ꍇ
         if ( dwFlags & WILD_WITHPATH ) {
            ChangeFileNameA ( szFileName, szPriorName ) ;
            // vt@Co
            Wildcard->StoredNames = StoreStringsA ( Wildcard->StoredNames, szFileName ) ;
         }
         // pXo͂Ȃꍇ
         else {
            // vt@Co
            Wildcard->StoredNames = StoreStringsA ( Wildcard->StoredNames, szPriorName ) ;
         }

         if ( Wildcard->StoredNames == STOREDSTRINGS_ERROR ) { IsErrorInLoop = 1 ; break ; }

      } while ( FindNextFileA ( hFindFile, pFindData ) ) ;

      FindClose ( hFindFile ) ;

      // G[܂͒~
      if ( IsErrorInLoop ) {
         CloseWildcardA ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDA*) WILDCARD_ERROR ;
      }

      // t@C\[g
      if ( Wildcard && pData->CompareFunction && SortStoredStringsA ( Wildcard->StoredNames, pData->CompareFunction ) ) {
         CloseWildcardA ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDA*) WILDCARD_ERROR ;
      }
   }



   // TufBNgAċAĂяosȂ
   if ( dwFlags & WILD_SEARCH_SUB && ! IsNoMoreSearchSub ) {

      ChangeFileNameA ( szFileName, "*" ) ;

      unsigned long dwFlagsSub = WILD_SEARCH_FOLDER | WILD_NO_PIVOT_DIR | ( dwFlags & WILD_SHORTNAME ) ;
      if ( dwFlags & WILD_SEARCH_HIDDENSUB ) dwFlagsSub |= WILD_SEARCH_HIDDEN ;

      WILDCARDA *WildcardSub = DoSearchWildcardA ( NULL, szFileName, dwFlagsSub, NULL, 0, 0, pData ) ;

      if ( WildcardSub == WILDCARD_ERROR ) {
         CloseWildcardA ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDA*) WILDCARD_ERROR ;
      }

      // fBNg݂ꍇ
      if ( WildcardSub ) {

         for ( const char *szString = GetFirstFileA ( WildcardSub ) ; szString ; szString = GetNextFileA ( WildcardSub ) ) {

            strcpy ( szFileName, szSearchPath ) ;
            ChangeFileNameA ( szFileName, szString ) ;
            strcat ( szFileName, "\\" ) ;
            strcat ( szFileName, GetFileNameA ( szSearchPath ) ) ;

            // ċAĂяo
            Wildcard = DoSearchWildcardA ( Wildcard, szFileName, dwFlags, Callback, lParam, nDepth + 1, pData ) ;
            if ( Wildcard == WILDCARD_ERROR ) break ;
         }

         CloseWildcardA ( WildcardSub ) ;
      }
   }

   free ( szFileName ) ;
   return Wildcard ;
}



// t@Cobt@iANSIŁj
// SearchWildcard () gƂ̓vZX̏I܂łɕK CloseWildcard () Ăяo
void WINAPI CloseWildcardA ( WILDCARDA *Wildcard ) {
   if ( ! Wildcard || Wildcard == WILDCARD_ERROR ) return ;
   if ( Wildcard->StoredNames && Wildcard->StoredNames != STOREDSTRINGS_ERROR ) FreeStoredStringsA ( Wildcard->StoredNames ) ;
   free ( Wildcard ) ;
   return ;
}



// t@Cobt@̃t@ČԂiANSIŁj
size_t WINAPI GetFileCountA ( WILDCARDA *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == WILDCARD_ERROR ) return 0 ;
   return GetStringCountA ( Wildcard->StoredNames ) ;
}



// t@Cobt@ŏ̃t@CԂiANSIŁj
// t@CȂ΁ANULL Ԃ
const char *WINAPI GetFirstFileA ( WILDCARDA *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == WILDCARD_ERROR ) return NULL ;
   return GetFirstStringA ( Wildcard->StoredNames ) ;
}



// t@Cobt@玟̃t@CԂiANSIŁj
// t@CȂ΁ANULL Ԃ
// GetFirstFile () ĂяoOȂ΁A͕s
const char *WINAPI GetNextFileA ( WILDCARDA *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == WILDCARD_ERROR ) return NULL ;
   return GetNextStringA ( Wildcard->StoredNames ) ;
}



// t@CfBNgȂ 0 ȊOAȂ 0 Ԃ
static int IsHaveAnyFileA ( const char *szFileName, int IsSearchHidden, int IsExcludeDir ) {

   int nResult = 0 ;

   char *szSearchPath = strdup_expand ( szFileName, (size_t) -1, 8 ) ;
   if ( ! szSearchPath ) return nResult ;
   strcat ( szSearchPath, "\\*" ) ;

   WIN32_FIND_DATAA FindData ;

   HANDLE hFindFile = FindFirstFileA ( szSearchPath, & FindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {
      do {

         if ( IsExcludeDir && ( FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) continue ;
         if ( ! IsSearchHidden && FindData.dwFileAttributes & ( FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM ) ) continue ;
         if ( ! strcmp ( FindData.cFileName, "." ) || ! strcmp ( FindData.cFileName, ".." ) ) continue ;

         nResult = 1 ;
         break ;

      } while ( FindNextFileA ( hFindFile, & FindData ) ) ;

      FindClose ( hFindFile ) ;
   }

   free ( szSearchPath ) ;

   return nResult ;
}



// Ot@CLǂ
// szLongPathName ̓pXtŁAszShortFileName ̓t@Ĉ݂Ŏw
static int IsValidAnsiLongFileName ( const char *szLongPathName, const char *szShortFileName ) {

   WIN32_FIND_DATAA FindData ;
   int nRetValue = 0 ;

   HANDLE hFindFile = FindFirstFileA ( szLongPathName, & FindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {
      if ( ! strcmp ( FindData.cAlternateFileName, szShortFileName ) ) nRetValue = 1 ;
      if ( FindNextFileA ( hFindFile, & FindData ) ) nRetValue = 0 ;
      FindClose ( hFindFile ) ;
   }

   return nRetValue ;
}



//////////////////////////////
//         UNICODE        //
//////////////////////////////



typedef struct {
   WIN32_FIND_DATAW *pFindData ;
   int ( __cdecl *CompareFunction ) ( const wchar_t **, const wchar_t ** ) ;
   volatile const short *pAbortFlag ;
#ifndef _CONSOLE
   HWND hDialog ;
   int IsMessageUnicode ;
   int nCountAll ;
#endif
} DATAW ;



// ֐
static WILDCARDW *DoSearchWildcardW ( WILDCARDW *Wildcard, const wchar_t *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const wchar_t *szSearchPath, WIN32_FIND_DATAW *FindData, int nDepth, LPARAM lParam ), LPARAM lParam, int nDepth, DATAW *pData ) ;
static inline int IsAbortedW ( DATAW *pData ) { return *pData->pAbortFlag ; }
static int IsHaveAnyFileW ( const wchar_t *szFileName, int IsSearchHidden, int IsExcludeDir ) ;



// ChJ[ht@Cobt@Ƀt@Co͂iUNICODEŁj
// nhɂ CloseWildcard () Ăяo
// t@Coɂ GetFirstFile ()  GetNextFile () Ăяo
// vf̌ GetFileCount () т
// nh܂ł́At@CǉČ邱Ƃł

// Wildcard : ChJ[hnhi NULL ̂Ƃ͐VɊ蓖āj
// szSearchPath : t@CiChJ[hуpX܂މj
// szSearchMode Ɍ[hw肷iڍׂ wildcard.h j
// R[obN֐̖߂l 0 ȂrAlȂ璆~
// ChJ[hnhԂ
// t@CȂƂ́A蓖Ăꂽ Wildcard ̂܂ܕԂ
// obt@̊mۂɎsƂA܂ AbortWildcard ɂ蒆~ꂽƂ́A
//   obt@NA WILDCARD_ERROR Ԃ
WILDCARDW *WINAPI SearchWildcardW ( WILDCARDW *Wildcard, const wchar_t *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const wchar_t *szSearchPath, WIN32_FIND_DATAW *FindData, int nDepth, LPARAM lParam ), LPARAM lParam ) {

   if ( ! GetFileNameW ( szSearchPath ) ) return Wildcard ;

   DATAW Data = { 0 } ;

   WIN32_FIND_DATAW FindData ;
   Data.pFindData = & FindData ;

#ifndef _CONSOLE
   if ( dwFlags & WILD_PEEKMESSAGE ) {
      if ( InitPeekMessage ( & Data.hDialog, & Data.IsMessageUnicode ) ) dwFlags &= ~ WILD_PEEKMESSAGE ;
   }
#endif

   // t@CfBNg̎w肪Ȃ΃t@Cw
   if ( ! ( dwFlags & WILD_SEARCH_FILE ) && ! ( dwFlags & WILD_SEARCH_FOLDER ) ) dwFlags |= WILD_SEARCH_FILE ;

   if ( ( dwFlags & WILD_NO_EMPTY_DIR ) && ( dwFlags & WILD_ONLY_EMPTY_DIR ) ) dwFlags &= ~ ( WILD_NO_EMPTY_DIR | WILD_ONLY_EMPTY_DIR ) ;

   // \[gp֐I
   if ( dwFlags & WILD_XP_STYLE ) {
      if ( dwFlags & WILD_SORT )         Data.CompareFunction = CompareStoredStringsNumericalW ;
      if ( dwFlags & WILD_SORT_REVERSE ) Data.CompareFunction = CompareStoredStringsNumericalRevW ;
   }
   else {
      if ( dwFlags & WILD_SORT )         Data.CompareFunction = CompareStoredStringsLocaleW ;
      if ( dwFlags & WILD_SORT_REVERSE ) Data.CompareFunction = CompareStoredStringsLocaleRevW ;
   }

   RegisterAbortFlag ( & Data.pAbortFlag ) ;
   WILDCARDW *Result = (WILDCARDW*) WILDCARD_ERROR ;
   __try {
      Result = DoSearchWildcardW ( Wildcard, szSearchPath, dwFlags, Callback, lParam, 0, & Data ) ;
   } __finally {
      UnregisterAbortFlag ( Data.pAbortFlag ) ;
   }

   return Result ;
}



// SearchWildcardW() ̉֐
// ċAĂяo
static WILDCARDW *DoSearchWildcardW ( WILDCARDW *Wildcard, const wchar_t *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const wchar_t *szSearchPath, WIN32_FIND_DATAW *FindData, int nDepth, LPARAM lParam ), LPARAM lParam, int nDepth, DATAW *pData ) {


   if ( Wildcard == WILDCARD_ERROR ) return (WILDCARDW*) WILDCARD_ERROR ;


   WIN32_FIND_DATAW *const pFindData = pData->pFindData ;
   int IsNoMoreSearchSub = 0 ;


   wchar_t *szFileName = wcsdup_expand ( szSearchPath, MAX_LONG_PATH, MAX_PATH + 1 ) ; // TufBNg \ 邽
   if ( ! szFileName ) {
      CloseWildcardW ( Wildcard ) ;
      return (WILDCARDW*) WILDCARD_ERROR ;
   }


   // ̃fBNg̃t@C
   HANDLE hFindFile = FindFirstFileW ( szSearchPath, pFindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {

      int IsFirst = 1 ;
      int IsErrorInLoop = 0 ;

      do {

#ifndef _CONSOLE
         if ( ! ( ++ pData->nCountAll & 0x7F ) ) {
            if ( dwFlags & WILD_PEEKMESSAGE ) PeekMessageProc ( pData->hDialog, pData->IsMessageUnicode ) ;
         }
#endif
         if ( IsAbortedW ( pData ) ) { IsErrorInLoop = 1 ; break ; }

         if ( ! wcscmp ( pFindData->cFileName, L"." ) || ! wcscmp ( pFindData->cFileName, L".." ) ) {
            if ( ! ( dwFlags & WILD_SEARCH_CURDIR ) ) continue ;
         }
         else {
            if ( pFindData->dwFileAttributes & ( FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM ) ) {
               if ( ! ( dwFlags & WILD_SEARCH_HIDDEN ) ) continue ;
            }
            if ( pFindData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
               if ( ! ( dwFlags & WILD_SEARCH_FOLDER ) ) continue ;
            }
            else {
               if ( ! ( dwFlags & WILD_SEARCH_FILE ) ) continue ;
            }
         }

         // Ot@CƃV[gt@ĈǂD
         wchar_t *szPriorName = ( dwFlags & WILD_SHORTNAME ) ? pFindData->cAlternateFileName : pFindData->cFileName ;
         wchar_t *szAlternateName = ( dwFlags & WILD_SHORTNAME ) ? pFindData->cFileName : pFindData->cAlternateFileName ;

         // Ot@CƃV[gt@C
         if ( ! *szPriorName && *szAlternateName ) szPriorName = szAlternateName ;

         // ̃fBNg
         if ( pFindData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
            if ( dwFlags & ( WILD_NO_EMPTY_DIR | WILD_ONLY_EMPTY_DIR ) ) {
               ChangeFileNameW ( szFileName, szPriorName ) ;
               if ( ( dwFlags & WILD_NO_EMPTY_DIR ) && ! IsHaveAnyFileW ( szFileName, dwFlags & WILD_SEARCH_HIDDEN, 1 ) ) continue ;
               if ( ( dwFlags & WILD_ONLY_EMPTY_DIR ) && IsHaveAnyFileW ( szFileName, dwFlags & WILD_SEARCH_HIDDEN, 0 ) ) continue ;
            }
         }

         // R[obN֐Ăяo
         if ( Callback ) {
            int nCallbackRetvalue = Callback ( szSearchPath, pFindData, nDepth, lParam ) ;
            if ( nCallbackRetvalue == 0 ) continue ;
            if ( nCallbackRetvalue < 0 ) { IsNoMoreSearchSub = 1 ; break ; }
         }

         // ChJ[h\̂̃m
         if ( ! Wildcard ) {
            Wildcard = (WILDCARDW*) malloc ( sizeof(WILDCARDW) ) ;
            if ( ! Wildcard ) { IsErrorInLoop = 1 ; break ; }
            memzero ( Wildcard, sizeof(WILDCARDW) ) ;
         }

         // fBNgo
         if ( IsFirst ) {
            IsFirst = 0 ;
            if ( ! ( dwFlags & WILD_NO_PIVOT_DIR ) ) {
               ChangeFileNameW ( szFileName, NULL ) ;
               if ( ! ( dwFlags & WILD_WITHPATH ) ) {
                  if ( ! *szFileName && Wildcard->StoredNames ) Wildcard->StoredNames = StoreStringsW ( Wildcard->StoredNames, L".\\" ) ;
                  else                                          Wildcard->StoredNames = StoreStringsW ( Wildcard->StoredNames, szFileName ) ;
                  if ( Wildcard->StoredNames == STOREDSTRINGS_ERROR ) { IsErrorInLoop = 1 ; break ; }
               }
            }
            MarkSortStartW ( Wildcard->StoredNames ) ;
         }

         // pXo͂ꍇ
         if ( dwFlags & WILD_WITHPATH ) {
            ChangeFileNameW ( szFileName, szPriorName ) ;
            // vt@Co
            Wildcard->StoredNames = StoreStringsW ( Wildcard->StoredNames, szFileName ) ;
         }
         // pXo͂Ȃꍇ
         else {
            // vt@Co
            Wildcard->StoredNames = StoreStringsW ( Wildcard->StoredNames, szPriorName ) ;
         }
         if ( Wildcard->StoredNames == STOREDSTRINGS_ERROR ) { IsErrorInLoop = 1 ; break ; }

      } while ( FindNextFileW ( hFindFile, pFindData ) ) ;

      FindClose ( hFindFile ) ;

      // G[܂͒~
      if ( IsErrorInLoop ) {
         CloseWildcardW ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDW*) WILDCARD_ERROR ;
      }

      // t@C\[g
      if ( Wildcard && pData->CompareFunction && SortStoredStringsW ( Wildcard->StoredNames, pData->CompareFunction ) ) {
         CloseWildcardW ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDW*) WILDCARD_ERROR ;
      }
   }



   // TufBNgAċAĂяosȂ
   if ( dwFlags & WILD_SEARCH_SUB && ! IsNoMoreSearchSub ) {

      ChangeFileNameW ( szFileName, L"*" ) ;

      unsigned long dwFlagsSub = WILD_SEARCH_FOLDER | WILD_NO_PIVOT_DIR | ( dwFlags & WILD_SHORTNAME ) ;
      if ( dwFlags & WILD_SEARCH_HIDDENSUB ) dwFlagsSub |= WILD_SEARCH_HIDDEN ;

      WILDCARDW *WildcardSub = DoSearchWildcardW ( NULL, szFileName, dwFlagsSub, NULL, 0, 0, pData ) ;

      if ( WildcardSub == WILDCARD_ERROR ) {
         CloseWildcardW ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDW*) WILDCARD_ERROR ;
      }

      // fBNg݂ꍇ
      if ( WildcardSub ) {

         for ( const wchar_t *szString = GetFirstFileW ( WildcardSub ) ; szString ; szString = GetNextFileW ( WildcardSub ) ) {

            wcscpy ( szFileName, szSearchPath ) ;
            ChangeFileNameW ( szFileName, szString ) ;
            wcscat ( szFileName, L"\\" ) ;
            wcscat ( szFileName, GetFileNameW ( szSearchPath ) ) ;

            // ċAĂяo
            Wildcard = DoSearchWildcardW ( Wildcard, szFileName, dwFlags, Callback, lParam, nDepth + 1, pData ) ;
            if ( Wildcard == WILDCARD_ERROR ) break ;
         }

         CloseWildcardW ( WildcardSub ) ;
      }
   }

   free ( szFileName ) ;
   return Wildcard ;
}



// t@Cobt@iUNICODEŁj
// SearchWildcard () gƂ̓vZX̏I܂łɕK CloseWildcard () Ăяo
void WINAPI CloseWildcardW ( WILDCARDW *Wildcard ) {
   if ( ! Wildcard || Wildcard == WILDCARD_ERROR ) return ;
   if ( Wildcard->StoredNames && Wildcard->StoredNames != STOREDSTRINGS_ERROR ) FreeStoredStringsW ( Wildcard->StoredNames ) ;
   free ( Wildcard ) ;
   return ;
}



// t@Cobt@̃t@ČԂiUNICODEŁj
size_t WINAPI GetFileCountW ( WILDCARDW *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == WILDCARD_ERROR ) return 0 ;
   return GetStringCountW ( Wildcard->StoredNames ) ;
}



// t@Cobt@ŏ̃t@CԂiUNICODEŁj
// t@CȂ΁ANULL Ԃ
const wchar_t *WINAPI GetFirstFileW ( WILDCARDW *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == WILDCARD_ERROR ) return NULL ;
   return GetFirstStringW ( Wildcard->StoredNames ) ;
}



// t@Cobt@玟̃t@CԂiUNICODEŁj
// t@CȂ΁ANULL Ԃ
// GetFirstFile () ĂяoOȂ΁A͕s
const wchar_t *WINAPI GetNextFileW ( WILDCARDW *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == WILDCARD_ERROR ) return NULL ;
   return GetNextStringW ( Wildcard->StoredNames ) ;
}



// t@CfBNgȂ 0 ȊOAȂ 0 Ԃ
static int IsHaveAnyFileW ( const wchar_t *szFileName, int IsSearchHidden, int IsExcludeDir ) {

   int nResult = 0 ;

   wchar_t *szSearchPath = wcsdup_expand ( szFileName, (size_t) -1, 8 ) ;
   if ( ! szSearchPath ) return nResult ;
   wcscat ( szSearchPath, L"\\*" ) ;

   WIN32_FIND_DATAW FindData ;

   HANDLE hFindFile = FindFirstFileW ( szSearchPath, & FindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {
      do {

         if ( IsExcludeDir && ( FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) continue ;
         if ( ! IsSearchHidden && FindData.dwFileAttributes & ( FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM ) ) continue ;
         if ( ! wcscmp ( FindData.cFileName, L"." ) || ! wcscmp ( FindData.cFileName, L".." ) ) continue ;

         nResult = 1 ;
         break ;

      } while ( FindNextFileW ( hFindFile, & FindData ) ) ;

      FindClose ( hFindFile ) ;
   }

   free ( szSearchPath ) ;

   return nResult ;
}



//////////////////////////////
//       PEEK MESSAGE       //
//////////////////////////////



#ifndef _CONSOLE



#define PeekMessageA PeekMessageA_
#define PeekMessageW PeekMessageW_
#define TranslateMessage TranslateMessage_
#define DispatchMessageA DispatchMessageA_
#define DispatchMessageW DispatchMessageW_
#define IsDialogMessageA IsDialogMessageA_
#define IsDialogMessageW IsDialogMessageW_

#define IsWindowUnicode IsWindowUnicode_
#define GetActiveWindow GetActiveWindow_
#define GetClassNameA GetClassNameA_
#define GetClassNameW GetClassNameW_

typedef BOOL ( WINAPI *PEEKMESSAGEA ) ( LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg ) ;
typedef BOOL ( WINAPI *PEEKMESSAGEW ) ( LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg ) ;
typedef BOOL ( WINAPI *TRANSLATEMESSAGE ) ( CONST MSG *lpMsg ) ;
typedef LRESULT ( WINAPI *DISPATCHMESSAGEA ) ( CONST MSG *lpMsg ) ;
typedef LRESULT ( WINAPI *DISPATCHMESSAGEW ) ( CONST MSG *lpMsg ) ;
typedef BOOL ( WINAPI *ISDIALOGMESSAGEA ) ( HWND hDlg, LPMSG lpMsg ) ;
typedef BOOL ( WINAPI *ISDIALOGMESSAGEW ) ( HWND hDlg, LPMSG lpMsg ) ;

typedef BOOL ( WINAPI *ISWINDOWUNICODE ) ( HWND hWnd ) ;
typedef HWND ( WINAPI *GETACTIVEWINDOW ) ( VOID ) ;
typedef int ( WINAPI *GETCLASSNAMEA ) ( HWND hWnd, LPSTR lpClassName, int nMaxCount ) ;
typedef int ( WINAPI *GETCLASSNAMEW ) ( HWND hWnd, LPWSTR lpClassName, int nMaxCount ) ;

static HINSTANCE        hUser32 ;
static PEEKMESSAGEA     PeekMessageA ;
static PEEKMESSAGEW     PeekMessageW ;
static TRANSLATEMESSAGE TranslateMessage ;
static DISPATCHMESSAGEA DispatchMessageA ;
static DISPATCHMESSAGEW DispatchMessageW ;
static ISDIALOGMESSAGEA IsDialogMessageA ;
static ISDIALOGMESSAGEW IsDialogMessageW ;

static ISWINDOWUNICODE  IsWindowUnicode ;
static GETACTIVEWINDOW  GetActiveWindow ;
static GETCLASSNAMEA    GetClassNameA ;
static GETCLASSNAMEW    GetClassNameW ;



static void __cdecl FreeUser32 ( void ) ;



// USER32.DLL [h
// EBhE hDialog  IsUnicode ݒ肷
// s 0 ȊOԂ
static int InitPeekMessage ( HWND *phDialog, int *pIsUnicode ) {

   static volatile int IsTried ;

   if ( ! IsTried ) {

#ifdef _MT
      EnterCriticalSection ( & LoadDllSection ) ;
      __try {
         if ( ! IsTried ) {
#endif
            HINSTANCE hDll ;
            if ( IsNT () ) hDll = LoadLibraryW ( L"USER32.DLL" ) ;
            else           hDll = LoadLibraryA (  "USER32.DLL" ) ;

            int IsError = 0 ;
            if ( GETPROCADDRESS ( hDll, PEEKMESSAGEA, PeekMessageA ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, PEEKMESSAGEW, PeekMessageW ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, TRANSLATEMESSAGE, TranslateMessage ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, DISPATCHMESSAGEA, DispatchMessageA ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, DISPATCHMESSAGEW, DispatchMessageW ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, ISDIALOGMESSAGEA, IsDialogMessageA ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, ISDIALOGMESSAGEW, IsDialogMessageW ) ) IsError = 1 ;

            if ( GETPROCADDRESS ( hDll, ISWINDOWUNICODE, IsWindowUnicode ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, GETACTIVEWINDOW, GetActiveWindow ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, GETCLASSNAMEA, GetClassNameA ) ) IsError = 1 ;
            if ( GETPROCADDRESS ( hDll, GETCLASSNAMEW, GetClassNameW ) ) IsError = 1 ;

            if ( IsError ) {
               FreeLibrary ( hDll ) ;
            }
            else {
               atexit ( FreeUser32 ) ;
               hUser32 = hDll ;
            }

            IsTried = 1 ;
#ifdef _MT
         }
      } __finally {
         LeaveCriticalSection ( & LoadDllSection ) ;
      }
#endif
   }


   if ( hUser32 ) {
      HWND hWnd = GetActiveWindow () ;
      if ( hWnd ) {
         if ( IsNT () ) {
            wchar_t szClassName [ MAX_PATH ] ;
            GetClassNameW ( hWnd, szClassName, MAX_PATH ) ;
            if ( ! wcscmp ( szClassName, L"#32770" ) ) *phDialog = hWnd ;
            else                                       *phDialog = NULL ;
         }
         else {
            char szClassName [ MAX_PATH ] ;
            GetClassNameA ( hWnd, szClassName, MAX_PATH ) ;
            if ( ! strcmp ( szClassName, "#32770" ) ) *phDialog = hWnd ;
            else                                      *phDialog = NULL ;
         }
         *pIsUnicode = IsWindowUnicode ( hWnd ) ;
      }
      else {
         *pIsUnicode = IsNT () ;
      }
   }

   return ( hUser32 ) ? 0 : 1 ;
}



// USER32.DLL 
static void __cdecl FreeUser32 ( void ) {
   if ( hUser32 ) FreeLibrary ( hUser32 ) ;
}



// bZ[W[v܂킷
static int PeekMessageProc ( HWND hDialog, int IsUnicode ) {

   MSG Msg ;

   if ( IsUnicode ) {
      while ( PeekMessageW ( & Msg, NULL, 0, 0, PM_REMOVE ) ) {
         if ( ! hDialog || ! IsDialogMessageW ( hDialog, & Msg ) ) {
            TranslateMessage ( & Msg ) ;
            DispatchMessageW ( & Msg ) ;
         }
      }
   }
   else {
      while ( PeekMessageA ( & Msg, NULL, 0, 0, PM_REMOVE ) ) {
         if ( ! hDialog || ! IsDialogMessageA ( hDialog, & Msg ) ) {
            TranslateMessage ( & Msg ) ;
            DispatchMessageA ( & Msg ) ;
         }
      }
   }

   return 0 ;
}



#endif



//////////////////////////////
//         ʊ֐         //
//////////////////////////////



#define ABORT_TABLE_SIZE      0x10

typedef struct ABORT_DATA_ {
   short AbortFlag [ ABORT_TABLE_SIZE ] ;
   volatile size_t ThreadCount [ ABORT_TABLE_SIZE ] ;
} ABORT_DATA ;

static ABORT_DATA AbortTable ;

static volatile size_t nCurrentIndex ;


#ifdef _MT
#ifdef _WIN64
static inline size_t INCREMENT_COUNTER ( volatile size_t *p ) { return InterlockedIncrement64 ( (LONGLONG*) p ) ; }
static inline size_t DECREMENT_COUNTER ( volatile size_t *p ) { return InterlockedDecrement64 ( (LONGLONG*) p ) ; }
#else
static inline size_t INCREMENT_COUNTER ( volatile size_t *p ) { return InterlockedIncrement ( (LONG*) p ) ; }
static inline size_t DECREMENT_COUNTER ( volatile size_t *p ) { return InterlockedDecrement ( (LONG*) p ) ; }
#endif
#else
#define INCREMENT_COUNTER(p)     ( ++ ( *(p) ) )
#define DECREMENT_COUNTER(p)     ( -- ( *(p) ) )
#endif



// ~tOe[uɓo^
static int RegisterAbortFlag ( volatile const short **pAbortFlagAddress ) {

   size_t nIndex = nCurrentIndex % (unsigned) ABORT_TABLE_SIZE ;

   INCREMENT_COUNTER ( & AbortTable.ThreadCount [ nIndex ] ) ;

   *pAbortFlagAddress = & AbortTable.AbortFlag [ nIndex ] ;

   return 0 ;
}



// ~tOe[uo^폜
static int UnregisterAbortFlag ( volatile const short *pAbortFlag ) {

   size_t nIndex = pAbortFlag - AbortTable.AbortFlag ;

   if ( nIndex < ABORT_TABLE_SIZE ) {
      if ( ! DECREMENT_COUNTER ( & AbortTable.ThreadCount [ nIndex ] ) ) AbortTable.AbortFlag [ nIndex ] = FALSE ;
      return 0 ;
   }

   return 1 ;
}



// ~tO ON ɂ
int WINAPI AbortWildcard ( void ) {

   size_t nIndex = nCurrentIndex % (unsigned) ABORT_TABLE_SIZE ;

   if ( AbortTable.ThreadCount [ nIndex ] ) {
      AbortTable.AbortFlag [ nIndex ] = TRUE ;
      INCREMENT_COUNTER ( & nCurrentIndex ) ;
   }

   return 0 ;
}



