// cjkctype.h

#ifndef CJKCTYPE_H
#define CJKCTYPE_H


#ifdef __cplusplus
extern "C" {
#endif


int ismbblead_cp ( int c, int codepage ) ;
int ismbbtrail_cp ( int c, int codepage ) ;
int ismbbkana_cp ( int c, int codepage ) ;
int ismbbsurrogate_cp ( int c, int codepage ) ;
int ismbcp ( int codepage ) ;


size_t mbslcpylen_cp ( char *dst, const char *src, size_t srclen, size_t bufsiz, int codepage ) ;
#define mbslcpy_cp(dst,src,bufsiz)     mbslcpylen_cp ( dst, src, (size_t) -1, bufsiz )

size_t mbslcat_cp ( char *dst, const char *src, size_t bufsiz, int codepage ) ;

size_t mbsreplace_cp ( char *string, const char *pattern, const char *replace, char **pnext, size_t max, int codepage ) ;


int mbsncmp_i_cp ( const char *string1, const char *string2, size_t count, int isignore, int codepage ) ;
// #define mbscmp_cp(s1,s2,cp)      mbsncmp_i_cp ( s1, s2, (size_t) -1, 0, cp )
#define mbsicmp_cp(s1,s2,cp)        mbsncmp_i_cp ( s1, s2, (size_t) -1, 1, cp )
// #define mbsncmp_cp(s1,s2,n,cp)   mbsncmp_i_cp ( s1, s2, n, 0, cp )
#define mbsnicmp_cp(s1,s2,n,cp)     mbsncmp_i_cp ( s1, s2, n, 1, cp )

int mbsrncmp_i_cp ( const char *string1, const char *string2, size_t count, int isignore, int codepage ) ;
#define mbsrcmp_cp(s1,s2,cp)        mbsncmp_i_cp ( s1, s2, (size_t) -1, 0, cp )
#define mbsricmp_cp(s1,s2,cp)       mbsncmp_i_cp ( s1, s2, (size_t) -1, 1, cp )
#define mbsrncmp_cp(s1,s2,n,cp)     mbsncmp_i_cp ( s1, s2, n, 0, cp )
#define mbsrnicmp_cp(s1,s2,n,cp)    mbsncmp_i_cp ( s1, s2, n, 1, cp )


int mbsheadcmp_i_cp ( const char *string1, const char *string2, int isignore, int codepage ) ;
#define mbsheadicmp_cp(s1,s2,cp)    mbsheadcmp_i_cp ( s1, s2, 1, cp )

int mbstailcmp_i_cp ( const char *string1, const char *string2, int isignore, int codepage ) ;
#define mbstailcmp_cp(s1,s2,cp)     mbstailcmp_i_cp ( s1, s2, 0, cp )
#define mbstailicmp_cp(s1,s2,cp)    mbstailcmp_i_cp ( s1, s2, 1, cp )

char *mbsstr_i_r_cp ( const char *string, const char *pattern, int isignore, int islast, int codepage ) ;
#define mbsstr_cp(s,p,cp)        mbsstr_i_r_cp   ( s, p, 0, 0, cp )
#define mbsstri_cp(s,p,cp)       mbsstr_i_r_cp   ( s, p, 1, 0, cp )
#define mbsrstr_cp(s,p,cp)       mbsstr_i_r_cp   ( s, p, 0, 1, cp )


char *mbschr_i_r_cp ( const char *string, int c, int isignore, int islast, int codepage ) ;
#define mbschr_cp(s,c,cp)        mbschr_i_r_cp   ( s, c, 0, 0, cp )
#define mbschri_cp(s,c,cp)       mbschr_i_r_cp   ( s, c, 1, 0, cp )
#define mbsrchr_cp(s,c,cp)       mbschr_i_r_cp   ( s, c, 0, 1, cp )
#define mbsrchri_cp(s,c,cp)      mbschr_i_r_cp   ( s, c, 1, 1, cp )


size_t mbsspn_cp ( const char *string, const char *keys, int codepage ) ;
size_t mbscspn_cp ( const char *string, const char *keys, int codepage ) ;

char *mbsspnp_cp ( const char *string, const char *keys, int codepage ) ;
char *mbspbrk_cp ( const char *string, const char *keys, int codepage ) ;

char *mbslwr_cp ( char *string, int codepage ) ;
char *mbsupr_cp ( char *string, int codepage ) ;

char *mbsrev_cp ( char *string, int codepage ) ;

char *mbstrunc_cp ( char *string, size_t length, int codepage ) ;

size_t mbslen_cp ( const char *string, int codepage ) ;

char *mbsldup_cp ( const char *string, size_t bufsiz, int codepage ) ;

int mbsbtype_cp ( const char *string, size_t count, int codepage ) ;
int ismbslead_cp ( const char *string, const char *current, int codepage ) ;
int ismbstrail_cp ( const char *string, const char *current, int codepage ) ;

int jmstojis ( int c ) ;
int jistojms ( int c ) ;


#define ismbblead_sjis(c)     ismbblead_cp ( c, CP_JAPANESE )
#define ismbblead_gb(c)       ismbblead_cp ( c, CP_CHINESE_SIMPLIFIED )
#define ismbblead_big5(c)     ismbblead_cp ( c, CP_CHINESE_TRADITIONAL )
#define ismbblead_ks(c)       ismbblead_cp ( c, CP_KOREAN )
#define ismbblead_johab(c)    ismbblead_cp ( c, CP_KOREAN_JOHAB )

#define ismbbtrail_sjis(c)    ismbbtrail_cp ( c, CP_JAPANESE )
#define ismbbtrail_gb(c)      ismbbtrail_cp ( c, CP_CHINESE_SIMPLIFIED )
#define ismbbtrail_big5(c)    ismbbtrail_cp ( c, CP_CHINESE_TRADITIONAL )
#define ismbbtrail_ks(c)      ismbbtrail_cp ( c, CP_KOREAN )
#define ismbbtrail_johab(c)   ismbbtrail_cp ( c, CP_KOREAN_JOHAB )

#define ismbbkana_sjis(c)     ismbbkana_cp ( c, CP_JAPANESE )
#define ismbbsurrogate_gbx(c) ismbbsurrogate_cp ( c, CP_CHINESE_SIMPLIFIED_EX )


#ifdef __cplusplus
}
#endif



#if defined DEBUG_CONST_STRING && defined __cplusplus    // for debug

#define FUNC_STR_STR(func) \
   static inline const char *func##_ ( const char *s1, const char *s2, int cp ) { return func ( s1, s2, cp ) ; } \
   static inline       char *func##_ (       char *s1, const char *s2, int cp ) { return func ( s1, s2, cp ) ; }

#define FUNC_STR_STR_INT_INT(func)  \
   static inline const char *func##_ ( const char *s1, const char *s2, int n1, int n2, int cp ) { return func ( s1, s2, n1, n2, cp ) ; } \
   static inline       char *func##_ (       char *s1, const char *s2, int n1, int n2, int cp ) { return func ( s1, s2, n1, n2, cp ) ; }

#define FUNC_STR_INT_INT_INT(func)  \
   static inline const char *func##_ ( const char *s, int c, int n1, int n2, int cp ) { return func ( s, c, n1, n2, cp ) ; } \
   static inline       char *func##_ (       char *s, int c, int n1, int n2, int cp ) { return func ( s, c, n1, n2, cp ) ; }

FUNC_STR_STR_INT_INT ( mbsstr_i_r_cp )
FUNC_STR_INT_INT_INT ( mbschr_i_r_cp )

FUNC_STR_STR ( mbsspnp_cp )
FUNC_STR_STR ( mbspbrk_cp )

#undef FUNC_STR_STR
#undef FUNC_STR_STR_INT_INT
#undef FUNC_STR_INT_INT_INT

#define mbsstr_i_r_cp   mbsstr_i_r_cp_
#define mbschr_i_r_cp   mbschr_i_r_cp_
#define mbsspnp_cp      mbsspnp_cp_
#define mbspbrk_cp      mbspbrk_cp_

#endif // defined DEBUG_CONST_STRING && defined __cplusplus



#endif


