// conv_tbl.h

#ifndef CONV_TBL_H
#define CONV_TBL_H



////////////////////////////////////////
//             BIG5 <-> GB            //
////////////////////////////////////////


// big52gb
const unsigned short *Big52gbTable ( int C ) ;
int Big52gb_Gb2312 ( int C ) ;
int Big52cw_NoGbOnly ( int C ) ;
int Big52cwn_NoGbOnly ( int C ) ;

// gb2big5
const unsigned short *Gb2big5Table ( int C ) ;



////////////////////////////////////////
//             CW <-> GB              //
////////////////////////////////////////


// cw2gb
const unsigned short *Cw2gbTable ( int C ) ;
extern const unsigned short CwOneByteCharToGb_0080_00FF [] ;
extern const unsigned short CwOneByteCharToUnicode_0080_00FF [] ;

// kg2gb
const unsigned short *Kg2gbTable ( int C ) ;
int Kg2uc_NoGbOnly ( int C ) ;

// gb2cw
const unsigned short *Gb2cwTable ( int C ) ;
const char *GetGbDecomposedForm ( int cGb ) ;



////////////////////////////////////////
//             CW <-> CWN             //
////////////////////////////////////////


// cw2cwn
const unsigned short *Cw2cwnTable ( int C ) ;

// cwn2cw
const unsigned short *Cwn2cwTable ( int C ) ;
extern const unsigned short Cwn2cwTable_NoFanti_F5 [] ;
extern const unsigned short Cwn2cwTable_NoFanti_F6 [] ;
int Cwn2gb_NoCwOnly ( int C ) ;
int Gb2cwn_NoCwOnly ( int C ) ;
int Cwn2uc_NoCwOnly ( int C ) ;
int Cwn2uc_NoGbOnly ( int C ) ;
int Cwn2gbFanti_NoCwOnly ( int C ) ;



////////////////////////////////////////
//             CW <-> NH              //
////////////////////////////////////////


// cw2nh
const unsigned short *Cw2nhTable ( int C ) ;
extern const unsigned short Cw2nhOneByteChar_0080_00FF [] ;
extern const unsigned short Cw2nhOneByteCharNh3_0080_00FF [] ;

// nh2cw
const unsigned short *Nh2cwTable ( int C ) ;
extern const unsigned short Nh2cwOneByteChar_0000_007F [] ;
extern const unsigned short Nh2cwOneByteCharNh3_0000_007F [] ;
int Nh2gb_NoCwOnly ( int C ) ;
int Gb2nh_NoCwOnly ( int C ) ;



////////////////////////////////////////
//             CW <-> ZQ              //
////////////////////////////////////////


// cw2zq
const unsigned short *Cw2zqTable ( int C ) ;
extern const unsigned short Cw2zqOneByteChar_0080_00FF [] ;

// zq2cw
const unsigned short *Zq2cwTable ( int C ) ;
extern const unsigned short Zq2cwOneByteChar_0080_00FF [] ;



////////////////////////////////////////
//             CW <-> CX              //
////////////////////////////////////////


// cw2cx
const unsigned short *Cw2cxTable ( int C ) ;
extern const unsigned short Cw2cxOneByteChar_0080_00FF [] ;

// cx2cw
const unsigned short *Cx2cwTable ( int C ) ;
extern const unsigned short Cx2cwOneByteChar_0080_00FF [] ;
int Cx2gb_NoCwOnly ( int C ) ;
int Gb2cx_NoCwOnly ( int C ) ;
int Cx2big5_NoCwOnly ( int C ) ;
int Big52cx_NoCwOnly ( int C ) ;



////////////////////////////////////////
//             CW <-> ZJ              //
////////////////////////////////////////


// cw2zj
const unsigned short *Cw2zjTable ( int C ) ;
extern const unsigned short Cw2zjOneByteChar_0080_00FF [] ;

// zj2cw
const unsigned short *Zj2cwTable ( int C ) ;



////////////////////////////////////////
//             TM <-> CW              //
////////////////////////////////////////


// tm2cw
const unsigned short *Tm2cwTable ( int C ) ;
int Tm2gb_NoCwOnly ( int C ) ;
extern const unsigned short Tm2cwOneByteChar_0080_00FF [] ;
extern const unsigned short TmKeisenToSjis [] ;
extern const unsigned short Nec2sjisTable_85 [] ;
extern const unsigned short Nec2sjisTable_86 [] ;
extern const unsigned short TmHanHiraToZenHira_0080_00FF [] ;

// tm2uni
const unsigned short *GetTm2uniTable ( const char *szFontName ) ;
const unsigned short *GetTm2uniTableEx ( int nIndex ) ;



////////////////////////////////////////
//                SJIS                //
////////////////////////////////////////


// sjismac.h
const unsigned short *Sjis2uniTable_Mac ( int C ) ;
int Sjis2uni_Mac_SingleByte ( int cSjis, int cUnicode ) ;
const wchar_t *Sjis2uni_Mac_Composition ( int cSjis ) ;
const unsigned short *Uni2sjisTable_Mac ( int C ) ;

// sjisnec.h
const unsigned short *SjisNec2ibmTable ( int C ) ;
const unsigned short *SjisIbm2necTable ( int C ) ;

// sjisorg.h
const unsigned short *Sjis2uniTable_Org ( int C ) ;
int Sjis2uni_Org_SingleByte ( int cSjis, int cUnicode ) ;
const unsigned short *Uni2sjisTable_Org ( int C ) ;



////////////////////////////////////////
//               SYMBOL               //
////////////////////////////////////////


// sym2uni.h
extern const unsigned short SymbolToUnicodeTable [] ;
extern const unsigned short WingdingsToUnicodeTable [] ;
extern const unsigned short SilIpaToUnicodeTable [] ;
extern const unsigned short SilIpa93ToUnicodeTable [] ;
extern const unsigned short GalatiaToUnicodeTable [] ;
extern const unsigned short GalatiaExToUnicodeTable [] ;
extern const unsigned short GreekTransToUnicodeTableMain [] ;
extern const unsigned short DaiBannaToUnicodeTable [] ;
extern const unsigned short ApparatusToUnicodeTable [] ;
extern const unsigned short HebTransToUnicodeTableMain [] ;
extern const unsigned short HebTransCapsToUnicodeTableMain [] ;
extern const unsigned short IpaphonToUnicodeTable [] ;
extern const unsigned short IpasamToUnicodeTable [] ;
extern const unsigned short TimesNewRomanPhoneticMacToUnicodeTable [] ;
extern const unsigned short SgreekToUnicodeTableMain [] ;
extern const unsigned short SpionicToUnicodeTableMain [] ;
extern const unsigned short WinGreekToUnicodeTable [] ;
extern const unsigned short AthenianToUnicodeTable [] ;
extern const unsigned short MounceToUnicodeTable [] ;
extern const unsigned short TekniaGreekToUnicodeTableMain [] ;
extern const unsigned short MidEastTimesToUnicodeTable [] ;
extern const unsigned short VnTimesToUnicodeTable [] ;
extern const unsigned short CirilicaToUnicodeTable [] ;

extern const unsigned short GreekTransToUnicodeTableSub [] ;
extern const unsigned short HebTransToUnicodeTableSub [] ;
extern const unsigned short HebTransCapsToUnicodeTableSub [] ;
extern const unsigned short SgreekToUnicodeTableSub [] ;
extern const unsigned short SpionicToUnicodeTableSub [] ;
extern const unsigned short TekniaGreekToUnicodeTableSub [] ;

#ifdef RTFCONV_DLL
int CharToUnicode_external ( int C, int nCodePage, unsigned long dwConversionMode ) ;
int UnicodeToChar_external ( int C, int nCodePage, unsigned long dwConversionMode ) ;
#endif
int TimesNewRomanPhoneticToUnicode ( int nCodePage, int C, unsigned long dwConversionMode ) ;



#endif
