// gbx.cpp

#include <stdlib.h>
#include "msc.h"
#include "gbx.h"
#include "gbxrange.h"



#define MAKE_GBXSCALAR(high,low)    ( ( ( ((high)/0x100-0x81)*10 + ((high)%0x100-0x30) ) * ( (0xFF-0x81)*10 ) + ((low)/0x100-0x81)*10 + ((low)%0x100-0x30) ) + 0x10000 )
#define GBXSCALAR_MAX   MAKE_GBXSCALAR ( 0xFE39, 0xFE39 )


static int __cdecl Compare ( const void *pKey, const void *pArray ) ;



// GB18030 Unicode ֕ϊ
//  cGbx ɂ́APoCg̏ꍇA"20"̃oCgȂ΁A0x20w
//                 QoCg̏ꍇA"FE-50"̃oCgȂ΁A0xFE50w
//                 SoCg̏ꍇA"81-30-81-31"̃oCgȂ΁A0x81308131w
// Ԃl Unicode iScalarlj
// ϊłȂƂ 0 Ԃ
int GbxToUnicode ( unsigned int cGbx ) {

   int nScalar ;     // GBX  Scalar l

   // GBX Surrogates
   if ( cGbx >= 0x10000 ) {
      int cFirstWord = cGbx >> 16 ;
      int cSecondWord = cGbx & 0xFFFF ;

      // Invalid
      if ( ( cFirstWord >> 8 ) < 0x81 || ( cFirstWord >> 8 ) > 0xFE ) return 0 ;
      if ( ( cFirstWord & 0xFF ) < 0x30 || ( cFirstWord & 0xFF ) > 0x39 ) return 0 ;
      if ( ( cSecondWord >> 8 ) < 0x81 || ( cSecondWord >> 8 ) > 0xFE ) return 0 ;
      if ( ( cSecondWord & 0xFF ) < 0x30 || ( cSecondWord & 0xFF ) > 0x39 ) return 0 ;

      int nPlaneStartScalar = ( ( cFirstWord >> 8 ) - 0x81 ) * 10 + ( ( cFirstWord & 0xFF ) - 0x30 ) ;
      int nScalarInPlane = ( ( cSecondWord >> 8 ) - 0x81 ) * 10 + ( ( cSecondWord & 0xFF ) - 0x30 ) ;
      nScalar = nPlaneStartScalar * ( ( 0xFF - 0x81 ) * 10 ) + nScalarInPlane + 0x10000 ;
   }
   // GBX BMP
   else {
      nScalar = cGbx ;
   }

   // Non BMP
   if ( nScalar >= MAKE_GBXSCALAR(0x9030,0x8130) ) {
      return nScalar - MAKE_GBXSCALAR(0x9030,0x8130) + 0x10000 ;
   }

   // BMP
   const GBX_RANGE *pGbx2UniRange = (const GBX_RANGE*) bsearch ( & nScalar, Gbx2UniRange, sizeof(Gbx2UniRange)/sizeof(GBX_RANGE), sizeof(GBX_RANGE), Compare ) ;
   if ( pGbx2UniRange ) return ( pGbx2UniRange->Base ) + ( nScalar - pGbx2UniRange->Start ) ;

   // GBK
   return 0 ;
}



// Unicode  GB18030 ֕ϊ
//  cUnicode ̓XJ[lw
// Ԃl GB18030 i"81-30-81-31"̃oCgȂ΁A0x81308131Ԃj
// ϊłȂƂ 0 Ԃ
unsigned int UnicodeToGbx ( int cUnicode ) {

   int nScalar ;     // GBX  Scalar l

   // Invalid
   if ( cUnicode < 0 ) return 0 ;

   // Surrogates
   if ( cUnicode >= 0x10000 ) {
      nScalar = cUnicode - 0x10000 + MAKE_GBXSCALAR(0x9030,0x8130) ;
   }
   // BMP
   else {
      nScalar = 0 ;
      const GBX_RANGE *pUni2GbxRange = (const GBX_RANGE*) bsearch ( & cUnicode, Uni2GbxRange, sizeof(Uni2GbxRange)/sizeof(GBX_RANGE), sizeof(GBX_RANGE), Compare ) ;
      if ( pUni2GbxRange ) nScalar = ( pUni2GbxRange->Base ) + ( cUnicode - pUni2GbxRange->Start ) ;
   }

   // GBK or Invalid
   if ( nScalar <= 0 ) return 0 ;

   // GBX BMP
   if ( nScalar < 0x10000 ) return nScalar ;

   // GBX Surrogates
   if ( nScalar > GBXSCALAR_MAX ) return 0 ;

   nScalar -= 0x10000 ;
   int nPlaneStartScalar = (unsigned) nScalar / ( ( 0xFF - 0x81 ) * 10 ) ;
   int nScalarInPlane = (unsigned) nScalar % ( ( 0xFF - 0x81 ) * 10 ) ;
   int cFirstWord = ( (unsigned) nPlaneStartScalar / 10 ) * 0x100 + ( (unsigned) nPlaneStartScalar % 10 ) + 0x8130 ;
   int cSecondWord = ( (unsigned) nScalarInPlane / 10 ) * 0x100 + ( (unsigned) nScalarInPlane % 10 ) + 0x8130 ;

   return ( cFirstWord << 16 ) + cSecondWord ;
}



// oCi[T[`p̔r֐
static int __cdecl Compare ( const void *pKey, const void *pArray ) {
   if ( ( * (int*) pKey ) < ( ( (GBX_RANGE*) pArray )->Start ) ) return -1 ;
   if ( ( * (int*) pKey ) > ( ( (GBX_RANGE*) pArray )->End ) ) return 1 ;
   return 0 ;
}



