// htmlcr.cpp

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "msc.h"
#include "htmlcr.h"



typedef struct {
   int nCode ;
   const char *szName ;
} CHARACTER_NAME ;



// HtmlCharRefToUnicode pr֐
static int __cdecl HtmlCharRefNameCmp ( const void *pKey, const void *pArray ) {
   return strcmp ( (const char*) pKey, ((CHARACTER_NAME*) pArray )->szName ) ;
}



// HTML̕GeBeB Unicode ɕϊ
//  ; ܂߂Ȃ
// ϊłȂ EOF Ԃ
int HtmlCharRefToUnicode ( const char *szCharRef ) {


   static const CHARACTER_NAME HtmlCharRefList [] = {
      { 0x00C6,   "AElig" },
      { 0x00C1,   "Aacute" },
      { 0x00C2,   "Acirc" },
      { 0x00C0,   "Agrave" },
      { 0x0391,   "Alpha" },
      { 0x00C5,   "Aring" },
      { 0x00C3,   "Atilde" },
      { 0x00C4,   "Auml" },
      { 0x0392,   "Beta" },
      { 0x00C7,   "Ccedil" },
      { 0x03A7,   "Chi" },
      { 0x2021,   "Dagger" },
      { 0x0394,   "Delta" },
      { 0x00D0,   "ETH" },
      { 0x00C9,   "Eacute" },
      { 0x00CA,   "Ecirc" },
      { 0x00C8,   "Egrave" },
      { 0x0395,   "Epsilon" },
      { 0x0397,   "Eta" },
      { 0x00CB,   "Euml" },
      { 0x0393,   "Gamma" },
      { 0x00CD,   "Iacute" },
      { 0x00CE,   "Icirc" },
      { 0x00CC,   "Igrave" },
      { 0x0399,   "Iota" },
      { 0x00CF,   "Iuml" },
      { 0x039A,   "Kappa" },
      { 0x039B,   "Lambda" },
      { 0x039C,   "Mu" },
      { 0x00D1,   "Ntilde" },
      { 0x039D,   "Nu" },
      { 0x0152,   "OElig" },
      { 0x00D3,   "Oacute" },
      { 0x00D4,   "Ocirc" },
      { 0x00D2,   "Ograve" },
      { 0x03A9,   "Omega" },
      { 0x039F,   "Omicron" },
      { 0x00D8,   "Oslash" },
      { 0x00D5,   "Otilde" },
      { 0x00D6,   "Ouml" },
      { 0x03A6,   "Phi" },
      { 0x03A0,   "Pi" },
      { 0x2033,   "Prime" },
      { 0x03A8,   "Psi" },
      { 0x03A1,   "Rho" },
      { 0x0160,   "Scaron" },
      { 0x03A3,   "Sigma" },
      { 0x00DE,   "THORN" },
      { 0x03A4,   "Tau" },
      { 0x0398,   "Theta" },
      { 0x00DA,   "Uacute" },
      { 0x00DB,   "Ucirc" },
      { 0x00D9,   "Ugrave" },
      { 0x03A5,   "Upsilon" },
      { 0x00DC,   "Uuml" },
      { 0x039E,   "Xi" },
      { 0x00DD,   "Yacute" },
      { 0x0178,   "Yuml" },
      { 0x0396,   "Zeta" },
      { 0x00E1,   "aacute" },
      { 0x00E2,   "acirc" },
      { 0x00B4,   "acute" },
      { 0x00E6,   "aelig" },
      { 0x00E0,   "agrave" },
      { 0x2135,   "alefsym" },
      { 0x03B1,   "alpha" },
      { 0x0026,   "amp" },
      { 0x2227,   "and" },
      { 0x2220,   "ang" },
      { 0x00E5,   "aring" },
      { 0x2248,   "asymp" },
      { 0x00E3,   "atilde" },
      { 0x00E4,   "auml" },
      { 0x201E,   "bdquo" },
      { 0x03B2,   "beta" },
      { 0x00A6,   "brvbar" },
      { 0x2022,   "bull" },
      { 0x2229,   "cap" },
      { 0x00E7,   "ccedil" },
      { 0x00B8,   "cedil" },
      { 0x00A2,   "cent" },
      { 0x03C7,   "chi" },
      { 0x02C6,   "circ" },
      { 0x2663,   "clubs" },
      { 0x2245,   "cong" },
      { 0x00A9,   "copy" },
      { 0x21B5,   "crarr" },
      { 0x222A,   "cup" },
      { 0x00A4,   "curren" },
      { 0x21D3,   "dArr" },
      { 0x2020,   "dagger" },
      { 0x2193,   "darr" },
      { 0x00B0,   "deg" },
      { 0x03B4,   "delta" },
      { 0x2666,   "diams" },
      { 0x00F7,   "divide" },
      { 0x00E9,   "eacute" },
      { 0x00EA,   "ecirc" },
      { 0x00E8,   "egrave" },
      { 0x2205,   "empty" },
      { 0x2003,   "emsp" },
      { 0x2002,   "ensp" },
      { 0x03B5,   "epsilon" },
      { 0x2261,   "equiv" },
      { 0x03B7,   "eta" },
      { 0x00F0,   "eth" },
      { 0x00EB,   "euml" },
      { 0x20AC,   "euro" },
      { 0x2203,   "exist" },
      { 0x0192,   "fnof" },
      { 0x2200,   "forall" },
      { 0x00BD,   "frac12" },
      { 0x00BC,   "frac14" },
      { 0x00BE,   "frac34" },
      { 0x2044,   "frasl" },
      { 0x03B3,   "gamma" },
      { 0x2265,   "ge" },
      { 0x003E,   "gt" },
      { 0x21D4,   "hArr" },
      { 0x2194,   "harr" },
      { 0x2665,   "hearts" },
      { 0x2026,   "hellip" },
      { 0x00ED,   "iacute" },
      { 0x00EE,   "icirc" },
      { 0x00A1,   "iexcl" },
      { 0x00EC,   "igrave" },
      { 0x2111,   "image" },
      { 0x221E,   "infin" },
      { 0x222B,   "int" },
      { 0x03B9,   "iota" },
      { 0x00BF,   "iquest" },
      { 0x2208,   "isin" },
      { 0x00EF,   "iuml" },
      { 0x03BA,   "kappa" },
      { 0x21D0,   "lArr" },
      { 0x03BB,   "lambda" },
      { 0x2329,   "lang" },
      { 0x00AB,   "laquo" },
      { 0x2190,   "larr" },
      { 0x2308,   "lceil" },
      { 0x201C,   "ldquo" },
      { 0x2264,   "le" },
      { 0x230A,   "lfloor" },
      { 0x2217,   "lowast" },
      { 0x25CA,   "loz" },
      { 0x200E,   "lrm" },
      { 0x2039,   "lsaquo" },
      { 0x2018,   "lsquo" },
      { 0x003C,   "lt" },
      { 0x00AF,   "macr" },
      { 0x2014,   "mdash" },
      { 0x00B5,   "micro" },
      { 0x00B7,   "middot" },
      { 0x2212,   "minus" },
      { 0x03BC,   "mu" },
      { 0x2207,   "nabla" },
      { 0x00A0,   "nbsp" },
      { 0x2013,   "ndash" },
      { 0x2260,   "ne" },
      { 0x220B,   "ni" },
      { 0x00AC,   "not" },
      { 0x2209,   "notin" },
      { 0x2284,   "nsub" },
      { 0x00F1,   "ntilde" },
      { 0x03BD,   "nu" },
      { 0x00F3,   "oacute" },
      { 0x00F4,   "ocirc" },
      { 0x0153,   "oelig" },
      { 0x00F2,   "ograve" },
      { 0x203E,   "oline" },
      { 0x03C9,   "omega" },
      { 0x03BF,   "omicron" },
      { 0x2295,   "oplus" },
      { 0x2228,   "or" },
      { 0x00AA,   "ordf" },
      { 0x00BA,   "ordm" },
      { 0x00F8,   "oslash" },
      { 0x00F5,   "otilde" },
      { 0x2297,   "otimes" },
      { 0x00F6,   "ouml" },
      { 0x00B6,   "para" },
      { 0x2202,   "part" },
      { 0x2030,   "permil" },
      { 0x22A5,   "perp" },
      { 0x03C6,   "phi" },
      { 0x03C0,   "pi" },
      { 0x03D6,   "piv" },
      { 0x00B1,   "plusmn" },
      { 0x00A3,   "pound" },
      { 0x2032,   "prime" },
      { 0x220F,   "prod" },
      { 0x221D,   "prop" },
      { 0x03C8,   "psi" },
      { 0x0022,   "quot" },
      { 0x21D2,   "rArr" },
      { 0x221A,   "radic" },
      { 0x232A,   "rang" },
      { 0x00BB,   "raquo" },
      { 0x2192,   "rarr" },
      { 0x2309,   "rceil" },
      { 0x201D,   "rdquo" },
      { 0x211C,   "real" },
      { 0x00AE,   "reg" },
      { 0x230B,   "rfloor" },
      { 0x03C1,   "rho" },
      { 0x200F,   "rlm" },
      { 0x203A,   "rsaquo" },
      { 0x2019,   "rsquo" },
      { 0x201A,   "sbquo" },
      { 0x0161,   "scaron" },
      { 0x22C5,   "sdot" },
      { 0x00A7,   "sect" },
      { 0x00AD,   "shy" },
      { 0x03C3,   "sigma" },
      { 0x03C2,   "sigmaf" },
      { 0x223C,   "sim" },
      { 0x2660,   "spades" },
      { 0x2282,   "sub" },
      { 0x2286,   "sube" },
      { 0x2211,   "sum" },
      { 0x2283,   "sup" },
      { 0x00B9,   "sup1" },
      { 0x00B2,   "sup2" },
      { 0x00B3,   "sup3" },
      { 0x2287,   "supe" },
      { 0x00DF,   "szlig" },
      { 0x03C4,   "tau" },
      { 0x2234,   "there4" },
      { 0x03B8,   "theta" },
      { 0x03D1,   "thetasym" },
      { 0x2009,   "thinsp" },
      { 0x00FE,   "thorn" },
      { 0x02DC,   "tilde" },
      { 0x00D7,   "times" },
      { 0x2122,   "trade" },
      { 0x21D1,   "uArr" },
      { 0x00FA,   "uacute" },
      { 0x2191,   "uarr" },
      { 0x00FB,   "ucirc" },
      { 0x00F9,   "ugrave" },
      { 0x00A8,   "uml" },
      { 0x03D2,   "upsih" },
      { 0x03C5,   "upsilon" },
      { 0x00FC,   "uuml" },
      { 0x2118,   "weierp" },
      { 0x03BE,   "xi" },
      { 0x00FD,   "yacute" },
      { 0x00A5,   "yen" },
      { 0x00FF,   "yuml" },
      { 0x03B6,   "zeta" },
      { 0x200D,   "zwj" },
      { 0x200C,   "zwnj" },
   } ;

   static const int HTML_CHARREF_LIST_NELEM = NELEMOF ( HtmlCharRefList ) ;


   if ( *szCharRef == '&' ) szCharRef ++ ;

   // numeric
   if ( *szCharRef == '#' ) {
      szCharRef ++ ;
      if ( tolower ( *szCharRef ) == 'x' ) {
         szCharRef ++ ;
         if ( isascii ( *szCharRef ) && isxdigit ( *szCharRef ) ) return strtoul ( szCharRef, NULL, 0x10 ) ;
      }
      else {
         if ( isascii ( *szCharRef ) && isdigit ( *szCharRef ) ) return strtoul ( szCharRef, NULL, 10 ) ;
      }
      return EOF ;
   }

   // name
   const CHARACTER_NAME *pResult = (const CHARACTER_NAME*) bsearch ( szCharRef, HtmlCharRefList, HTML_CHARREF_LIST_NELEM, sizeof(CHARACTER_NAME), HtmlCharRefNameCmp ) ;
   if ( ! pResult ) return EOF ;

   return pResult->nCode ;
}



// UnicodeToHtmlCharRef pr֐
static int __cdecl HtmlCharRefCharCmp ( const void *pKey, const void *pArray ) {
   if ( ( * (int*) pKey ) < ( ( (CHARACTER_NAME*) pArray )->nCode ) ) return -1 ;
   if ( ( * (int*) pKey ) > ( ( (CHARACTER_NAME*) pArray )->nCode ) ) return 1 ;
   return 0 ;
}



// Unicode  HTML ̕GeBeBɕϊ
// ϊłȂ NULL Ԃ
const char *UnicodeToHtmlCharRef ( int C ) {


   static const CHARACTER_NAME HtmlCharRefList [] = {
      { 0x0022,   "&quot;" },
      { 0x0026,   "&amp;" },
      { 0x003C,   "&lt;" },
      { 0x003E,   "&gt;" },
      { 0x00A0,   "&nbsp;" },
      { 0x00A1,   "&iexcl;" },
      { 0x00A2,   "&cent;" },
      { 0x00A3,   "&pound;" },
      { 0x00A4,   "&curren;" },
      { 0x00A5,   "&yen;" },
      { 0x00A6,   "&brvbar;" },
      { 0x00A7,   "&sect;" },
      { 0x00A8,   "&uml;" },
      { 0x00A9,   "&copy;" },
      { 0x00AA,   "&ordf;" },
      { 0x00AB,   "&laquo;" },
      { 0x00AC,   "&not;" },
      { 0x00AD,   "&shy;" },
      { 0x00AE,   "&reg;" },
      { 0x00AF,   "&macr;" },
      { 0x00B0,   "&deg;" },
      { 0x00B1,   "&plusmn;" },
      { 0x00B2,   "&sup2;" },
      { 0x00B3,   "&sup3;" },
      { 0x00B4,   "&acute;" },
      { 0x00B5,   "&micro;" },
      { 0x00B6,   "&para;" },
      { 0x00B7,   "&middot;" },
      { 0x00B8,   "&cedil;" },
      { 0x00B9,   "&sup1;" },
      { 0x00BA,   "&ordm;" },
      { 0x00BB,   "&raquo;" },
      { 0x00BC,   "&frac14;" },
      { 0x00BD,   "&frac12;" },
      { 0x00BE,   "&frac34;" },
      { 0x00BF,   "&iquest;" },
      { 0x00C0,   "&Agrave;" },
      { 0x00C1,   "&Aacute;" },
      { 0x00C2,   "&Acirc;" },
      { 0x00C3,   "&Atilde;" },
      { 0x00C4,   "&Auml;" },
      { 0x00C5,   "&Aring;" },
      { 0x00C6,   "&AElig;" },
      { 0x00C7,   "&Ccedil;" },
      { 0x00C8,   "&Egrave;" },
      { 0x00C9,   "&Eacute;" },
      { 0x00CA,   "&Ecirc;" },
      { 0x00CB,   "&Euml;" },
      { 0x00CC,   "&Igrave;" },
      { 0x00CD,   "&Iacute;" },
      { 0x00CE,   "&Icirc;" },
      { 0x00CF,   "&Iuml;" },
      { 0x00D0,   "&ETH;" },
      { 0x00D1,   "&Ntilde;" },
      { 0x00D2,   "&Ograve;" },
      { 0x00D3,   "&Oacute;" },
      { 0x00D4,   "&Ocirc;" },
      { 0x00D5,   "&Otilde;" },
      { 0x00D6,   "&Ouml;" },
      { 0x00D7,   "&times;" },
      { 0x00D8,   "&Oslash;" },
      { 0x00D9,   "&Ugrave;" },
      { 0x00DA,   "&Uacute;" },
      { 0x00DB,   "&Ucirc;" },
      { 0x00DC,   "&Uuml;" },
      { 0x00DD,   "&Yacute;" },
      { 0x00DE,   "&THORN;" },
      { 0x00DF,   "&szlig;" },
      { 0x00E0,   "&agrave;" },
      { 0x00E1,   "&aacute;" },
      { 0x00E2,   "&acirc;" },
      { 0x00E3,   "&atilde;" },
      { 0x00E4,   "&auml;" },
      { 0x00E5,   "&aring;" },
      { 0x00E6,   "&aelig;" },
      { 0x00E7,   "&ccedil;" },
      { 0x00E8,   "&egrave;" },
      { 0x00E9,   "&eacute;" },
      { 0x00EA,   "&ecirc;" },
      { 0x00EB,   "&euml;" },
      { 0x00EC,   "&igrave;" },
      { 0x00ED,   "&iacute;" },
      { 0x00EE,   "&icirc;" },
      { 0x00EF,   "&iuml;" },
      { 0x00F0,   "&eth;" },
      { 0x00F1,   "&ntilde;" },
      { 0x00F2,   "&ograve;" },
      { 0x00F3,   "&oacute;" },
      { 0x00F4,   "&ocirc;" },
      { 0x00F5,   "&otilde;" },
      { 0x00F6,   "&ouml;" },
      { 0x00F7,   "&divide;" },
      { 0x00F8,   "&oslash;" },
      { 0x00F9,   "&ugrave;" },
      { 0x00FA,   "&uacute;" },
      { 0x00FB,   "&ucirc;" },
      { 0x00FC,   "&uuml;" },
      { 0x00FD,   "&yacute;" },
      { 0x00FE,   "&thorn;" },
      { 0x00FF,   "&yuml;" },
      { 0x0152,   "&OElig;" },
      { 0x0153,   "&oelig;" },
      { 0x0160,   "&Scaron;" },
      { 0x0161,   "&scaron;" },
      { 0x0178,   "&Yuml;" },
      { 0x0192,   "&fnof;" },
      { 0x02C6,   "&circ;" },
      { 0x02DC,   "&tilde;" },
      { 0x0391,   "&Alpha;" },
      { 0x0392,   "&Beta;" },
      { 0x0393,   "&Gamma;" },
      { 0x0394,   "&Delta;" },
      { 0x0395,   "&Epsilon;" },
      { 0x0396,   "&Zeta;" },
      { 0x0397,   "&Eta;" },
      { 0x0398,   "&Theta;" },
      { 0x0399,   "&Iota;" },
      { 0x039A,   "&Kappa;" },
      { 0x039B,   "&Lambda;" },
      { 0x039C,   "&Mu;" },
      { 0x039D,   "&Nu;" },
      { 0x039E,   "&Xi;" },
      { 0x039F,   "&Omicron;" },
      { 0x03A0,   "&Pi;" },
      { 0x03A1,   "&Rho;" },
      { 0x03A3,   "&Sigma;" },
      { 0x03A4,   "&Tau;" },
      { 0x03A5,   "&Upsilon;" },
      { 0x03A6,   "&Phi;" },
      { 0x03A7,   "&Chi;" },
      { 0x03A8,   "&Psi;" },
      { 0x03A9,   "&Omega;" },
      { 0x03B1,   "&alpha;" },
      { 0x03B2,   "&beta;" },
      { 0x03B3,   "&gamma;" },
      { 0x03B4,   "&delta;" },
      { 0x03B5,   "&epsilon;" },
      { 0x03B6,   "&zeta;" },
      { 0x03B7,   "&eta;" },
      { 0x03B8,   "&theta;" },
      { 0x03B9,   "&iota;" },
      { 0x03BA,   "&kappa;" },
      { 0x03BB,   "&lambda;" },
      { 0x03BC,   "&mu;" },
      { 0x03BD,   "&nu;" },
      { 0x03BE,   "&xi;" },
      { 0x03BF,   "&omicron;" },
      { 0x03C0,   "&pi;" },
      { 0x03C1,   "&rho;" },
      { 0x03C2,   "&sigmaf;" },
      { 0x03C3,   "&sigma;" },
      { 0x03C4,   "&tau;" },
      { 0x03C5,   "&upsilon;" },
      { 0x03C6,   "&phi;" },
      { 0x03C7,   "&chi;" },
      { 0x03C8,   "&psi;" },
      { 0x03C9,   "&omega;" },
      { 0x03D1,   "&thetasym;" },
      { 0x03D2,   "&upsih;" },
      { 0x03D6,   "&piv;" },
      { 0x2002,   "&ensp;" },
      { 0x2003,   "&emsp;" },
      { 0x2009,   "&thinsp;" },
      { 0x200C,   "&zwnj;" },
      { 0x200D,   "&zwj;" },
      { 0x200E,   "&lrm;" },
      { 0x200F,   "&rlm;" },
      { 0x2013,   "&ndash;" },
      { 0x2014,   "&mdash;" },
      { 0x2018,   "&lsquo;" },
      { 0x2019,   "&rsquo;" },
      { 0x201A,   "&sbquo;" },
      { 0x201C,   "&ldquo;" },
      { 0x201D,   "&rdquo;" },
      { 0x201E,   "&bdquo;" },
      { 0x2020,   "&dagger;" },
      { 0x2021,   "&Dagger;" },
      { 0x2022,   "&bull;" },
      { 0x2026,   "&hellip;" },
      { 0x2030,   "&permil;" },
      { 0x2032,   "&prime;" },
      { 0x2033,   "&Prime;" },
      { 0x2039,   "&lsaquo;" },
      { 0x203A,   "&rsaquo;" },
      { 0x203E,   "&oline;" },
      { 0x2044,   "&frasl;" },
      { 0x20AC,   "&euro;" },
      { 0x2111,   "&image;" },
      { 0x2118,   "&weierp;" },
      { 0x211C,   "&real;" },
      { 0x2122,   "&trade;" },
      { 0x2135,   "&alefsym;" },
      { 0x2190,   "&larr;" },
      { 0x2191,   "&uarr;" },
      { 0x2192,   "&rarr;" },
      { 0x2193,   "&darr;" },
      { 0x2194,   "&harr;" },
      { 0x21B5,   "&crarr;" },
      { 0x21D0,   "&lArr;" },
      { 0x21D1,   "&uArr;" },
      { 0x21D2,   "&rArr;" },
      { 0x21D3,   "&dArr;" },
      { 0x21D4,   "&hArr;" },
      { 0x2200,   "&forall;" },
      { 0x2202,   "&part;" },
      { 0x2203,   "&exist;" },
      { 0x2205,   "&empty;" },
      { 0x2207,   "&nabla;" },
      { 0x2208,   "&isin;" },
      { 0x2209,   "&notin;" },
      { 0x220B,   "&ni;" },
      { 0x220F,   "&prod;" },
      { 0x2211,   "&sum;" },
      { 0x2212,   "&minus;" },
      { 0x2217,   "&lowast;" },
      { 0x221A,   "&radic;" },
      { 0x221D,   "&prop;" },
      { 0x221E,   "&infin;" },
      { 0x2220,   "&ang;" },
      { 0x2227,   "&and;" },
      { 0x2228,   "&or;" },
      { 0x2229,   "&cap;" },
      { 0x222A,   "&cup;" },
      { 0x222B,   "&int;" },
      { 0x2234,   "&there4;" },
      { 0x223C,   "&sim;" },
      { 0x2245,   "&cong;" },
      { 0x2248,   "&asymp;" },
      { 0x2260,   "&ne;" },
      { 0x2261,   "&equiv;" },
      { 0x2264,   "&le;" },
      { 0x2265,   "&ge;" },
      { 0x2282,   "&sub;" },
      { 0x2283,   "&sup;" },
      { 0x2284,   "&nsub;" },
      { 0x2286,   "&sube;" },
      { 0x2287,   "&supe;" },
      { 0x2295,   "&oplus;" },
      { 0x2297,   "&otimes;" },
      { 0x22A5,   "&perp;" },
      { 0x22C5,   "&sdot;" },
      { 0x2308,   "&lceil;" },
      { 0x2309,   "&rceil;" },
      { 0x230A,   "&lfloor;" },
      { 0x230B,   "&rfloor;" },
      { 0x2329,   "&lang;" },
      { 0x232A,   "&rang;" },
      { 0x25CA,   "&loz;" },
      { 0x2660,   "&spades;" },
      { 0x2663,   "&clubs;" },
      { 0x2665,   "&hearts;" },
      { 0x2666,   "&diams;" },
   } ;

   static const int HTML_CHARREF_LIST_NELEM = NELEMOF ( HtmlCharRefList ) ;


   // name
   const CHARACTER_NAME *pResult = (const CHARACTER_NAME*) bsearch ( & C, HtmlCharRefList, HTML_CHARREF_LIST_NELEM, sizeof(CHARACTER_NAME), HtmlCharRefCharCmp ) ;
   if ( ! pResult ) return NULL ;

   return pResult->szName ;
}



