// mbctbl.h

#ifndef MBCTBL_H
#define MBCTBL_H


#ifdef __cplusplus
extern "C" {
#endif



#ifdef MBCTBL_DLL


int WINAPI MultiByteToUnicode ( int C, int nCodePage ) ;
int WINAPI UnicodeToMultiByte ( int cUnicode, int nCodePage ) ;
int WINAPI JisHojoToUnicode ( int C ) ;
int WINAPI UnicodeToJisHojo ( int cUnicode ) ;
int WINAPI ShiftJis2004ToUnicode ( int cSjis, int cUnicode, const wchar_t **pszUnicode ) ;
int WINAPI UnicodeToShiftJis2004 ( int cUnicode, int cSjis, const wchar_t *szUnicode ) ;
int WINAPI IsMbcValidCodePage ( int nCodePage ) ;
int WINAPI GetDllVersion ( void ) ;


#else


typedef int ( WINAPI *MULTIBYTETOUNICODE ) ( int C, int nCodePage ) ;
typedef int ( WINAPI *UNICODETOMULTIBYTE ) ( int cUnicode, int nCodePage ) ;
typedef int ( WINAPI *JISHOJOTOUNICODE ) ( int C ) ;
typedef int ( WINAPI *UNICODETOJISHOJO ) ( int cUnicode ) ;
typedef int ( WINAPI *SHIFTJIS2004TOUNICODE ) ( int cSjis, int cUnicode, const wchar_t **pszUnicode ) ;
typedef int ( WINAPI *UNICODETOSHIFTJIS2004 ) ( int cUnicode, int cSjis, const wchar_t *szUnicode ) ;
typedef int ( WINAPI *ISMBCVALIDCODEPAGE ) ( int nCodePage ) ;


#endif // else of #ifdef MBCTBL_DLL



static inline int IsMbcDllCodePage ( int nCodePage ) {

   int nResult ;

   switch ( nCodePage ) {
      case CP_JAPANESE :
      case CP_KOREAN :
      case CP_CHINESE_SIMPLIFIED :
      case CP_CHINESE_TRADITIONAL :
      case CP_CHINESE_HKSCS :
      case CP_KOREAN_JOHAB :
         nResult = 1 ; break ;
      default :
         nResult = 0 ; break ;
   }

   return nResult ;
}



#ifdef __cplusplus
}
#endif

#endif


