// unilang.cpp

#include <windows.h>
#include "msc.h"
#include "langid.h"
#include "uniblock.h"
#include "unilang.h"



// K؂ȌꎯʎqԂ
// nIndex Ȃ cUnicode AȊOȂ nIndex 狁߂
// CfbNX pIndex ɕۑ
// ŶȂ 0 Ԃ
int UnicodeToLangId ( int cUnicode, int nIndex, int *pIndex ) {

   static const unsigned short UnicodeBlockLangId [] = {
      /*   0000  Basic Latin      (0) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   0080  Latin-1 Supple   (1) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   0100  Latin Extended   (2) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   0180  Latin Extended   (3) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   0250  IPA Extensions   (4) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   02B0  Spacing Modifi   (5) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   0300  Combining Diac   (6) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   0370  Greek and Copt   (7) */  MAKELANGID ( LANG_GREEK, SUBLANG_DEFAULT ),
      /*   0400  Cyrillic         (8) */  MAKELANGID ( LANG_RUSSIAN, SUBLANG_DEFAULT ),
      /*   0500  Cyrillic Suppl   (9) */  MAKELANGID ( LANG_RUSSIAN, SUBLANG_DEFAULT ),
      /*   0530  Armenian        (10) */  MAKELANGID ( LANG_ARMENIAN, SUBLANG_DEFAULT ),
      /*   0590  Hebrew          (11) */  MAKELANGID ( LANG_HEBREW, SUBLANG_DEFAULT ),
      /*   0600  Arabic          (12) */  MAKELANGID ( LANG_ARABIC, SUBLANG_DEFAULT ),
      /*   0700  Syriac          (13) */  MAKELANGID ( LANG_SYRIAC, SUBLANG_SYRIAC ),
      /*   0780  Thaana          (14) */  0,
      /*   0900  Devanagari      (15) */  MAKELANGID ( LANG_HINDI, SUBLANG_DEFAULT ),
      /*   0980  Bengali         (16) */  MAKELANGID ( LANG_BENGALI, SUBLANG_DEFAULT ),
      /*   0A00  Gurmukhi        (17) */  MAKELANGID ( LANG_PUNJABI, SUBLANG_DEFAULT ),
      /*   0A80  Gujarati        (18) */  MAKELANGID ( LANG_GUJARATI, SUBLANG_DEFAULT ),
      /*   0B00  Oriya           (19) */  MAKELANGID ( LANG_ORIYA, SUBLANG_DEFAULT ),
      /*   0B80  Tamil           (20) */  MAKELANGID ( LANG_TAMIL, SUBLANG_DEFAULT ),
      /*   0C00  Telugu          (21) */  MAKELANGID ( LANG_TELUGU, SUBLANG_DEFAULT ),
      /*   0C80  Kannada         (22) */  MAKELANGID ( LANG_KANNADA, SUBLANG_DEFAULT ),
      /*   0D00  Malayalam       (23) */  MAKELANGID ( LANG_MALAYALAM, SUBLANG_DEFAULT ),
      /*   0D80  Sinhala         (24) */  MAKELANGID ( LANG_SINHALESE, SUBLANG_DEFAULT ),
      /*   0E00  Thai            (25) */  MAKELANGID ( LANG_THAI, SUBLANG_DEFAULT ),
      /*   0E80  Lao             (26) */  MAKELANGID ( LANG_LAO, SUBLANG_DEFAULT ),
      /*   0F00  Tibetan         (27) */  MAKELANGID ( LANG_TIBETAN, SUBLANG_DEFAULT ),
      /*   1000  Myanmar         (28) */  MAKELANGID ( LANG_BURMESE, SUBLANG_DEFAULT ),
      /*   10A0  Georgian        (29) */  MAKELANGID ( LANG_GEORGIAN, SUBLANG_DEFAULT ),
      /*   1100  Hangul Jamo     (30) */  MAKELANGID ( LANG_KOREAN, SUBLANG_DEFAULT ),
      /*   1200  Ethiopic        (31) */  MAKELANGID ( LANG_AMHARIC, SUBLANG_DEFAULT ),
      /*   13A0  Cherokee        (32) */  MAKELANGID ( LANG_CHEROKEE, SUBLANG_DEFAULT ),
      /*   1400  Unified Canadi  (33) */  MAKELANGID ( LANG_INUKTITUT, SUBLANG_DEFAULT ),
      /*   1680  Ogham           (34) */  0,
      /*   16A0  Runic           (35) */  0,
      /*   1700  Tagalog         (36) */  MAKELANGID ( LANG_FILIPINO, SUBLANG_DEFAULT ),
      /*   1720  Hanunoo         (37) */  0,
      /*   1740  Buhid           (38) */  0,
      /*   1760  Tagbanwa        (39) */  0,
      /*   1780  Khmer           (40) */  MAKELANGID ( LANG_KHMER, SUBLANG_DEFAULT ),
      /*   1800  Mongolian       (41) */  MAKELANGID ( LANG_MONGOLIAN, SUBLANG_MONGOLIAN_PRC ),
      /*   1900  Limbu           (42) */  0,
      /*   1950  Tai Le          (43) */  0,
      /*   19E0  Khmer Symbols   (44) */  MAKELANGID ( LANG_KHMER, SUBLANG_DEFAULT ),
      /*   1D00  Phonetic Exten  (45) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   1E00  Latin Extended  (46) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   1F00  Greek Extended  (47) */  MAKELANGID ( LANG_GREEK, SUBLANG_DEFAULT ),
      /*   2000  General Punctu  (48) */  0,
      /*   2070  Superscripts a  (49) */  0,
      /*   20A0  Currency Symbo  (50) */  0,
      /*   20D0  Combining Diac  (51) */  0,
      /*   2100  Letterlike Sym  (52) */  0,
      /*   2150  Number Forms    (53) */  0,
      /*   2190  Arrows          (54) */  0,
      /*   2200  Mathematical O  (55) */  0,
      /*   2300  Miscellaneous   (56) */  0,
      /*   2400  Control Pictur  (57) */  0,
      /*   2440  Optical Charac  (58) */  0,
      /*   2460  Enclosed Alpha  (59) */  0,
      /*   2500  Box Drawing     (60) */  0,
      /*   2580  Block Elements  (61) */  0,
      /*   25A0  Geometric Shap  (62) */  0,
      /*   2600  Miscellaneous   (63) */  0,
      /*   2700  Dingbats        (64) */  0,
      /*   27C0  Miscellaneous   (65) */  0,
      /*   27F0  Supplemental A  (66) */  0,
      /*   2800  Braille Patter  (67) */  0,
      /*   2900  Supplemental A  (68) */  0,
      /*   2980  Miscellaneous   (69) */  0,
      /*   2A00  Supplemental M  (70) */  0,
      /*   2B00  Miscellaneous   (71) */  0,
      /*   2E80  CJK Radicals S  (72) */  0,
      /*   2F00  Kangxi Radical  (73) */  0,
      /*   2FF0  Ideographic De  (74) */  0,
      /*   3000  CJK Symbols an  (75) */  0,
      /*   3040  Hiragana        (76) */  MAKELANGID ( LANG_JAPANESE, SUBLANG_DEFAULT ),
      /*   30A0  Katakana        (77) */  MAKELANGID ( LANG_JAPANESE, SUBLANG_DEFAULT ),
      /*   3100  Bopomofo        (78) */  0,
      /*   3130  Hangul Compati  (79) */  MAKELANGID ( LANG_KOREAN, SUBLANG_DEFAULT ),
      /*   3190  Kanbun          (80) */  0,
      /*   31A0  Bopomofo Exten  (81) */  0,
      /*   31F0  Katakana Phone  (82) */  MAKELANGID ( LANG_JAPANESE, SUBLANG_DEFAULT ),
      /*   3200  Enclosed CJK L  (83) */  0,
      /*   3300  CJK Compatibil  (84) */  0,
      /*   3400  CJK Unified Id  (85) */  0,
      /*   4DC0  Yijing Hexagra  (86) */  0,
      /*   4E00  CJK Unified Id  (87) */  0,
      /*   A000  Yi Syllables    (88) */  MAKELANGID ( LANG_YI, SUBLANG_DEFAULT ),
      /*   A490  Yi Radicals     (89) */  MAKELANGID ( LANG_YI, SUBLANG_DEFAULT ),
      /*   AC00  Hangul Syllabl  (90) */  MAKELANGID ( LANG_KOREAN, SUBLANG_DEFAULT ),
      /*   E000  Private Use Ar  (91) */  0,
      /*   F900  CJK Compatibil  (92) */  0,
      /*   FB00  Alphabetic Pre  (93) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   FB50  Arabic Present  (94) */  MAKELANGID ( LANG_ARABIC, SUBLANG_DEFAULT ),
      /*   FE00  Variation Sele  (95) */  0,
      /*   FE20  Combining Half  (96) */  0,
      /*   FE30  CJK Compatibil  (97) */  0,
      /*   FE50  Small Form Var  (98) */  0,
      /*   FE70  Arabic Present  (99) */  MAKELANGID ( LANG_ARABIC, SUBLANG_DEFAULT ),
      /*   FF00  Halfwidth and  (100) */  0,
      /*   FFF0  Specials       (101) */  0,
      /*  10000  Linear B Sylla (102) */  0,
      /*  10080  Linear B Ideog (103) */  0,
      /*  10100  Aegean Numbers (104) */  0,
      /*  10300  Old Italic     (105) */  0,
      /*  10330  Gothic         (106) */  0,
      /*  10380  Ugaritic       (107) */  0,
      /*  10400  Deseret        (108) */  0,
      /*  10450  Shavian        (109) */  0,
      /*  10480  Osmanya        (110) */  0,
      /*  10800  Cypriot Syllab (111) */  0,
      /*  1D000  Byzantine Musi (112) */  0,
      /*  1D100  Musical Symbol (113) */  0,
      /*  1D300  Tai Xuan Jing  (114) */  0,
      /*  1D400  Mathematical A (115) */  0,
      /*  20000  CJK Unified Id (116) */  0,
      /*  2F800  CJK Compatibil (117) */  0,
      /*  E0000  Tags           (118) */  0,
      /*  E0100  Variation Sele (119) */  0,
      /*  F0000  Supplementary  (120) */  0,
      /* 100000  Supplementary  (121) */  0,
      /*   0750  Arabic Supplem (122) */  MAKELANGID ( LANG_ARABIC, SUBLANG_DEFAULT ),
      /*   1380  Ethiopic Suppl (123) */  MAKELANGID ( LANG_AMHARIC, SUBLANG_DEFAULT ),
      /*   1980  New Tai Lue    (124) */  0,
      /*   1A00  Buginese       (125) */  0,
      /*   1D80  Phonetic Exten (126) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   1DC0  Combining Diac (127) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   2C00  Glagolitic     (128) */  0,
      /*   2C80  Coptic         (129) */  0,
      /*   2D00  Georgian Suppl (130) */  MAKELANGID ( LANG_GEORGIAN, SUBLANG_DEFAULT ),
      /*   2D30  Tifinagh       (131) */  0,
      /*   2D80  Ethiopic Exten (132) */  MAKELANGID ( LANG_AMHARIC, SUBLANG_DEFAULT ),
      /*   2E00  Supplemental P (133) */  0,
      /*   31C0  CJK Strokes    (134) */  0,
      /*   A700  Modifier Tone  (135) */  0,
      /*   A800  Syloti Nagri   (136) */  0,
      /*   FE10  Vertical Forms (137) */  0,
      /*  10140  Ancient Greek  (138) */  0,
      /*  103A0  Old Persian    (139) */  0,
      /*  10A00  Kharoshthi     (140) */  0,
      /*  1D200  Ancient Greek  (141) */  0,
      /*   07C0  NKo            (142) */  0,
      /*   1B00  Balinese       (143) */  0,
      /*   2C60  Latin Extended (144) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   A720  Latin Extended (145) */  MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ),
      /*   A840  Phags-pa       (146) */  0,
      /*  10900  Phoenician     (147) */  0,
      /*  12000  Cuneiform      (148) */  0,
      /*  12400  Cuneiform Numb (149) */  0,
      /*  1D360  Counting Rod N (150) */  0,
      /*   1B80  Sundanese      (151) */  0,
      /*   1C00  Lepcha         (152) */  0,
      /*   1C50  Ol Chiki       (153) */  0,
      /*   2DE0  Cyrillic Exten (154) */  0,
      /*   A500  Vai            (155) */  0,
      /*   A640  Cyrillic Exten (156) */  0,
      /*   A880  Saurashtra     (157) */  0,
      /*   A900  Kayah Li       (158) */  0,
      /*   A930  Rejang         (159) */  0,
      /*   AA00  Cham           (160) */  0,
      /*  10190  Ancient Symbol (161) */  0,
      /*  101D0  Phaistos Disc  (162) */  0,
      /*  10280  Lycian         (163) */  0,
      /*  102A0  Carian         (164) */  0,
      /*  10920  Lydian         (165) */  0,
      /*  1F000  Mahjong Tiles  (166) */  0,
      /*  1F030  Domino Tiles   (167) */  0,
      /*   0800  Samaritan      (168) */  0,
      /*   18B0  Unified Canadi (169) */  0,
      /*   1A20  Tai Tham       (170) */  0,
      /*   1CD0  Vedic Extensio (171) */  0,
      /*   A4D0  Lisu           (172) */  0,
      /*   A6A0  Bamum          (173) */  0,
      /*   A830  Common Indic N (174) */  0,
      /*   A8E0  Devanagari Ext (175) */  0,
      /*   A960  Hangul Jamo Ex (176) */  0,
      /*   A980  Javanese       (177) */  0,
      /*   AA60  Myanmar Extend (178) */  0,
      /*   AA80  Tai Viet       (179) */  0,
      /*   ABC0  Meetei Mayek   (180) */  0,
      /*   D7B0  Hangul Jamo Ex (181) */  0,
      /*  10840  Imperial Arama (182) */  0,
      /*  10A60  Old South Arab (183) */  0,
      /*  10B00  Avestan        (184) */  0,
      /*  10B40  Inscriptional  (185) */  0,
      /*  10B60  Inscriptional  (186) */  0,
      /*  10C00  Old Turkic     (187) */  0,
      /*  10E60  Rumi Numeral S (188) */  0,
      /*  11080  Kaithi         (189) */  0,
      /*  13000  Egyptian Hiero (190) */  0,
      /*  1F100  Enclosed Alpha (191) */  0,
      /*  1F200  Enclosed Ideog (192) */  0,
      /*  2A700  CJK Unified Id (193) */  0,
   } ;

   if ( nIndex < 0 ) nIndex = GetUnicodeBlock ( cUnicode, 0, 0, NULL, NULL, NULL ) ;

   if ( nIndex >= 0 ) {
      if ( pIndex ) *pIndex = nIndex ;
      return UnicodeBlockLangId [ nIndex ] ;
   }

   return 0 ;
}



