// langid.h

#ifndef LANGID_H
#define LANGID_H



// LANGID definitions
// Defined after VC++ Ver.6

// See <winnt.h>
// http://www.unicode.org/onlinedat/languages.html

// http://windowssdk.msdn.microsoft.com/en-us/library/ms776294.aspx (primary/sublang)



///////////////////////////////////////
//       Primary Language IDs        //
///////////////////////////////////////



#ifndef LANG_ROMANSH
#define LANG_ROMANSH          0x17
#endif
#ifndef LANG_TAJIK
#define LANG_TAJIK            0x28
#endif
#ifndef LANG_SORBIAN
#define LANG_SORBIAN          0x2E
#endif
#ifndef LANG_SUTU
#define LANG_SUTU             0x30
#endif
#ifndef LANG_TSONGA
#define LANG_TSONGA           0x31
#endif
#ifndef LANG_TSWANA
#define LANG_TSWANA           0x32
#endif
#ifndef LANG_VENDA
#define LANG_VENDA            0x33
#endif
#ifndef LANG_XHOSA
#define LANG_XHOSA            0x34
#endif
#ifndef LANG_ZULU
#define LANG_ZULU             0x35
#endif
#ifndef LANG_MALTESE
#define LANG_MALTESE          0x3A
#endif
#ifndef LANG_SAMI
#define LANG_SAMI             0x3B     // as known as Lappish
#endif
#ifndef LANG_GAELIC
#define LANG_GAELIC           0x3C
#endif
#ifndef LANG_YIDDISH
#define LANG_YIDDISH          0x3D
#endif


#ifndef LANG_KYRGYZ
#define LANG_KYRGYZ           0x40
#endif
#ifndef LANG_TURKMEN
#define LANG_TURKMEN          0x42
#endif


#ifndef LANG_MONGOLIAN
#define LANG_MONGOLIAN        0x50
#endif
#ifndef LANG_TIBETAN
#define LANG_TIBETAN          0x51
#endif
#ifndef LANG_WELSH
#define LANG_WELSH            0x52
#endif
#ifndef LANG_KHMER
#define LANG_KHMER            0x53
#endif
#ifndef LANG_LAO
#define LANG_LAO              0x54
#endif
#ifndef LANG_BURMESE
#define LANG_BURMESE          0x55
#endif
#ifndef LANG_GALICIAN
#define LANG_GALICIAN         0x56
#endif


#ifndef LANG_SYRIAC
#define LANG_SYRIAC           0x5A
#endif
#ifndef LANG_SINHALESE
#define LANG_SINHALESE        0x5B
#endif
#ifndef LANG_CHEROKEE
#define LANG_CHEROKEE         0x5C
#endif
#ifndef LANG_INUKTITUT
#define LANG_INUKTITUT        0x5D
#endif
#ifndef LANG_AMHARIC
#define LANG_AMHARIC          0x5E
#endif
#ifndef LANG_TAMAZIGHT
#define LANG_TAMAZIGHT        0x5F
#endif


#ifndef LANG_FRISIAN
#define LANG_FRISIAN          0x62
#endif
#ifndef LANG_PASHTO
#define LANG_PASHTO           0x63     // as known as Pushto
#endif
#ifndef LANG_FILIPINO
#define LANG_FILIPINO         0x64
#endif
#ifndef LANG_DIVEHI
#define LANG_DIVEHI           0x65
#endif
#ifndef LANG_EDO
#define LANG_EDO              0x66
#endif
#ifndef LANG_FULFULDE
#define LANG_FULFULDE         0x67
#endif
#ifndef LANG_HAUSA
#define LANG_HAUSA            0x68
#endif
#ifndef LANG_IBIBIO
#define LANG_IBIBIO           0x69
#endif
#ifndef LANG_YORUBA
#define LANG_YORUBA           0x6A
#endif
#ifndef LANG_QUECHUA
#define LANG_QUECHUA          0x6B
#endif
#ifndef LANG_SOTHO
#define LANG_SOTHO            0x6C
#endif
#ifndef LANG_BASHKIR
#define LANG_BASHKIR          0x6D
#endif
#ifndef LANG_LUXEMBOURGISH
#define LANG_LUXEMBOURGISH    0x6E
#endif
#ifndef LANG_GREENLANDIC
#define LANG_GREENLANDIC      0x6F
#endif


#ifndef LANG_IGBO
#define LANG_IGBO             0x70
#endif
#ifndef LANG_KANURI
#define LANG_KANURI           0x71
#endif
#ifndef LANG_OROMO
#define LANG_OROMO            0x72     // as knonw as Afan, Galla
#endif
#ifndef LANG_TIGRIGNA
#define LANG_TIGRIGNA         0x73
#endif
#ifndef LANG_GUARANI
#define LANG_GUARANI          0x74
#endif
#ifndef LANG_HAWAIIAN
#define LANG_HAWAIIAN         0x75
#endif
#ifndef LANG_LATIN
#define LANG_LATIN            0x76
#endif
#ifndef LANG_SOMALI
#define LANG_SOMALI           0x77
#endif
#ifndef LANG_YI
#define LANG_YI               0x78
#endif
#ifndef LANG_PAPIAMENTU
#define LANG_PAPIAMENTU       0x79
#endif
#ifndef LANG_MAPUDUNGUN
#define LANG_MAPUDUNGUN       0x7A
#endif
#ifndef LANG_MOHAWK
#define LANG_MOHAWK           0x7C
#endif
#ifndef LANG_BRETON
#define LANG_BRETON           0x7E
#endif
#ifndef LANG_INVARIANT
#define LANG_INVARIANT        0x7F
#endif


#ifndef LANG_UIGHUR
#define LANG_UIGHUR           0x80
#endif
#ifndef LANG_MAORI
#define LANG_MAORI            0x81
#endif
#ifndef LANG_OCCITAN
#define LANG_OCCITAN          0x82
#endif
#ifndef LANG_CORSICAN
#define LANG_CORSICAN         0x83
#endif
#ifndef LANG_ALSATIAN
#define LANG_ALSATIAN         0x84
#endif
#ifndef LANG_YAKUT
#define LANG_YAKUT            0x85
#endif
#ifndef LANG_KICHE
#define LANG_KICHE            0x86
#endif
#ifndef LANG_KINYARWANDA
#define LANG_KINYARWANDA      0x87
#endif
#ifndef LANG_WOLOF
#define LANG_WOLOF            0x88
#endif
#ifndef LANG_DARI
#define LANG_DARI             0x8C
#endif
#ifndef LANG_MALAGASY
#define LANG_MALAGASY         0x8D
#endif



// renamed

#ifndef LANG_BOSNIAN
#define LANG_BOSNIAN                LANG_CROATIAN
#endif
#ifndef LANG_IRISH
#define LANG_IRISH                  LANG_GAELIC
#endif
#ifndef LANG_LOWER_SORBIAN
#define LANG_LOWER_SORBIAN          LANG_SORBIAN
#endif
#ifndef LANG_UPPER_SORBIAN
#define LANG_UPPER_SORBIAN          LANG_SORBIAN
#endif
#ifndef LANG_PERSIAN
#define LANG_PERSIAN                LANG_FARSI
#endif



// Use with the ConvertDefaultLocale function

#ifndef LANG_BOSNIAN_NEUTRAL
#define LANG_BOSNIAN_NEUTRAL        0x781A
#endif
#ifndef LANG_SERBIAN_NEUTRAL
#define LANG_SERBIAN_NEUTRAL        0x7C1A
#endif
#ifndef LANG_CHINESE_SIMPLIFIED
#define LANG_CHINESE_SIMPLIFIED       0x04
#endif
#ifndef LANG_CHINESE_TRADITIONAL
#define LANG_CHINESE_TRADITIONAL    0x7C04
#endif



///////////////////////////////////////
//          Sublanguage IDs          //
///////////////////////////////////////



#ifndef SUBLANG_AFRIKAANS_SOUTH_AFRICA
#define SUBLANG_AFRIKAANS_SOUTH_AFRICA                SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_ALBANIAN_ALBANIA
#define SUBLANG_ALBANIAN_ALBANIA                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_ALSATIAN_FRANCE
#define SUBLANG_ALSATIAN_FRANCE                       SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_AMHARIC_ETHIOPIA
#define SUBLANG_AMHARIC_ETHIOPIA                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_ARMENIAN_ARMENIA
#define SUBLANG_ARMENIAN_ARMENIA                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_ASSAMESE_INDIA
#define SUBLANG_ASSAMESE_INDIA                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_BASHKIR_RUSSIA
#define SUBLANG_BASHKIR_RUSSIA                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_BASQUE_BASQUE
#define SUBLANG_BASQUE_BASQUE                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_BELARUSIAN_BELARUS
#define SUBLANG_BELARUSIAN_BELARUS                    SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_BENGALI_BANGLADESH
#define SUBLANG_BENGALI_BANGLADESH                    0x02
#endif
#ifndef SUBLANG_BENGALI_INDIA
#define SUBLANG_BENGALI_INDIA                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_CYRILLIC
#define SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_CYRILLIC   0x08
#endif
#ifndef SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_LATIN
#define SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_LATIN      0x05
#endif
#ifndef SUBLANG_BRETON_FRANCE
#define SUBLANG_BRETON_FRANCE                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_BULGARIAN_BULGARIA
#define SUBLANG_BULGARIAN_BULGARIA                    SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_CATALAN_CATALAN
#define SUBLANG_CATALAN_CATALAN                       SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_CORSICAN_FRANCE
#define SUBLANG_CORSICAN_FRANCE                       SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_CROATIAN_BOSNIA_HERZEGOVINA_LATIN
#define SUBLANG_CROATIAN_BOSNIA_HERZEGOVINA_LATIN     0x04
#endif
#ifndef SUBLANG_CROATIAN_CROATIA
#define SUBLANG_CROATIAN_CROATIA                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_CZECH_CZECH_REPUBLIC
#define SUBLANG_CZECH_CZECH_REPUBLIC                  SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_DANISH_DENMARK
#define SUBLANG_DANISH_DENMARK                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_DARI_AFGHANISTAN
#define SUBLANG_DARI_AFGHANISTAN                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_DIVEHI_MALDIVES
#define SUBLANG_DIVEHI_MALDIVES                       SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_ENGLISH_INDIA
#define SUBLANG_ENGLISH_INDIA                         0x10
#endif
#ifndef SUBLANG_ENGLISH_IRELAND
#define SUBLANG_ENGLISH_IRELAND                       SUBLANG_ENGLISH_EIRE
#endif
#ifndef SUBLANG_ENGLISH_MALAYSIA
#define SUBLANG_ENGLISH_MALAYSIA                      0x11
#endif
#ifndef SUBLANG_ENGLISH_SINGAPORE
#define SUBLANG_ENGLISH_SINGAPORE                     0x12
#endif
#ifndef SUBLANG_ESTONIAN_ESTONIA
#define SUBLANG_ESTONIAN_ESTONIA                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_FAEROESE_FAROE_ISLANDS
#define SUBLANG_FAEROESE_FAROE_ISLANDS                SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_FILIPINO_PHILIPPINES
#define SUBLANG_FILIPINO_PHILIPPINES                  SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_FINNISH_FINLAND
#define SUBLANG_FINNISH_FINLAND                       SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_FRISIAN_NETHERLANDS
#define SUBLANG_FRISIAN_NETHERLANDS                   SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_GAELIC_SCOTTISH
#define SUBLANG_GAELIC_SCOTTISH                       SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_GAELIC_IRISH
#define SUBLANG_GAELIC_IRISH                          0x02
#endif
#ifndef SUBLANG_GALICIAN_GALICIAN
#define SUBLANG_GALICIAN_GALICIAN                     SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_GEORGIAN_GEORGIA
#define SUBLANG_GEORGIAN_GEORGIA                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_GREEK_GREECE
#define SUBLANG_GREEK_GREECE                          SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_GREENLANDIC_GREENLAND
#define SUBLANG_GREENLANDIC_GREENLAND                 SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_GUJARATI_INDIA
#define SUBLANG_GUJARATI_INDIA                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_HAUSA_NIGERIA
#define SUBLANG_HAUSA_NIGERIA                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_HAUSA_NIGERIA_LATIN
#define SUBLANG_HAUSA_NIGERIA_LATIN                   SUBLANG_HAUSA_NIGERIA
#endif
#ifndef SUBLANG_HEBREW_ISRAEL
#define SUBLANG_HEBREW_ISRAEL                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_HINDI_INDIA
#define SUBLANG_HINDI_INDIA                           SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_HUNGARIAN_HUNGARY
#define SUBLANG_HUNGARIAN_HUNGARY                     SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_ICELANDIC_ICELAND
#define SUBLANG_ICELANDIC_ICELAND                     SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_IGBO_NIGERIA
#define SUBLANG_IGBO_NIGERIA                          SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_INDONESIAN_INDONESIA
#define SUBLANG_INDONESIAN_INDONESIA                  SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_INUKTITUT_CANADA
#define SUBLANG_INUKTITUT_CANADA                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_INUKTITUT_CANADA_LATIN
#define SUBLANG_INUKTITUT_CANADA_LATIN                0x02
#endif
#ifndef SUBLANG_IRISH_IRELAND
#define SUBLANG_IRISH_IRELAND                         0x02
#endif
#ifndef SUBLANG_JAPANESE_JAPAN
#define SUBLANG_JAPANESE_JAPAN                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_KANNADA_INDIA
#define SUBLANG_KANNADA_INDIA                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_KASHMIRI_SASIA
#define SUBLANG_KASHMIRI_SASIA                        0x02
#endif
#ifndef SUBLANG_KAZAK_KAZAKHSTAN
#define SUBLANG_KAZAK_KAZAKHSTAN                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_KHMER_CAMBODIA
#define SUBLANG_KHMER_CAMBODIA                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_KICHE_GUATEMALA
#define SUBLANG_KICHE_GUATEMALA                       SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_KINYARWANDA_RWANDA
#define SUBLANG_KINYARWANDA_RWANDA                    SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_KONKANI_INDIA
#define SUBLANG_KONKANI_INDIA                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_KYRGYZ_KYRGYZSTAN
#define SUBLANG_KYRGYZ_KYRGYZSTAN                     SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_LAO_LAO
#define SUBLANG_LAO_LAO                               SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_LAO_LAO_PDR
#define SUBLANG_LAO_LAO_PDR                           SUBLANG_LAO_LAO
#endif
#ifndef SUBLANG_LATVIAN_LATVIA
#define SUBLANG_LATVIAN_LATVIA                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_LITHUANIAN_LITHUANIA
#define SUBLANG_LITHUANIAN_LITHUANIA                  SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_LITHUANIAN_CLASSIC
#define SUBLANG_LITHUANIAN_CLASSIC                    0x02
#endif
#ifndef SUBLANG_LOWER_SORBIAN_GERMANY
#define SUBLANG_LOWER_SORBIAN_GERMANY                 0x02
#endif
#ifndef SUBLANG_LUXEMBOURGISH_LUXEMBOURG
#define SUBLANG_LUXEMBOURGISH_LUXEMBOURG              SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_MACEDONIAN_MACEDONIA
#define SUBLANG_MACEDONIAN_MACEDONIA                  SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_MALAYALAM_INDIA
#define SUBLANG_MALAYALAM_INDIA                       SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_MALTESE_MALTA
#define SUBLANG_MALTESE_MALTA                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_MAORI_NEW_ZEALAND
#define SUBLANG_MAORI_NEW_ZEALAND                     SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_MAPUDUNGUN_CHILE
#define SUBLANG_MAPUDUNGUN_CHILE                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_MARATHI_INDIA
#define SUBLANG_MARATHI_INDIA                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_MOHAWK_MOHAWK
#define SUBLANG_MOHAWK_MOHAWK                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_MONGOLIAN_CYRILLIC_MONGOLIA
#define SUBLANG_MONGOLIAN_CYRILLIC_MONGOLIA           SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_MONGOLIAN_PRC
#define SUBLANG_MONGOLIAN_PRC                         0x02
#endif
#ifndef SUBLANG_NEPALI_NEPAL
#define SUBLANG_NEPALI_NEPAL                          SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_OCCITAN_FRANCE
#define SUBLANG_OCCITAN_FRANCE                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_ORIYA_INDIA
#define SUBLANG_ORIYA_INDIA                           SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_PASHTO_AFGHANISTAN
#define SUBLANG_PASHTO_AFGHANISTAN                    SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_PERSIAN_IRAN
#define SUBLANG_PERSIAN_IRAN                          SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_POLISH_POLAND
#define SUBLANG_POLISH_POLAND                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_PORTUGUESE_PORTUGAL
#define SUBLANG_PORTUGUESE_PORTUGAL                   SUBLANG_PORTUGUESE
#endif
#ifndef SUBLANG_PUNJABI_INDIA
#define SUBLANG_PUNJABI_INDIA                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_QUECHUA_BOLIVIA
#define SUBLANG_QUECHUA_BOLIVIA                       SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_QUECHUA_ECUADOR
#define SUBLANG_QUECHUA_ECUADOR                       0x02
#endif
#ifndef SUBLANG_QUECHUA_PERU
#define SUBLANG_QUECHUA_PERU                          0x03
#endif
#ifndef SUBLANG_ROMANIAN_ROMANIA
#define SUBLANG_ROMANIAN_ROMANIA                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_ROMANSH_SWITZERLAND
#define SUBLANG_ROMANSH_SWITZERLAND                   SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_RUSSIAN_RUSSIA
#define SUBLANG_RUSSIAN_RUSSIA                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_SAMI_INARI_FINLAND
#define SUBLANG_SAMI_INARI_FINLAND                    0x09
#endif
#ifndef SUBLANG_SAMI_LULE_NORWAY
#define SUBLANG_SAMI_LULE_NORWAY                      0x04
#endif
#ifndef SUBLANG_SAMI_LULE_SWEDEN
#define SUBLANG_SAMI_LULE_SWEDEN                      0x05
#endif
#ifndef SUBLANG_SAMI_NORTHERN_FINLAND
#define SUBLANG_SAMI_NORTHERN_FINLAND                 0x03
#endif
#ifndef SUBLANG_SAMI_NORTHERN_NORWAY
#define SUBLANG_SAMI_NORTHERN_NORWAY                  SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_SAMI_NORTHERN_SWEDEN
#define SUBLANG_SAMI_NORTHERN_SWEDEN                  0x02
#endif
#ifndef SUBLANG_SAMI_SKOLT_FINLAND
#define SUBLANG_SAMI_SKOLT_FINLAND                    0x08
#endif
#ifndef SUBLANG_SAMI_SOUTHERN_NORWAY
#define SUBLANG_SAMI_SOUTHERN_NORWAY                  0x06
#endif
#ifndef SUBLANG_SAMI_SOUTHERN_SWEDEN
#define SUBLANG_SAMI_SOUTHERN_SWEDEN                  0x07
#endif
#ifndef SUBLANG_SANSKRIT_INDIA
#define SUBLANG_SANSKRIT_INDIA                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_CYRILLIC
#define SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_CYRILLIC   0x07
#endif
#ifndef SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_LATIN
#define SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_LATIN      0x06
#endif
#ifndef SUBLANG_SERBIAN_CROATIA
#define SUBLANG_SERBIAN_CROATIA                       SUBLANG_CROATIAN_CROATIA
#endif
#ifndef SUBLANG_SINDHI_AFGHANISTAN
#define SUBLANG_SINDHI_AFGHANISTAN                    0x02
#endif
#ifndef SUBLANG_SINDHI_PAKISTAN
#define SUBLANG_SINDHI_PAKISTAN                       0x02
#endif
#ifndef SUBLANG_SINHALESE_SRI_LANKA
#define SUBLANG_SINHALESE_SRI_LANKA                   SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_SLOVAK_SLOVAKIA
#define SUBLANG_SLOVAK_SLOVAKIA                       SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_SLOVENIAN_SLOVENIA
#define SUBLANG_SLOVENIAN_SLOVENIA                    SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_SOTHO_NORTHERN_SOUTH_AFRICA
#define SUBLANG_SOTHO_NORTHERN_SOUTH_AFRICA           SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_SPANISH_US
#define SUBLANG_SPANISH_US                            0x15
#endif
#ifndef SUBLANG_SWAHILI
#define SUBLANG_SWAHILI                               SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_SWEDISH_SWEDEN
#define SUBLANG_SWEDISH_SWEDEN                        SUBLANG_SWEDISH
#endif
#ifndef SUBLANG_SYRIAC
#define SUBLANG_SYRIAC                                SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_TAJIK_TAJIKISTAN
#define SUBLANG_TAJIK_TAJIKISTAN                      SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_TAMAZIGHT_ALGERIA_LATIN
#define SUBLANG_TAMAZIGHT_ALGERIA_LATIN               0x02
#endif
#ifndef SUBLANG_TAMIL_INDIA
#define SUBLANG_TAMIL_INDIA                           SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_TATAR_RUSSIA
#define SUBLANG_TATAR_RUSSIA                          SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_TELUGU_INDIA
#define SUBLANG_TELUGU_INDIA                          SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_THAI_THAILAND
#define SUBLANG_THAI_THAILAND                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_TIBETAN_BHUTAN
#define SUBLANG_TIBETAN_BHUTAN                        0x02
#endif
#ifndef SUBLANG_TIBETAN_PRC
#define SUBLANG_TIBETAN_PRC                           SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_TIGRIGNA_ERITREA
#define SUBLANG_TIGRIGNA_ERITREA                      0x02     // ?
#endif
#ifndef SUBLANG_TSWANA_SOUTH_AFRICA
#define SUBLANG_TSWANA_SOUTH_AFRICA                   SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_TURKISH_TURKEY
#define SUBLANG_TURKISH_TURKEY                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_TURKMEN_TURKMENISTAN
#define SUBLANG_TURKMEN_TURKMENISTAN                  SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_UIGHUR_PRC
#define SUBLANG_UIGHUR_PRC                            SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_UKRAINIAN_UKRAINE
#define SUBLANG_UKRAINIAN_UKRAINE                     SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_UPPER_SORBIAN_GERMANY
#define SUBLANG_UPPER_SORBIAN_GERMANY                 SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_VIETNAMESE_VIETNAM
#define SUBLANG_VIETNAMESE_VIETNAM                    SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_WELSH_UNITED_KINGDOM
#define SUBLANG_WELSH_UNITED_KINGDOM                  SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_WOLOF_SENEGAL
#define SUBLANG_WOLOF_SENEGAL                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_XHOSA_SOUTH_AFRICA
#define SUBLANG_XHOSA_SOUTH_AFRICA                    SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_YAKUT_RUSSIA
#define SUBLANG_YAKUT_RUSSIA                          SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_YI_PRC
#define SUBLANG_YI_PRC                                SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_YORUBA_NIGERIA
#define SUBLANG_YORUBA_NIGERIA                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_ZULU_SOUTH_AFRICA
#define SUBLANG_ZULU_SOUTH_AFRICA                     SUBLANG_DEFAULT
#endif


#ifndef SUBLANG_CUSTOM_DEFAULT
#define SUBLANG_CUSTOM_DEFAULT                        0x03
#endif
#ifndef SUBLANG_CUSTOM_UNSPECIFIED
#define SUBLANG_CUSTOM_UNSPECIFIED                    0x04
#endif
#ifndef SUBLANG_UI_CUSTOM_DEFAULT
#define SUBLANG_UI_CUSTOM_DEFAULT                     0x05
#endif



///////////////////////////////////////
//   Some Compilers do not support   //
///////////////////////////////////////


#ifndef LANG_URDU
#define LANG_URDU             0x20
#endif
#ifndef LANG_ARMENIAN
#define LANG_ARMENIAN         0x2B
#endif
#ifndef LANG_AZERI
#define LANG_AZERI            0x2C
#endif
#ifndef LANG_MACEDONIAN
#define LANG_MACEDONIAN       0x2F
#endif
#ifndef LANG_GEORGIAN
#define LANG_GEORGIAN         0x37
#endif
#ifndef LANG_HINDI
#define LANG_HINDI            0x39
#endif
#ifndef LANG_MALAY
#define LANG_MALAY            0x3E
#endif
#ifndef LANG_KAZAK
#define LANG_KAZAK            0x3F
#endif
#ifndef LANG_SWAHILI
#define LANG_SWAHILI          0x41
#endif
#ifndef LANG_UZBEK
#define LANG_UZBEK            0x43
#endif
#ifndef LANG_TATAR
#define LANG_TATAR            0x44
#endif
#ifndef LANG_BENGALI
#define LANG_BENGALI          0x45
#endif
#ifndef LANG_PUNJABI
#define LANG_PUNJABI          0x46
#endif
#ifndef LANG_GUJARATI
#define LANG_GUJARATI         0x47
#endif
#ifndef LANG_ORIYA
#define LANG_ORIYA            0x48
#endif
#ifndef LANG_TAMIL
#define LANG_TAMIL            0x49
#endif
#ifndef LANG_TELUGU
#define LANG_TELUGU           0x4A
#endif
#ifndef LANG_KANNADA
#define LANG_KANNADA          0x4B
#endif
#ifndef LANG_MALAYALAM
#define LANG_MALAYALAM        0x4C
#endif
#ifndef LANG_ASSAMESE
#define LANG_ASSAMESE         0x4D
#endif
#ifndef LANG_MARATHI
#define LANG_MARATHI          0x4E
#endif
#ifndef LANG_SANSKRIT
#define LANG_SANSKRIT         0x4F
#endif
#ifndef LANG_KONKANI
#define LANG_KONKANI          0x57
#endif
#ifndef LANG_MANIPURI
#define LANG_MANIPURI         0x58
#endif
#ifndef LANG_SINDHI
#define LANG_SINDHI           0x59
#endif
#ifndef LANG_KASHMIRI
#define LANG_KASHMIRI         0x60
#endif
#ifndef LANG_NEPALI
#define LANG_NEPALI           0x61
#endif


#ifndef SUBLANG_AZERI_LATIN
#define SUBLANG_AZERI_LATIN                           SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_AZERI_CYRILLIC
#define SUBLANG_AZERI_CYRILLIC                        0x02
#endif
#ifndef SUBLANG_CHINESE_MACAU
#define SUBLANG_CHINESE_MACAU                         0x05
#endif
#ifndef SUBLANG_ENGLISH_ZIMBABWE
#define SUBLANG_ENGLISH_ZIMBABWE                      0x0C
#endif
#ifndef SUBLANG_ENGLISH_PHILIPPINES
#define SUBLANG_ENGLISH_PHILIPPINES                   0x0D
#endif
#ifndef SUBLANG_FRENCH_MONACO
#define SUBLANG_FRENCH_MONACO                         0x06
#endif
#ifndef SUBLANG_KASHMIRI_INDIA
#define SUBLANG_KASHMIRI_INDIA                        0x02
#endif
#ifndef SUBLANG_LITHUANIAN
#define SUBLANG_LITHUANIAN                            SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_MALAY_MALAYSIA
#define SUBLANG_MALAY_MALAYSIA                        SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_MALAY_BRUNEI_DARUSSALAM
#define SUBLANG_MALAY_BRUNEI_DARUSSALAM               0x02
#endif
#ifndef SUBLANG_NEPALI_INDIA
#define SUBLANG_NEPALI_INDIA                          0x02
#endif
#ifndef SUBLANG_SPANISH_DOMINICAN_REPUBLIC
#define SUBLANG_SPANISH_DOMINICAN_REPUBLIC            0x07
#endif
#ifndef SUBLANG_URDU_PAKISTAN
#define SUBLANG_URDU_PAKISTAN                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_URDU_INDIA
#define SUBLANG_URDU_INDIA                            0x02
#endif
#ifndef SUBLANG_UZBEK_LATIN
#define SUBLANG_UZBEK_LATIN                           SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_UZBEK_CYRILLIC
#define SUBLANG_UZBEK_CYRILLIC                        0x02
#endif
#ifndef SUBLANG_SINDHI_INDIA
#define SUBLANG_SINDHI_INDIA                          SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_SWAHILI_KENYA
#define SUBLANG_SWAHILI_KENYA                         SUBLANG_DEFAULT
#endif
#ifndef SUBLANG_SYRIAC_SYRIA
#define SUBLANG_SYRIAC_SYRIA                          SUBLANG_DEFAULT
#endif



#if 0
// Non Standard, used in WINE
#define LANG_ESPERANTO     0x8F
#define LANG_WALON         0x90
#define LANG_CORNISH       0x91
#define SUBLANG_DUTCH_SURINAM       0x03
#define SUBLANG_ROMANIAN_MOLDAVIA   0x02
#define SUBLANG_RUSSIAN_MOLDAVIA    0x02
#define SUBLANG_GAELIC_MANX         0x03
#endif



#endif


