// sendmsg.h

#ifndef SENDMSG_H
#define SENDMSG_H

#ifdef __cplusplus
extern "C" {
#endif



////////////////////////////////////////
//         EBhE         //
////////////////////////////////////////



HICON Wm_SetIcon ( HWND hWnd, int nIconSize, HICON hIcon ) ;
int Wm_SetFont ( HWND hWnd, HFONT hFont, int IsRedraw ) ;
int Wm_Notify ( HWND hWnd, NMHDR *pNotifyMessageHeader ) ;
int Wm_GetTextA ( HWND hWnd, char *szString, int nMaxLen ) ;
int Wm_GetTextW ( HWND hWnd, wchar_t *szString, int nMaxLen ) ;
int Wm_SetTextA ( HWND hWnd, const char *szString ) ;
int Wm_SetTextW ( HWND hWnd, const wchar_t *szString ) ;
int Wm_KeyDown ( HWND hWnd, int nVirtualKey ) ;
int Wm_Destroy ( HWND hWnd ) ;
int Wm_CopyData ( HWND hWnd, HWND hWndFrom, const COPYDATASTRUCT *pCopyDataStruct ) ;


#ifdef UNICODE
#define Wm_GetText Wm_GetTextW
#define Wm_SetText Wm_SetTextW
#else
#define Wm_GetText Wm_GetTextA
#define Wm_SetText Wm_SetTextA
#endif


#define Dlg_Wm_SetIcon(hDlg,nId,nIconSize,hIcon)   Wm_SetIcon(GetDlgItem(hDlg,nId),nIconSize,hIcon)
#define Dlg_Wm_SetFont(hDlg,nId,hFont,IsRedraw)    Wm_SetFont(GetDlgItem(hDlg,nId),hFont,IsRedraw)
#define Dlg_Wm_Notify(hDlg,nId,pNmhdr)             Wm_Notify(GetDlgItem(hDlg,nId),pNmhdr)
#define Dlg_Wm_GetTextA(hDlg,nId,szString,nMaxLen) Wm_GetTextA(GetDlgItem(hDlg,nId),szString,nMaxLen)
#define Dlg_Wm_GetTextW(hDlg,nId,szString,nMaxLen) Wm_GetTextW(GetDlgItem(hDlg,nId),szString,nMaxLen)
#define Dlg_Wm_SetTextA(hDlg,nId,szString)         Wm_SetTextA(GetDlgItem(hDlg,nId),szString)
#define Dlg_Wm_SetTextW(hDlg,nId,szString)         Wm_SetTextW(GetDlgItem(hDlg,nId),szString)
#define Dlg_Wm_KeyDown(hDlg,nId,nKey)              Wm_KeyDown(GetDlgItem(hDlg,nId),nKey)


#ifdef UNICODE
#define Dlg_Wm_GetText Dlg_Wm_GetTextW
#define Dlg_Wm_SetText Dlg_Wm_SetTextW
#else
#define Dlg_Wm_GetText Dlg_Wm_GetTextA
#define Dlg_Wm_SetText Dlg_Wm_SetTextA
#endif



////////////////////////////////////////
//             _CAO             //
////////////////////////////////////////



int Dlg_SetFocus ( HWND hDlg, int nId ) ;
int Dlg_EnableWindow ( HWND hDlg, int nId, int IsEnable ) ;


#define Dlg_IsWindowEnabled(hDlg,nId)              IsWindowEnabled(GetDlgItem(hDlg,nId))



////////////////////////////////////////
//         {^Rg[         //
////////////////////////////////////////



int Button_SetStyle ( HWND hWnd, int nStyle, int IsRedraw ) ;


#define Dlg_Button_SetStyle(hDlg,nId,nStyle,IsRedraw)    Button_SetStyle(GetDlgItem(hDlg,nId),nStyle,IsRedraw)



////////////////////////////////////////
//          ^uRg[          //
////////////////////////////////////////



#undef TabCtrl_InsertItem
#undef TabCtrl_AdjustRect
#undef TabCtrl_GetCurSel


int TabCtrl_InsertItemA ( HWND hWnd, int nItem, const TC_ITEMA *pItem ) ;
int TabCtrl_InsertItemW ( HWND hWnd, int nItem, const TC_ITEMW *pItem ) ;
int TabCtrl_AdjustRect ( HWND hWnd, int IsLarger, RECT *pRect ) ;
int TabCtrl_GetCurSel ( HWND hWnd ) ;


#ifdef UNICODE
#define TabCtrl_InsertItem TabCtrl_InsertItemW
#else
#define TabCtrl_InsertItem TabCtrl_InsertItemA
#endif


#define Dlg_TabCtrl_InsertItemA(hDlg,nId,iItem,pItem)    TabCtrl_InsertItemA(GetDlgItem(hDlg,nId),iItem,pItem)
#define Dlg_TabCtrl_InsertItemW(hDlg,nId,iItem,pItem)    TabCtrl_InsertItemW(GetDlgItem(hDlg,nId),iItem,pItem)
#define Dlg_TabCtrl_AdjustRect(hDlg,nId,bLarger,pRect)   TabCtrl_AdjustRect(GetDlgItem(hDlg,nId),bLarger,pRect)
#define Dlg_TabCtrl_GetCurSel(hDlg,nId)                  TabCtrl_GetCurSel(GetDlgItem(hDlg,nId))


#ifdef UNICODE
#define Dlg_TabCtrl_InsertItem Dlg_TabCtrl_InsertItemW
#else
#define Dlg_TabCtrl_InsertItem Dlg_TabCtrl_InsertItemA
#endif



////////////////////////////////////////
//       GfBbgRg[       //
////////////////////////////////////////



int Edit_GetMargins ( HWND hWnd, int *pLeftMargin, int *pRightMargin ) ;
int Edit_SetMargins ( HWND hWnd, short nLeftMargin, short nRightMargin ) ;
int Edit_SetReadOnly ( HWND hWnd, int IsReadOnly ) ;
int Edit_SetSel ( HWND hWnd, int nStart, int nEnd ) ;
int Edit_LimitText ( HWND hWnd, int nMax ) ;


#define Dlg_Edit_GetMargins(hDlg,nId,pLeft,pRight)    Edit_GetMargins(GetDlgItem(hDlg,nId),pLeft,pRight)
#define Dlg_Edit_SetMargins(hDlg,nId,nLeft,nRight)    Edit_SetMargins(GetDlgItem(hDlg,nId),nLeft,nRight)
#define Dlg_Edit_SetReadOnly(hDlg,nId,IsReadOnly)     Edit_SetReadOnly(GetDlgItem(hDlg,nId),IsReadOnly)
#define Dlg_Edit_SetSel(hDlg,nId,nStart,nEnd)         Edit_SetSel(GetDlgItem(hDlg,nId),nStart,nEnd)
#define Dlg_Edit_LimitText(hDlg,nId,nMax)             Edit_LimitText(GetDlgItem(hDlg,nId),nMax)


#define MoveCaretToStart(hWnd)                   Edit_SetSel ( hWnd, 0, 0 )
#define MoveCaretToEnd(hWnd)                     Edit_SetSel ( hWnd, 0x7FFFFFFF, 0x7FFFFFFF )
#define Dlg_MoveCaretToStart(hDlg,nId)           MoveCaretToStart(GetDlgItem(hDlg,nId))
#define Dlg_MoveCaretToEnd(hDlg,nId)             MoveCaretToEnd(GetDlgItem(hDlg,nId))



////////////////////////////////////////
//     R{{bNXRg[     //
////////////////////////////////////////



int ComboBox_AddStringA ( HWND hWnd, const char *szString ) ;
int ComboBox_AddStringW ( HWND hWnd, const wchar_t *szString ) ;
int ComboBox_InsertStringA ( HWND hWnd, int nIndex, const char *szString ) ;
int ComboBox_InsertStringW ( HWND hWnd, int nIndex, const wchar_t *szString ) ;
int ComboBox_GetCount ( HWND hWnd ) ;
int ComboBox_ResetContent ( HWND hWnd ) ;
int ComboBox_GetCurSel ( HWND hWnd ) ;
int ComboBox_SetCurSel ( HWND hWnd, int nIndex ) ;
int ComboBox_SelectStringA ( HWND hWnd, int nIndexStart, const char *szString ) ;
int ComboBox_SelectStringW ( HWND hWnd, int nIndexStart, const wchar_t *szString ) ;
int ComboBox_FindStringExactA ( HWND hWnd, int nIndexStart, const char *szString ) ;
int ComboBox_FindStringExactW ( HWND hWnd, int nIndexStart, const wchar_t *szString ) ;
int ComboBox_GetItemHeight ( HWND hWnd ) ;
int ComboBox_SetEditSel ( HWND hWnd, short nStart, short nEnd ) ;
int ComboBox_LimitText ( HWND hWnd, int nMax ) ;
int ComboBox_SetMaxHeight ( HWND hWnd, int nItemMax ) ;


#ifdef UNICODE
#define ComboBox_AddString ComboBox_AddStringW
#define ComboBox_InsertString ComboBox_InsertStringW
#define ComboBox_SelectString ComboBox_SelectStringW
#define ComboBox_FindStringExact ComboBox_FindStringExactW
#else
#define ComboBox_AddString ComboBox_AddStringA
#define ComboBox_InsertString ComboBox_InsertStringA
#define ComboBox_SelectString ComboBox_SelectStringA
#define ComboBox_FindStringExact ComboBox_FindStringExactA
#endif


#define Dlg_ComboBox_AddStringA(hDlg,nId,szString)                   ComboBox_AddStringA(GetDlgItem(hDlg,nId),szString)
#define Dlg_ComboBox_AddStringW(hDlg,nId,szString)                   ComboBox_AddStringW(GetDlgItem(hDlg,nId),szString)
#define Dlg_ComboBox_InsertStringA(hDlg,nId,nIndex,szString)         ComboBox_InsertStringA(GetDlgItem(hDlg,nId),nIndex,szString)
#define Dlg_ComboBox_InsertStringW(hDlg,nId,nIndex,szString)         ComboBox_InsertStringW(GetDlgItem(hDlg,nId),nIndex,szString)
#define Dlg_ComboBox_GetCount(hDlg,nId)                              ComboBox_GetCount(GetDlgItem(hDlg,nId))
#define Dlg_ComboBox_ResetContent(hDlg,nId)                          ComboBox_ResetContent(GetDlgItem(hDlg,nId))
#define Dlg_ComboBox_GetCurSel(hDlg,nId)                             ComboBox_GetCurSel(GetDlgItem(hDlg,nId))
#define Dlg_ComboBox_SetCurSel(hDlg,nId,nIndex)                      ComboBox_SetCurSel(GetDlgItem(hDlg,nId),nIndex)
#define Dlg_ComboBox_SelectStringA(hDlg,nId,nIndexStart,szString)    ComboBox_SelectStringA(GetDlgItem(hDlg,nId),nIndexStart,szString)
#define Dlg_ComboBox_SelectStringW(hDlg,nId,nIndexStart,szString)    ComboBox_SelectStringW(GetDlgItem(hDlg,nId),nIndexStart,szString)
#define Dlg_ComboBox_FindStringExactA(hDlg,nId,nIndexStart,szString) ComboBox_FindStringExactA(GetDlgItem(hDlg,nId),nIndexStart,szString)
#define Dlg_ComboBox_FindStringExactW(hDlg,nId,nIndexStart,szString) ComboBox_FindStringExactW(GetDlgItem(hDlg,nId),nIndexStart,szString)
#define Dlg_ComboBox_GetItemHeight(hDlg,nId)                         ComboBox_GetItemHeight(GetDlgItem(hDlg,nId))
#define Dlg_ComboBox_SetEditSel(hDlg,nId,nStart,nEnd)                ComboBox_SetEditSel(GetDlgItem(hDlg,nId),nStart,nEnd)
#define Dlg_ComboBox_LimitText(hDlg,nId,nMax)                        ComboBox_LimitText(GetDlgItem(hDlg,nId),nMax)
#define Dlg_ComboBox_SetMaxHeight(hDlg,nId,nMax)                     ComboBox_SetMaxHeight(GetDlgItem(hDlg,nId),nMax)


#ifdef UNICODE
#define Dlg_ComboBox_AddString Dlg_ComboBox_AddStringW
#define Dlg_ComboBox_InsertString Dlg_ComboBox_InsertStringW
#define Dlg_ComboBox_SelectString Dlg_ComboBox_SelectStringW
#define Dlg_ComboBox_FindStringExact Dlg_ComboBox_FindStringExactW
#else
#define Dlg_ComboBox_AddString Dlg_ComboBox_AddStringA
#define Dlg_ComboBox_InsertString Dlg_ComboBox_InsertStringA
#define Dlg_ComboBox_SelectString Dlg_ComboBox_SelectStringA
#define Dlg_ComboBox_FindStringExact Dlg_ComboBox_FindStringExactA
#endif



////////////////////////////////////////
//     Xg{bNXRg[     //
////////////////////////////////////////



int ListBox_AddStringA ( HWND hWnd, const char *szString ) ;
int ListBox_AddStringW ( HWND hWnd, const wchar_t *szString ) ;
int ListBox_InsertStringA ( HWND hWnd, int nIndex, const char *szString ) ;
int ListBox_InsertStringW ( HWND hWnd, int nIndex, const wchar_t *szString ) ;
int ListBox_GetCount ( HWND hWnd ) ;
int ListBox_ResetContent ( HWND hWnd ) ;
int ListBox_GetCurSel ( HWND hWnd ) ;
int ListBox_SetCurSel ( HWND hWnd, int nIndex ) ;
int ListBox_GetTextA ( HWND hWnd, int nIndex, char *szString ) ;
int ListBox_GetTextW ( HWND hWnd, int nIndex, wchar_t *szString ) ;
int ListBox_GetTextLenA ( HWND hWnd, int nIndex ) ;
int ListBox_GetTextLenW ( HWND hWnd, int nIndex ) ;


#ifdef UNICODE
#define ListBox_AddString ListBox_AddStringW
#define ListBox_InsertString ListBox_InsertStringW
#define ListBox_GetText ListBox_GetTextW
#define ListBox_GetTextLen ListBox_GetTextLenW
#else
#define ListBox_AddString ListBox_AddStringA
#define ListBox_InsertString ListBox_InsertStringA
#define ListBox_GetText ListBox_GetTextA
#define ListBox_GetTextLen ListBox_GetTextLenA
#endif


#define Dlg_ListBox_AddStringA(hDlg,nId,szString)                    ListBox_AddStringA(GetDlgItem(hDlg,nId),szString)
#define Dlg_ListBox_AddStringW(hDlg,nId,szString)                    ListBox_AddStringW(GetDlgItem(hDlg,nId),szString)
#define Dlg_ListBox_InsertStringA(hDlg,nId,nIndex,szString)          ListBox_InsertStringA(GetDlgItem(hDlg,nId),nIndex,szString)
#define Dlg_ListBox_InsertStringW(hDlg,nId,nIndex,szString)          ListBox_InsertStringW(GetDlgItem(hDlg,nId),nIndex,szString)
#define Dlg_ListBox_ResetContent(hDlg,nId)                           ListBox_ResetContent(GetDlgItem(hDlg,nId))
#define Dlg_ListBox_GetCurSel(hDlg,nId)                              ListBox_GetCurSel(GetDlgItem(hDlg,nId))
#define Dlg_ListBox_SetCurSel(hDlg,nId,nIndex)                       ListBox_SetCurSel(GetDlgItem(hDlg,nId),nIndex)
#define Dlg_ListBox_GetTextA(hDlg,nId,nIndex,szString)               ListBox_GetTextA(GetDlgItem(hDlg,nId),nIndex,szString)
#define Dlg_ListBox_GetTextW(hDlg,nId,nIndex,szString)               ListBox_GetTextW(GetDlgItem(hDlg,nId),nIndex,szString)
#define Dlg_ListBox_GetTextLenA(hDlg,nId,nIndex)                     ListBox_GetTextLenA(GetDlgItem(hDlg,nId),nIndex)
#define Dlg_ListBox_GetTextLenW(hDlg,nId,nIndex)                     ListBox_GetTextLenW(GetDlgItem(hDlg,nId),nIndex)


#ifdef UNICODE
#define Dlg_ListBox_AddString Dlg_ListBox_AddStringW
#define Dlg_ListBox_InsertString Dlg_ListBox_InsertStringW
#define Dlg_ListBox_GetText Dlg_ListBox_GetTextW
#define Dlg_ListBox_GetTextLen Dlg_ListBox_GetTextLenW
#else
#define Dlg_ListBox_AddString Dlg_ListBox_AddStringA
#define Dlg_ListBox_InsertString Dlg_ListBox_InsertStringA
#define Dlg_ListBox_GetText Dlg_ListBox_GetTextA
#define Dlg_ListBox_GetTextLen Dlg_ListBox_GetTextLenA
#endif



////////////////////////////////////////
//       vOXRg[       //
////////////////////////////////////////



int ProgressCtrl_SetRange ( HWND hWnd, short nMin, short nMax ) ;
int ProgressCtrl_SetStep ( HWND hWnd, int nStep ) ;
int ProgressCtrl_SetPos ( HWND hWnd, int nPos ) ;
int ProgressCtrl_StepIt ( HWND hWnd ) ;


#define Dlg_ProgressCtrl_SetRange(hDlg,nId,nMin,nMax) ProgressCtrl_SetRange(GetDlgItem(hDlg,nId),nMin,nMax)
#define Dlg_ProgressCtrl_SetStep(hDlg,nId,nStep)      ProgressCtrl_SetStep(GetDlgItem(hDlg,nId),nStep)
#define Dlg_ProgressCtrl_SetPos(hDlg,nId,nPos)        ProgressCtrl_SetPos(GetDlgItem(hDlg,nId),nPos)
#define Dlg_ProgressCtrl_StepIt(hDlg,nId)             ProgressCtrl_StepIt(GetDlgItem(hDlg,nId))



////////////////////////////////////////
//             c[o[             //
////////////////////////////////////////



#if _WIN32_IE < 0x0400

#define TBIF_IMAGE              0x00000001
#define TBIF_TEXT               0x00000002
#define TBIF_STATE              0x00000004
#define TBIF_STYLE              0x00000008
#define TBIF_LPARAM             0x00000010
#define TBIF_COMMAND            0x00000020
#define TBIF_SIZE               0x00000040

typedef struct {
   UINT cbSize ;
   DWORD dwMask ;
   int idCommand ;
   int iImage ;
   BYTE fsState ;
   BYTE fsStyle ;
   WORD cx ;
   DWORD_PTR lParam ;
   LPSTR pszText ;
   int cchText ;
} TBBUTTONINFOA, *LPTBBUTTONINFOA ;

typedef struct {
   UINT cbSize ;
   DWORD dwMask ;
   int idCommand ;
   int iImage ;
   BYTE fsState ;
   BYTE fsStyle ;
   WORD cx ;
   DWORD_PTR lParam ;
   LPWSTR pszText ;
   int cchText ;
} TBBUTTONINFOW, *LPTBBUTTONINFOW ;

#ifdef UNICODE
#define TBBUTTONINFO TBBUTTONINFOW
#define LPTBBUTTONINFO LPTBBUTTONINFOW
#else
#define TBBUTTONINFO TBBUTTONINFOA
#define LPTBBUTTONINFO LPTBBUTTONINFOA
#endif

#endif


int ToolBar_ButtonCount ( HWND hWnd ) ;
int ToolBar_GetButton ( HWND hWnd, int nIndex, TBBUTTON *pButton ) ;
int ToolBar_GetButtonInfoA ( HWND hWnd, int nCommandId, TBBUTTONINFOA *pButtonInfo ) ;
int ToolBar_GetButtonInfoW ( HWND hWnd, int nCommandId, TBBUTTONINFOW *pButtonInfo ) ;


#ifdef UNICODE
#define ToolBar_GetButtonInfo ToolBar_GetButtonInfoW
#else
#define ToolBar_GetButtonInfo ToolBar_GetButtonInfoA
#endif



////////////////////////////////////////
//   bZ[W{bNXitj   //
////////////////////////////////////////



int __cdecl MessageBoxFormatA ( HWND hWnd, const char *szCaption, unsigned int uType, const char *format,... ) ;
int __cdecl MessageBoxFormatW ( HWND hWnd, const wchar_t *szCaption, unsigned int uType, const wchar_t *format,... ) ;


#ifdef UNICODE
#define MessageBoxFormat MessageBoxFormatW
#else
#define MessageBoxFormat MessageBoxFormatA
#endif



////////////////////////////////////////
//   EBhEʁitj   //
////////////////////////////////////////



int __cdecl Wm_SetTextFormatA ( HWND hWnd, const char *format,... ) ;
int __cdecl Wm_SetTextFormatW ( HWND hWnd, const wchar_t *format,... ) ;
int __cdecl Dlg_Wm_SetTextFormatA ( HWND hDlg, int nId, const char *format,... ) ;
int __cdecl Dlg_Wm_SetTextFormatW ( HWND hDlg, int nId, const wchar_t *format,... ) ;


#ifdef UNICODE
#define Wm_SetTextFormat Wm_SetTextFormatW
#define Dlg_Wm_SetTextFormat Dlg_Wm_SetTextFormatW
#else
#define Wm_SetTextFormat Wm_SetTextFormatA
#define Dlg_Wm_SetTextFormat Dlg_Wm_SetTextFormatA
#endif



////////////////////////////////////////
//     R{{bNXitj     //
////////////////////////////////////////



int __cdecl ComboBox_AddStringFormatA ( HWND hWnd, const char *format,... ) ;
int __cdecl ComboBox_AddStringFormatW ( HWND hWnd, const wchar_t *format,... ) ;
int __cdecl ComboBox_InsertStringFormatA ( HWND hWnd, int nIndex, const char *format,... ) ;
int __cdecl ComboBox_InsertStringFormatW ( HWND hWnd, int nIndex, const wchar_t *format,... ) ;
int __cdecl Dlg_ComboBox_AddStringFormatA ( HWND hDlg, int nId, const char *format,... ) ;
int __cdecl Dlg_ComboBox_AddStringFormatW ( HWND hDlg, int nId, const wchar_t *format,... ) ;
int __cdecl Dlg_ComboBox_InsertStringFormatA ( HWND hDlg, int nId, int nIndex, const char *format,... ) ;
int __cdecl Dlg_ComboBox_InsertStringFormatW ( HWND hDlg, int nId, int nIndex, const wchar_t *format,... ) ;


#ifdef UNICODE
#define ComboBox_AddStringFormat ComboBox_AddStringFormatW
#define ComboBox_InsertStringFormat ComboBox_InsertStringFormatW
#define Dlg_ComboBox_AddStringFormat Dlg_ComboBox_AddStringFormatW
#define Dlg_ComboBox_InsertStringFormat Dlg_ComboBox_InsertStringFormatW
#else
#define ComboBox_AddStringFormat ComboBox_AddStringFormatA
#define ComboBox_InsertStringFormat ComboBox_InsertStringFormatA
#define Dlg_ComboBox_AddStringFormat Dlg_ComboBox_AddStringFormatA
#define Dlg_ComboBox_InsertStringFormat Dlg_ComboBox_InsertStringFormatA
#endif



////////////////////////////////////////
//     Xg{bNXitj     //
////////////////////////////////////////



int __cdecl ListBox_AddStringFormatA ( HWND hWnd, const char *format,... ) ;
int __cdecl ListBox_AddStringFormatW ( HWND hWnd, const wchar_t *format,... ) ;
int __cdecl ListBox_InsertStringFormatA ( HWND hWnd, int nIndex, const char *format,... ) ;
int __cdecl ListBox_InsertStringFormatW ( HWND hWnd, int nIndex, const wchar_t *format,... ) ;
int __cdecl Dlg_ListBox_AddStringFormatA ( HWND hDlg, int nId, const char *format,... ) ;
int __cdecl Dlg_ListBox_AddStringFormatW ( HWND hDlg, int nId, const wchar_t *format,... ) ;
int __cdecl Dlg_ListBox_InsertStringFormatA ( HWND hDlg, int nId, int nIndex, const char *format,... ) ;
int __cdecl Dlg_ListBox_InsertStringFormatW ( HWND hDlg, int nId, int nIndex, const wchar_t *format,... ) ;


#ifdef UNICODE
#define ListBox_AddStringFormat ListBox_AddStringFormatW
#define ListBox_InsertStringFormat ListBox_InsertStringFormatW
#define Dlg_ListBox_AddStringFormat Dlg_ListBox_AddStringFormatW
#define Dlg_ListBox_InsertStringFormat Dlg_ListBox_InsertStringFormatW
#else
#define ListBox_AddStringFormat ListBox_AddStringFormatA
#define ListBox_InsertStringFormat ListBox_InsertStringFormatA
#define Dlg_ListBox_AddStringFormat Dlg_ListBox_AddStringFormatA
#define Dlg_ListBox_InsertStringFormat Dlg_ListBox_InsertStringFormatA
#endif



WNDPROC SetWindowProcA ( HWND hWnd, WNDPROC WndProc ) ;
WNDPROC SetWindowProcW ( HWND hWnd, WNDPROC WndProc ) ;
WNDPROC GetWindowProcA ( HWND hWnd ) ;
WNDPROC GetWindowProcW ( HWND hWnd ) ;

int SetDlgMsgResult ( HWND hWnd, LRESULT lResult ) ;


#ifdef UNICODE
#define SetWindowProc SetWindowProcW
#define GetWindowProc GetWindowProcW
#else
#define SetWindowProc SetWindowProcA
#define GetWindowProc GetWindowProcA
#endif



#ifdef __cplusplus
}
#endif

#endif


