// uniblock.cpp

#include <stdlib.h>
#include "msc.h"
#include "uniblock.h"



typedef struct {
   int nStart ;
   int nEnd ;
   int nIndex ;
} UNICODE_BLOCK ;



static int __cdecl UnicodeBlockCmp ( const void *pKey, const void *pArray ) {
   if ( ( * (int*) pKey ) < ( ( (UNICODE_BLOCK*) pArray )->nStart ) ) return -1 ;
   if ( ( * (int*) pKey ) > ( ( (UNICODE_BLOCK*) pArray )->nEnd ) ) return 1 ;
   return 0 ;
}



// UNICODE BLOCK ͈̔͂ƎʔԍƎ擾
// R[hEEʔԍ̂ǂ炩ł擾ł
// 环ʔԍAs -1 Ԃ
int GetUnicodeBlock ( int cUnicode, int nOrdinal, int nIndex, int *pStart, int *pEnd, int *pOrdinal ) {

   static const UNICODE_BLOCK UnicodeBlock [] = {
      {    0x0000,     0x007F,     0   },    // Basic Latin
      {    0x0080,     0x00FF,     1   },    // Latin-1 Supplement
      {    0x0100,     0x017F,     2   },    // Latin Extended-A
      {    0x0180,     0x024F,     3   },    // Latin Extended-B
      {    0x0250,     0x02AF,     4   },    // IPA Extensions
      {    0x02B0,     0x02FF,     5   },    // Spacing Modifier Letters
      {    0x0300,     0x036F,     6   },    // Combining Diacritical Marks
      {    0x0370,     0x03FF,     7   },    // Greek and Coptic
      {    0x0400,     0x04FF,     8   },    // Cyrillic
      {    0x0500,     0x052F,     9   },    // Cyrillic Supplement
      {    0x0530,     0x058F,    10   },    // Armenian
      {    0x0590,     0x05FF,    11   },    // Hebrew
      {    0x0600,     0x06FF,    12   },    // Arabic
      {    0x0700,     0x074F,    13   },    // Syriac
      {    0x0750,     0x077F,   122   },    // Arabic Supplement
      {    0x0780,     0x07BF,    14   },    // Thaana
      {    0x07C0,     0x07FF,   142   },    // NKo
      {    0x0800,     0x083F,   168   },    // Samaritan
      {    0x0900,     0x097F,    15   },    // Devanagari
      {    0x0980,     0x09FF,    16   },    // Bengali
      {    0x0A00,     0x0A7F,    17   },    // Gurmukhi
      {    0x0A80,     0x0AFF,    18   },    // Gujarati
      {    0x0B00,     0x0B7F,    19   },    // Oriya
      {    0x0B80,     0x0BFF,    20   },    // Tamil
      {    0x0C00,     0x0C7F,    21   },    // Telugu
      {    0x0C80,     0x0CFF,    22   },    // Kannada
      {    0x0D00,     0x0D7F,    23   },    // Malayalam
      {    0x0D80,     0x0DFF,    24   },    // Sinhala
      {    0x0E00,     0x0E7F,    25   },    // Thai
      {    0x0E80,     0x0EFF,    26   },    // Lao
      {    0x0F00,     0x0FFF,    27   },    // Tibetan
      {    0x1000,     0x109F,    28   },    // Myanmar
      {    0x10A0,     0x10FF,    29   },    // Georgian
      {    0x1100,     0x11FF,    30   },    // Hangul Jamo
      {    0x1200,     0x137F,    31   },    // Ethiopic
      {    0x1380,     0x139F,   123   },    // Ethiopic Supplement
      {    0x13A0,     0x13FF,    32   },    // Cherokee
      {    0x1400,     0x167F,    33   },    // Unified Canadian Aboriginal Syllabics
      {    0x1680,     0x169F,    34   },    // Ogham
      {    0x16A0,     0x16FF,    35   },    // Runic
      {    0x1700,     0x171F,    36   },    // Tagalog
      {    0x1720,     0x173F,    37   },    // Hanunoo
      {    0x1740,     0x175F,    38   },    // Buhid
      {    0x1760,     0x177F,    39   },    // Tagbanwa
      {    0x1780,     0x17FF,    40   },    // Khmer
      {    0x1800,     0x18AF,    41   },    // Mongolian
      {    0x18B0,     0x18FF,   169   },    // Unified Canadian Aboriginal Syllabics Extended
      {    0x1900,     0x194F,    42   },    // Limbu
      {    0x1950,     0x197F,    43   },    // Tai Le
      {    0x1980,     0x19DF,   124   },    // New Tai Lue
      {    0x19E0,     0x19FF,    44   },    // Khmer Symbols
      {    0x1A00,     0x1A1F,   125   },    // Buginese
      {    0x1A20,     0x1AAF,   170   },    // Tai Tham
      {    0x1B00,     0x1B7F,   143   },    // Balinese
      {    0x1B80,     0x1BBF,   151   },    // Sundanese
      {    0x1C00,     0x1C4F,   152   },    // Lepcha
      {    0x1C50,     0x1C7F,   153   },    // Ol Chiki
      {    0x1CD0,     0x1CFF,   171   },    // Vedic Extensions
      {    0x1D00,     0x1D7F,    45   },    // Phonetic Extensions
      {    0x1D80,     0x1DBF,   126   },    // Phonetic Extensions Supplement
      {    0x1DC0,     0x1DFF,   127   },    // Combining Diacritical Marks Supplement
      {    0x1E00,     0x1EFF,    46   },    // Latin Extended Additional
      {    0x1F00,     0x1FFF,    47   },    // Greek Extended
      {    0x2000,     0x206F,    48   },    // General Punctuation
      {    0x2070,     0x209F,    49   },    // Superscripts and Subscripts
      {    0x20A0,     0x20CF,    50   },    // Currency Symbols
      {    0x20D0,     0x20FF,    51   },    // Combining Diacritical Marks for Symbols
      {    0x2100,     0x214F,    52   },    // Letterlike Symbols
      {    0x2150,     0x218F,    53   },    // Number Forms
      {    0x2190,     0x21FF,    54   },    // Arrows
      {    0x2200,     0x22FF,    55   },    // Mathematical Operators
      {    0x2300,     0x23FF,    56   },    // Miscellaneous Technical
      {    0x2400,     0x243F,    57   },    // Control Pictures
      {    0x2440,     0x245F,    58   },    // Optical Character Recognition
      {    0x2460,     0x24FF,    59   },    // Enclosed Alphanumerics
      {    0x2500,     0x257F,    60   },    // Box Drawing
      {    0x2580,     0x259F,    61   },    // Block Elements
      {    0x25A0,     0x25FF,    62   },    // Geometric Shapes
      {    0x2600,     0x26FF,    63   },    // Miscellaneous Symbols
      {    0x2700,     0x27BF,    64   },    // Dingbats
      {    0x27C0,     0x27EF,    65   },    // Miscellaneous Mathematical Symbols-A
      {    0x27F0,     0x27FF,    66   },    // Supplemental Arrows-A
      {    0x2800,     0x28FF,    67   },    // Braille Patterns
      {    0x2900,     0x297F,    68   },    // Supplemental Arrows-B
      {    0x2980,     0x29FF,    69   },    // Miscellaneous Mathematical Symbols-B
      {    0x2A00,     0x2AFF,    70   },    // Supplemental Mathematical Operators
      {    0x2B00,     0x2BFF,    71   },    // Miscellaneous Symbols and Arrows
      {    0x2C00,     0x2C5F,   128   },    // Glagolitic
      {    0x2C60,     0x2C7F,   144   },    // Latin Extended-C
      {    0x2C80,     0x2CFF,   129   },    // Coptic
      {    0x2D00,     0x2D2F,   130   },    // Georgian Supplement
      {    0x2D30,     0x2D7F,   131   },    // Tifinagh
      {    0x2D80,     0x2DDF,   132   },    // Ethiopic Extended
      {    0x2DE0,     0x2DFF,   154   },    // Cyrillic Extended-A
      {    0x2E00,     0x2E7F,   133   },    // Supplemental Punctuation
      {    0x2E80,     0x2EFF,    72   },    // CJK Radicals Supplement
      {    0x2F00,     0x2FDF,    73   },    // Kangxi Radicals
      {    0x2FF0,     0x2FFF,    74   },    // Ideographic Description Characters
      {    0x3000,     0x303F,    75   },    // CJK Symbols and Punctuation
      {    0x3040,     0x309F,    76   },    // Hiragana
      {    0x30A0,     0x30FF,    77   },    // Katakana
      {    0x3100,     0x312F,    78   },    // Bopomofo
      {    0x3130,     0x318F,    79   },    // Hangul Compatibility Jamo
      {    0x3190,     0x319F,    80   },    // Kanbun
      {    0x31A0,     0x31BF,    81   },    // Bopomofo Extended
      {    0x31C0,     0x31EF,   134   },    // CJK Strokes
      {    0x31F0,     0x31FF,    82   },    // Katakana Phonetic Extensions
      {    0x3200,     0x32FF,    83   },    // Enclosed CJK Letters and Months
      {    0x3300,     0x33FF,    84   },    // CJK Compatibility
      {    0x3400,     0x4DBF,    85   },    // CJK Unified Ideographs Extension A
      {    0x4DC0,     0x4DFF,    86   },    // Yijing Hexagram Symbols
      {    0x4E00,     0x9FFF,    87   },    // CJK Unified Ideographs
      {    0xA000,     0xA48F,    88   },    // Yi Syllables
      {    0xA490,     0xA4CF,    89   },    // Yi Radicals
      {    0xA4D0,     0xA4FF,   172   },    // Lisu
      {    0xA500,     0xA63F,   155   },    // Vai
      {    0xA640,     0xA69F,   156   },    // Cyrillic Extended-B
      {    0xA6A0,     0xA6FF,   173   },    // Bamum
      {    0xA700,     0xA71F,   135   },    // Modifier Tone Letters
      {    0xA720,     0xA7FF,   145   },    // Latin Extended-D
      {    0xA800,     0xA82F,   136   },    // Syloti Nagri
      {    0xA830,     0xA83F,   174   },    // Common Indic Number Forms
      {    0xA840,     0xA87F,   146   },    // Phags-pa
      {    0xA880,     0xA8DF,   157   },    // Saurashtra
      {    0xA8E0,     0xA8FF,   175   },    // Devanagari Extended
      {    0xA900,     0xA92F,   158   },    // Kayah Li
      {    0xA930,     0xA95F,   159   },    // Rejang
      {    0xA960,     0xA97F,   176   },    // Hangul Jamo Extended-A
      {    0xA980,     0xA9DF,   177   },    // Javanese
      {    0xAA00,     0xAA5F,   160   },    // Cham
      {    0xAA60,     0xAA7F,   178   },    // Myanmar Extended-A
      {    0xAA80,     0xAADF,   179   },    // Tai Viet
      {    0xABC0,     0xABFF,   180   },    // Meetei Mayek
      {    0xAC00,     0xD7AF,    90   },    // Hangul Syllables
      {    0xD7B0,     0xD7FF,   181   },    // Hangul Jamo Extended-B
      {    0xE000,     0xF8FF,    91   },    // Private Use Area
      {    0xF900,     0xFAFF,    92   },    // CJK Compatibility Ideographs
      {    0xFB00,     0xFB4F,    93   },    // Alphabetic Presentation Forms
      {    0xFB50,     0xFDFF,    94   },    // Arabic Presentation Forms-A
      {    0xFE00,     0xFE0F,    95   },    // Variation Selectors
      {    0xFE10,     0xFE1F,   137   },    // Vertical Forms
      {    0xFE20,     0xFE2F,    96   },    // Combining Half Marks
      {    0xFE30,     0xFE4F,    97   },    // CJK Compatibility Forms
      {    0xFE50,     0xFE6F,    98   },    // Small Form Variants
      {    0xFE70,     0xFEFF,    99   },    // Arabic Presentation Forms-B
      {    0xFF00,     0xFFEF,   100   },    // Halfwidth and Fullwidth Forms
      {    0xFFF0,     0xFFFF,   101   },    // Specials
      {   0x10000,    0x1007F,   102   },    // Linear B Syllabary
      {   0x10080,    0x100FF,   103   },    // Linear B Ideograms
      {   0x10100,    0x1013F,   104   },    // Aegean Numbers
      {   0x10140,    0x1018F,   138   },    // Ancient Greek Numbers
      {   0x10190,    0x101CF,   161   },    // Ancient Symbols
      {   0x101D0,    0x101FF,   162   },    // Phaistos Disc
      {   0x10280,    0x1029F,   163   },    // Lycian
      {   0x102A0,    0x102DF,   164   },    // Carian
      {   0x10300,    0x1032F,   105   },    // Old Italic
      {   0x10330,    0x1034F,   106   },    // Gothic
      {   0x10380,    0x1039F,   107   },    // Ugaritic
      {   0x103A0,    0x103DF,   139   },    // Old Persian
      {   0x10400,    0x1044F,   108   },    // Deseret
      {   0x10450,    0x1047F,   109   },    // Shavian
      {   0x10480,    0x104AF,   110   },    // Osmanya
      {   0x10800,    0x1083F,   111   },    // Cypriot Syllabary
      {   0x10840,    0x1085F,   182   },    // Imperial Aramaic
      {   0x10900,    0x1091F,   147   },    // Phoenician
      {   0x10920,    0x1093F,   165   },    // Lydian
      {   0x10A00,    0x10A5F,   140   },    // Kharoshthi
      {   0x10A60,    0x10A7F,   183   },    // Old South Arabian
      {   0x10B00,    0x10B3F,   184   },    // Avestan
      {   0x10B40,    0x10B5F,   185   },    // Inscriptional Parthian
      {   0x10B60,    0x10B7F,   186   },    // Inscriptional Pahlavi
      {   0x10C00,    0x10C4F,   187   },    // Old Turkic
      {   0x10E60,    0x10E7F,   188   },    // Rumi Numeral Symbols
      {   0x11080,    0x110CF,   189   },    // Kaithi
      {   0x12000,    0x123FF,   148   },    // Cuneiform
      {   0x12400,    0x1247F,   149   },    // Cuneiform Numbers and Punctuation
      {   0x13000,    0x1342F,   190   },    // Egyptian Hieroglyphs
      {   0x1D000,    0x1D0FF,   112   },    // Byzantine Musical Symbols
      {   0x1D100,    0x1D1FF,   113   },    // Musical Symbols
      {   0x1D200,    0x1D24F,   141   },    // Ancient Greek Musical Notation
      {   0x1D300,    0x1D35F,   114   },    // Tai Xuan Jing Symbols
      {   0x1D360,    0x1D37F,   150   },    // Counting Rod Numerals
      {   0x1D400,    0x1D7FF,   115   },    // Mathematical Alphanumeric Symbols
      {   0x1F000,    0x1F02F,   166   },    // Mahjong Tiles
      {   0x1F030,    0x1F09F,   167   },    // Domino Tiles
      {   0x1F100,    0x1F1FF,   191   },    // Enclosed Alphanumeric Supplement
      {   0x1F200,    0x1F2FF,   192   },    // Enclosed Ideographic Supplement
      {   0x20000,    0x2A6DF,   116   },    // CJK Unified Ideographs Extension B
      {   0x2A700,    0x2B73F,   193   },    // CJK Unified Ideographs Extension C
      {   0x2F800,    0x2FA1F,   117   },    // CJK Compatibility Ideographs Supplement
      {   0xE0000,    0xE007F,   118   },    // Tags
      {   0xE0100,    0xE01EF,   119   },    // Variation Selectors Supplement
      {   0xF0000,    0xFFFFF,   120   },    // Supplementary Private Use Area-A
      {  0x100000,   0x10FFFF,   121   },    // Supplementary Private Use Area-B
   } ;


   static const unsigned char IndexToOrdinal [] = {
       0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 15, 18,
       19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34,
       36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 47, 48, 50, 58, 61, 62,
       63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78,
       79, 80, 81, 82, 83, 84, 85, 86, 95, 96, 97, 98, 99, 100, 101, 102,
       103, 104, 106, 107, 108, 109, 110, 111, 112, 113, 133, 135, 136, 137, 138, 139,
       141, 142, 143, 144, 145, 146, 147, 148, 149, 155, 156, 157, 159, 160, 161, 162,
       177, 178, 180, 182, 187, 189, 190, 191, 192, 193, 14, 35, 49, 51, 59, 60,
       87, 89, 90, 91, 92, 94, 105, 118, 120, 140, 150, 158, 166, 179, 16, 53,
       88, 119, 122, 164, 174, 175, 181, 54, 55, 56, 93, 115, 116, 123, 125, 126,
       129, 151, 152, 153, 154, 165, 183, 184, 17, 46, 52, 57, 114, 117, 121, 124,
       127, 128, 130, 131, 132, 134, 163, 167, 168, 169, 170, 171, 172, 173, 176, 185,
       186, 188,
   } ;


   const size_t UnicodeBlockArraySize = NELEMOF ( UnicodeBlock ) ;


   const UNICODE_BLOCK *pUnicodeBlock ;
   if ( cUnicode ) {
      pUnicodeBlock = (const UNICODE_BLOCK *) bsearch ( & cUnicode, UnicodeBlock, UnicodeBlockArraySize, sizeof(UNICODE_BLOCK), UnicodeBlockCmp ) ;
   }
   else if ( nOrdinal ) {
      if ( (unsigned) nOrdinal < UnicodeBlockArraySize ) pUnicodeBlock = UnicodeBlock + nOrdinal ;
      else                                               pUnicodeBlock = NULL ;
   }
   else {
      if ( (unsigned) nIndex < UnicodeBlockArraySize ) pUnicodeBlock = UnicodeBlock + IndexToOrdinal [ nIndex ] ;
      else                                             pUnicodeBlock = NULL ;
   }

   if ( pUnicodeBlock ) {
      if ( pStart ) *pStart = pUnicodeBlock->nStart ;
      if ( pEnd ) *pEnd = pUnicodeBlock->nEnd ;
      if ( pOrdinal ) *pOrdinal = (int) ( pUnicodeBlock - UnicodeBlock ) ;
      return pUnicodeBlock->nIndex ;
   }

   return -1 ;
}



// UNICODE BLOCK ̖O擾iANSIŁj
// 當As NULL Ԃ
const char *GetUnicodeBlockNameA ( int nOrdinal ) {

   static const char *const UnicodeBlockName [] = {
      "Basic Latin",
      "Latin-1 Supplement",
      "Latin Extended-A",
      "Latin Extended-B",
      "IPA Extensions",
      "Spacing Modifier Letters",
      "Combining Diacritical Marks",
      "Greek and Coptic",
      "Cyrillic",
      "Cyrillic Supplement",
      "Armenian",
      "Hebrew",
      "Arabic",
      "Syriac",
      "Arabic Supplement",
      "Thaana",
      "NKo",
      "Samaritan",
      "Devanagari",
      "Bengali",
      "Gurmukhi",
      "Gujarati",
      "Oriya",
      "Tamil",
      "Telugu",
      "Kannada",
      "Malayalam",
      "Sinhala",
      "Thai",
      "Lao",
      "Tibetan",
      "Myanmar",
      "Georgian",
      "Hangul Jamo",
      "Ethiopic",
      "Ethiopic Supplement",
      "Cherokee",
      "Unified Canadian Aboriginal Syllabics",
      "Ogham",
      "Runic",
      "Tagalog",
      "Hanunoo",
      "Buhid",
      "Tagbanwa",
      "Khmer",
      "Mongolian",
      "Unified Canadian Aboriginal Syllabics Extended",
      "Limbu",
      "Tai Le",
      "New Tai Lue",
      "Khmer Symbols",
      "Buginese",
      "Tai Tham",
      "Balinese",
      "Sundanese",
      "Lepcha",
      "Ol Chiki",
      "Vedic Extensions",
      "Phonetic Extensions",
      "Phonetic Extensions Supplement",
      "Combining Diacritical Marks Supplement",
      "Latin Extended Additional",
      "Greek Extended",
      "General Punctuation",
      "Superscripts and Subscripts",
      "Currency Symbols",
      "Combining Diacritical Marks for Symbols",
      "Letterlike Symbols",
      "Number Forms",
      "Arrows",
      "Mathematical Operators",
      "Miscellaneous Technical",
      "Control Pictures",
      "Optical Character Recognition",
      "Enclosed Alphanumerics",
      "Box Drawing",
      "Block Elements",
      "Geometric Shapes",
      "Miscellaneous Symbols",
      "Dingbats",
      "Miscellaneous Mathematical Symbols-A",
      "Supplemental Arrows-A",
      "Braille Patterns",
      "Supplemental Arrows-B",
      "Miscellaneous Mathematical Symbols-B",
      "Supplemental Mathematical Operators",
      "Miscellaneous Symbols and Arrows",
      "Glagolitic",
      "Latin Extended-C",
      "Coptic",
      "Georgian Supplement",
      "Tifinagh",
      "Ethiopic Extended",
      "Cyrillic Extended-A",
      "Supplemental Punctuation",
      "CJK Radicals Supplement",
      "Kangxi Radicals",
      "Ideographic Description Characters",
      "CJK Symbols and Punctuation",
      "Hiragana",
      "Katakana",
      "Bopomofo",
      "Hangul Compatibility Jamo",
      "Kanbun",
      "Bopomofo Extended",
      "CJK Strokes",
      "Katakana Phonetic Extensions",
      "Enclosed CJK Letters and Months",
      "CJK Compatibility",
      "CJK Unified Ideographs Extension A",
      "Yijing Hexagram Symbols",
      "CJK Unified Ideographs",
      "Yi Syllables",
      "Yi Radicals",
      "Lisu",
      "Vai",
      "Cyrillic Extended-B",
      "Bamum",
      "Modifier Tone Letters",
      "Latin Extended-D",
      "Syloti Nagri",
      "Common Indic Number Forms",
      "Phags-pa",
      "Saurashtra",
      "Devanagari Extended",
      "Kayah Li",
      "Rejang",
      "Hangul Jamo Extended-A",
      "Javanese",
      "Cham",
      "Myanmar Extended-A",
      "Tai Viet",
      "Meetei Mayek",
      "Hangul Syllables",
      "Hangul Jamo Extended-B",
      "Private Use Area",
      "CJK Compatibility Ideographs",
      "Alphabetic Presentation Forms",
      "Arabic Presentation Forms-A",
      "Variation Selectors",
      "Vertical Forms",
      "Combining Half Marks",
      "CJK Compatibility Forms",
      "Small Form Variants",
      "Arabic Presentation Forms-B",
      "Halfwidth and Fullwidth Forms",
      "Specials",
      "Linear B Syllabary",
      "Linear B Ideograms",
      "Aegean Numbers",
      "Ancient Greek Numbers",
      "Ancient Symbols",
      "Phaistos Disc",
      "Lycian",
      "Carian",
      "Old Italic",
      "Gothic",
      "Ugaritic",
      "Old Persian",
      "Deseret",
      "Shavian",
      "Osmanya",
      "Cypriot Syllabary",
      "Imperial Aramaic",
      "Phoenician",
      "Lydian",
      "Kharoshthi",
      "Old South Arabian",
      "Avestan",
      "Inscriptional Parthian",
      "Inscriptional Pahlavi",
      "Old Turkic",
      "Rumi Numeral Symbols",
      "Kaithi",
      "Cuneiform",
      "Cuneiform Numbers and Punctuation",
      "Egyptian Hieroglyphs",
      "Byzantine Musical Symbols",
      "Musical Symbols",
      "Ancient Greek Musical Notation",
      "Tai Xuan Jing Symbols",
      "Counting Rod Numerals",
      "Mathematical Alphanumeric Symbols",
      "Mahjong Tiles",
      "Domino Tiles",
      "Enclosed Alphanumeric Supplement",
      "Enclosed Ideographic Supplement",
      "CJK Unified Ideographs Extension B",
      "CJK Unified Ideographs Extension C",
      "CJK Compatibility Ideographs Supplement",
      "Tags",
      "Variation Selectors Supplement",
      "Supplementary Private Use Area-A",
      "Supplementary Private Use Area-B",
   } ;

   const size_t UnicodeBlockNameArraySize = NELEMOF ( UnicodeBlockName ) ;

   if ( (unsigned) nOrdinal < UnicodeBlockNameArraySize ) return UnicodeBlockName [ nOrdinal ] ;

   return NULL ;
}



// UNICODE BLOCK ̖O擾iUNICODEŁj
// 當As NULL Ԃ
const wchar_t *GetUnicodeBlockNameW ( int nOrdinal ) {

   static const wchar_t *const UnicodeBlockName [] = {
      L"Basic Latin",
      L"Latin-1 Supplement",
      L"Latin Extended-A",
      L"Latin Extended-B",
      L"IPA Extensions",
      L"Spacing Modifier Letters",
      L"Combining Diacritical Marks",
      L"Greek and Coptic",
      L"Cyrillic",
      L"Cyrillic Supplement",
      L"Armenian",
      L"Hebrew",
      L"Arabic",
      L"Syriac",
      L"Arabic Supplement",
      L"Thaana",
      L"NKo",
      L"Samaritan",
      L"Devanagari",
      L"Bengali",
      L"Gurmukhi",
      L"Gujarati",
      L"Oriya",
      L"Tamil",
      L"Telugu",
      L"Kannada",
      L"Malayalam",
      L"Sinhala",
      L"Thai",
      L"Lao",
      L"Tibetan",
      L"Myanmar",
      L"Georgian",
      L"Hangul Jamo",
      L"Ethiopic",
      L"Ethiopic Supplement",
      L"Cherokee",
      L"Unified Canadian Aboriginal Syllabics",
      L"Ogham",
      L"Runic",
      L"Tagalog",
      L"Hanunoo",
      L"Buhid",
      L"Tagbanwa",
      L"Khmer",
      L"Mongolian",
      L"Unified Canadian Aboriginal Syllabics Extended",
      L"Limbu",
      L"Tai Le",
      L"New Tai Lue",
      L"Khmer Symbols",
      L"Buginese",
      L"Tai Tham",
      L"Balinese",
      L"Sundanese",
      L"Lepcha",
      L"Ol Chiki",
      L"Vedic Extensions",
      L"Phonetic Extensions",
      L"Phonetic Extensions Supplement",
      L"Combining Diacritical Marks Supplement",
      L"Latin Extended Additional",
      L"Greek Extended",
      L"General Punctuation",
      L"Superscripts and Subscripts",
      L"Currency Symbols",
      L"Combining Diacritical Marks for Symbols",
      L"Letterlike Symbols",
      L"Number Forms",
      L"Arrows",
      L"Mathematical Operators",
      L"Miscellaneous Technical",
      L"Control Pictures",
      L"Optical Character Recognition",
      L"Enclosed Alphanumerics",
      L"Box Drawing",
      L"Block Elements",
      L"Geometric Shapes",
      L"Miscellaneous Symbols",
      L"Dingbats",
      L"Miscellaneous Mathematical Symbols-A",
      L"Supplemental Arrows-A",
      L"Braille Patterns",
      L"Supplemental Arrows-B",
      L"Miscellaneous Mathematical Symbols-B",
      L"Supplemental Mathematical Operators",
      L"Miscellaneous Symbols and Arrows",
      L"Glagolitic",
      L"Latin Extended-C",
      L"Coptic",
      L"Georgian Supplement",
      L"Tifinagh",
      L"Ethiopic Extended",
      L"Cyrillic Extended-A",
      L"Supplemental Punctuation",
      L"CJK Radicals Supplement",
      L"Kangxi Radicals",
      L"Ideographic Description Characters",
      L"CJK Symbols and Punctuation",
      L"Hiragana",
      L"Katakana",
      L"Bopomofo",
      L"Hangul Compatibility Jamo",
      L"Kanbun",
      L"Bopomofo Extended",
      L"CJK Strokes",
      L"Katakana Phonetic Extensions",
      L"Enclosed CJK Letters and Months",
      L"CJK Compatibility",
      L"CJK Unified Ideographs Extension A",
      L"Yijing Hexagram Symbols",
      L"CJK Unified Ideographs",
      L"Yi Syllables",
      L"Yi Radicals",
      L"Lisu",
      L"Vai",
      L"Cyrillic Extended-B",
      L"Bamum",
      L"Modifier Tone Letters",
      L"Latin Extended-D",
      L"Syloti Nagri",
      L"Common Indic Number Forms",
      L"Phags-pa",
      L"Saurashtra",
      L"Devanagari Extended",
      L"Kayah Li",
      L"Rejang",
      L"Hangul Jamo Extended-A",
      L"Javanese",
      L"Cham",
      L"Myanmar Extended-A",
      L"Tai Viet",
      L"Meetei Mayek",
      L"Hangul Syllables",
      L"Hangul Jamo Extended-B",
      L"Private Use Area",
      L"CJK Compatibility Ideographs",
      L"Alphabetic Presentation Forms",
      L"Arabic Presentation Forms-A",
      L"Variation Selectors",
      L"Vertical Forms",
      L"Combining Half Marks",
      L"CJK Compatibility Forms",
      L"Small Form Variants",
      L"Arabic Presentation Forms-B",
      L"Halfwidth and Fullwidth Forms",
      L"Specials",
      L"Linear B Syllabary",
      L"Linear B Ideograms",
      L"Aegean Numbers",
      L"Ancient Greek Numbers",
      L"Ancient Symbols",
      L"Phaistos Disc",
      L"Lycian",
      L"Carian",
      L"Old Italic",
      L"Gothic",
      L"Ugaritic",
      L"Old Persian",
      L"Deseret",
      L"Shavian",
      L"Osmanya",
      L"Cypriot Syllabary",
      L"Imperial Aramaic",
      L"Phoenician",
      L"Lydian",
      L"Kharoshthi",
      L"Old South Arabian",
      L"Avestan",
      L"Inscriptional Parthian",
      L"Inscriptional Pahlavi",
      L"Old Turkic",
      L"Rumi Numeral Symbols",
      L"Kaithi",
      L"Cuneiform",
      L"Cuneiform Numbers and Punctuation",
      L"Egyptian Hieroglyphs",
      L"Byzantine Musical Symbols",
      L"Musical Symbols",
      L"Ancient Greek Musical Notation",
      L"Tai Xuan Jing Symbols",
      L"Counting Rod Numerals",
      L"Mathematical Alphanumeric Symbols",
      L"Mahjong Tiles",
      L"Domino Tiles",
      L"Enclosed Alphanumeric Supplement",
      L"Enclosed Ideographic Supplement",
      L"CJK Unified Ideographs Extension B",
      L"CJK Unified Ideographs Extension C",
      L"CJK Compatibility Ideographs Supplement",
      L"Tags",
      L"Variation Selectors Supplement",
      L"Supplementary Private Use Area-A",
      L"Supplementary Private Use Area-B",
   } ;

   const size_t UnicodeBlockNameArraySize = NELEMOF ( UnicodeBlockName ) ;

   if ( (unsigned) nOrdinal < UnicodeBlockNameArraySize ) return UnicodeBlockName [ nOrdinal ] ;

   return NULL ;
}



