// sbctbl.cpp

#include <windows.h>
#include "msc.h"
#include "codepage.h"
#include "res.h"
#include "winmain.h"

#include "sbctbl.h"
#include "sbc2uni.h"



// Gg[|Cg
int WINAPI DllMain ( HINSTANCE hInst, unsigned long dwReason, void *pReserved ) {

   if ( dwReason == DLL_PROCESS_ATTACH ) {
      // \[X̃CX^X
      SetResourceInstance ( hInst ) ;
   }

   return TRUE ;
}



int WINAPI SingleByteToUnicode ( int C, int nCodePage ) {

   const unsigned short *pTable ;
   const unsigned short *pTableG0 ;

   pTable = GetSingleByteTable ( nCodePage, & pTableG0 ) ;

   if ( (unsigned) C < 0x80 ) {
      if ( pTableG0 )    return pTableG0 [ C ] ;
      else if ( pTable ) return C ;
      else               return 0 ;
   }

   if ( (unsigned) C < 0x100 ) {
      if ( pTable ) return pTable [ C - 0x80 ] ;
      else          return 0 ;
   }

   return 0 ;
}



int WINAPI UnicodeToSingleByte ( int cUnicode, int nCodePage ) {

   const unsigned short *pBitTable = Uni2sbcBitTable ( cUnicode >> 12 ) ;
   if ( ! pBitTable || ! GetShortArrayBit ( pBitTable, cUnicode & 0xFFF ) ) return 0 ;

   const unsigned short *pTable ;
   const unsigned short *pTableG0 ;

   pTable = GetSingleByteNoVariantTable ( nCodePage, & pTableG0 ) ;

   if ( pTableG0 ) {
      for ( int C = 0x7F ; C >= 0 ; C -- ) {
         if ( pTableG0 [ C ] == cUnicode ) return C ;
      }
   }

   if ( pTable ) {
      if ( ! pTableG0 && (unsigned) cUnicode < 0x80 ) return cUnicode ;
      for ( int C = 0xFF ; C >= 0x80 ; C -- ) {
         if ( pTable [ C - 0x80 ] == cUnicode ) return C ;
      }
   }

   return 0 ;
}



int WINAPI IsSbcValidCodePage ( int nCodePage ) {

   int nResult ;
   const unsigned short *Dummy ;

   if ( GetSingleByteTable ( nCodePage, & Dummy ) ) nResult = 1 ;
   else                                             nResult = 0 ;

   return nResult ;
}



int WINAPI GetDllVersion ( void ) {

   FILEVERSION FileVersion ;
   if ( GetFileVersion ( & FileVersion ) ) return 0 ;

   return TranslateVersionInfo ( & FileVersion ) ;
}



